/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"
/* // pour tester les opcodes
main()
{
 R[1]=5;
 printf("%d\n",R[1]);
 ADDI(0xFFFFFF00|140,1);
 printf("%d\n",R[1]);
}
*/
/*INSTRUCTIONS OPCODES*/

  void ADD(long m, long n) /* ADD Rm,Rn */
  {
      R[n]+=R[m];
      PC+=2;
  }
/*
 OPTIMISE PARAMETRE 1 EXTEND PRECALCULE
*/
  void ADDI(long i, long n)  // ADD #imm,Rn
  {
      R[n]+=i;
      PC+=2;
  }

/*
Example

 ADD  R0,R1       ;Before execution R0 = H'7FFFFFFF, R1 = H'00000001
                  ;After execution R1 = H'80000000
 ADD  #H'01,R2    ;Before execution  R2 = H'00000000
                  ;After execution  R2 = H'00000001
 ADD  #H'FE,R3    ;Before execution  R3 = H'00000001
                  ;After execution  R3 = H'FFFFFFFF
*/


  void ADDC(long m, long n)    /* ADDC Rm,Rn */
  {
      unsigned long tmp0,tmp1;
      tmp1=R[n]+R[m];
      tmp0=R[n];
      R[n]=tmp1+T;
      if (tmp0>tmp1) T=1;
      else T=0;
      if (tmp1>R[n]) T=1;
      PC+=2;
  }

/*
Example

  CLRT                         ;R0:R1(64 bits) + R2:R3(64 bits) = R0:R1(64 bits)
  ADDC  R3,R1                  ;Before execution T = 0, R1 = H'00000001, R3 = H'FFFFFFFF
                               ;After execution T = 1, R1 = H'00000000
  ADDC  R2,R0                  ;Before execution T = 1, R0 = H'00000000, R2 = H'00000000
                               ;After execution T = 0, R0 = H'00000001
*/


     void ADDV(long m, long n)    /* ADDV Rm,Rn */
     {
         long dest,src,ans;
         if ((long)R[n]>=0) dest=0;
         else dest=1;
         if ((long)R[m]>=0) src=0;
         else src=1;
         src+=dest;
         R[n]+=R[m];
         if ((long)R[n]>=0) ans=0;
         else ans=1;
         ans+=dest;
         if (src==0 || src==2) {
             if (ans==1) T=1;
             else T=0;
         }
         else T=0;
         PC+=2;
}



/*
Example

  ADDV  R0,R1                ;Before execution R0 = H'00000001, R1 = H'7FFFFFFE, T=0
                             ;After execution R1 = H'7FFFFFFF, T=0
  ADDV  R0,R1                ;Before execution R0 = H'00000002, R1 = H'7FFFFFFE, T=0
                             ;After execution R1 = H'80000000, T=1
*/

  void AND(long m, long n)    /* AND Rm,Rn */
  {
      R[n]&=R[m];
      PC+=2;
  }

  void ANDI(long i)    /* AND #imm,R0 */
  {
      //R[0]&=(0x000000FF & (long)i);
      R[0]&=i;
      PC+=2;
  }

  void ANDM(long i)    /* AND.B #imm,@(R0,GBR) */
  {
      long temp;
      temp=(long)Read_Byte(GBR+R[0]);
      //temp&=(0x000000FF & (long)i);
      temp&=i;
      Write_Byte(GBR+R[0],temp);
      PC+=2;
  }

/*
Example

      AND    R0,R1                  ;Before execution R0 = H'AAAAAAAA, R1=H'55555555
                                    ;After execution R1 = H'00000000
      AND    #H'0F,R0               ;Before execution R0 = H'FFFFFFFF
                                    ;After execution R0 = H'0000000F
      AND.B  #H'80,@(R0,GBR) ;Before execution (R0,GBR) = H'A5
                                    ;After execution (R0,GBR) = H'80
*/


  void BF(int d)    /* BF disp */
  {
      if (T==0) PC=PC+d;
      else    PC+=2;
  }

/*
Example

      CLRT                          ;Normally T = 0
      BT   TRGET_T                  ;T = 0, so branch is not taken.
      BF   TRGET_F                  ;T = 0, so branch to TRGET_F.
      NOP                           ;
      NOP                           ;
  TRGET_F:                          ;  BF instruction branch destination
*/



  void BFS(int d)    /* BFS disp */
  {
      unsigned int temp;
      temp=PC;
      if (T==0) PC=PC+d;
      else PC+=4;
      Delay_Slot(temp+2);
  }
/*
Example

      CLRT                          ;Normally T = 0
      BT/S  TRGET_T                 ;T = 0, so branch is not taken.
      NOP                           ;
      BF/S  TRGET_F                 ;T = 0, so branch to TRGET.
      ADD   R0,R1                   ;Executed before branch.
      NOP                           ;
  TRGET_F:                          ;  BF/S instruction branch destination
*/

  void BRA(int d)    /* BRA disp */
  {
      unsigned int temp;
      temp=PC;
      PC=PC+d;
      Delay_Slot(temp+2);
  }

/*
Example

      BRA  TRGET                    ;Branch to TRGET.
      ADD  R0,R1                    ;ADD executed before branch.
      NOP                           ;
  TRGET:                            ;  BRA instruction branch destination
*/


  void BRAF(int n)   /* BRAF Rn */
  {
      unsigned int temp;
      temp=PC;
      PC=PC+4+R[n];
      Delay_Slot(temp+2);
  }
/*
Example

     MOV.L #(TRGET-BRAF_PC),R0                  ;Set displacement.
     BRAF  R0                                   ;Branch to TRGET.
     ADD   R0,R1                                ;ADD executed before branch.
   BRAF_PC:                                     ;
     NOP
   TRGET:                                       ;  BRAF instruction branch destination
*/

  void BSR(int d)   /* BSR disp */
  {
      unsigned int temp;
      temp=PC;
      PR=PC+4;
      PC=PC+d;
      Delay_Slot(temp+2);
  }


/*
Example

     BSR  TRGET    ;Branch to TRGET.
     MOV  R3,R4    ;MOV executed before branch.
     ADD  R0,R1    ;Subroutine procedure return destination (contents of PR)
     .....
     .....
 TRGET:            ;  Entry to procedure
     MOV  R2,R3    ;
     RTS           ;Return to above ADD instruction.
     MOV  #1,R0    ;MOV executed before branch.
*/

  void BSRF(int n)     /* BSRF Rn */
  {
      unsigned int temp;
      temp=PC;
      PR=PC+4;
      PC=PC+4+R[n];
      Delay_Slot(temp+2);
  }

/*
Example

     MOV.L  #(TRGET-BSRF_PC),R0 ;Set displacement.
     BSRF   R0                     ;Branch to TRGET.
     MOV    R3,R4                  ;MOV executed before branch.
   BSRF_PC:                        ;
     ADD    R0,R1                  ;
      .....
   TRGET:                          ;  Entry to procedure
     MOV    R2,R3                  ;
     RTS                           ;Return to above ADD instruction.
     MOV    #1,R0                  ;MOV executed before branch.
*/


  void BT(int d)    /* BT disp */
  {
      if (T==1) PC=PC+d;
      else PC+=2;
  }
/*
  Example

     SETT            ;Normally T = 1
     BF   TRGET_F    ;T = 1, so branch is not taken.
     BT   TRGET_T    ;T = 1, so branch to TRGET_T.
     NOP             ;
     NOP             ;
 TRGET_T:            ;  BT instruction branch destination
*/

 void BTS(int d)    /* BTS disp */
 {
     unsigned temp;
     temp=PC;
     if (T==1) PC=PC+d;
     else PC+=4;
     Delay_Slot(temp+2);
 }

/*
Example

    SETT                    ;Normally T = 1
    BF/S  TRGET_F           ;T = 1, so branch is not taken.
    NOP                     ;
    BT/S  TRGET_T           ;T = 1, so branch to TRGET_T.
    ADD   R0,R1             ;Executed before branch.
    NOP                     ;
 TRGET_T:                   ;  BT/S instruction branch destination
*/


  void CLRMAC()    /* CLRMAC */
  {
      MACH=0;
      MACL=0;
      PC+=2;
  }
/*
Example

      CLRMAC                        ;Clear MAC register to initialize.
      MAC.W   @R0+,@R1+             ;Multiply-and-accumulate operation
      MAC.W   @R0+,@R1+             ;
*/

  void CLRS()    /* CLRS */
  {
      S=0;
      PC+=2;
  }
/*
Example

  CLRS          ;Before execution S = 1
                ;After execution S = 0
*/

  void CLRT()    /* CLRT */
  {
      T=0;
      PC+=2;
  }
/*
Example

  CLRT          ;Before execution T = 1
                ;After execution T = 0
*/

  void CMPEQ(long m, long n)    /* CMP_EQ Rm,Rn */
  {
      if (R[n]==R[m]) T=1;
      else T=0;
      PC+=2;
  }
  void CMPGE(long m, long n)    /* CMP_GE Rm,Rn */
  {
      if ((long)R[n]>=(long)R[m]) T=1;
      else T=0;
      PC+=2;
  }

  void CMPGT(long m, long n)    /* CMP_GT Rm,Rn */
  {
      if ((long)R[n]>(long)R[m]) T=1;
      else T=0;
      PC+=2;
  }


  void CMPHI(long m, long n)    /* CMP_HI Rm,Rn */
  {
      if ((unsigned long)R[n]>(unsigned long)R[m]) T=1;
      else T=0;
      PC+=2;
  }

void CMPHS(long m, long n)    /* CMP_HS Rm,Rn */
{
    if ((unsigned long)R[n]>=(unsigned long)R[m]) T=1;
    else T=0;
    PC+=2;
}


void CMPPL(long n)              /* CMP_PL Rn */
{
    if ((long)R[n]>0) T=1;
    else T=0;
    PC+=2;
}


void CMPPZ(long n)    /* CMP_PZ Rn */
{
    if ((long)R[n]>=0) T=1;
    else T=0;
    PC+=2;
}


void CMPSTR(long m, long n)    /* CMP_STR Rm,Rn */
{
    unsigned long temp;
    long HH,HL,LH,LL;
    temp=R[n]^R[m];
    HH=(temp&0xFF000000)>>24;
    HL=(temp&0x00FF0000)>>16;
    LH=(temp&0x0000FF00)>>8;
    LL=temp&0x000000FF;
    HH=HH&&HL&&LH&&LL;
    if (HH==0) T=1;
    else T=0;
    PC+=2;
  }


  void CMPIM(long i)    /* CMP_EQ #imm,R0 */
  {
      long imm;
      if ((i&0x80)==0) imm=(0x000000FF & i);
      else imm=(0xFFFFFF00 | i);
      if (R[0]==imm) T=1;
      else T=0;
      PC+=2;
  }

/*
Example

  CMP/GE   R0,R1                    ;R0 = H'7FFFFFFF, R1 = H'80000000
  BT       TRGET_T                  ;T = 0, so branch is not taken.
  CMP/HS   R0,R1                    ;R0 = H'7FFFFFFF, R1 = H'80000000
  BT       TRGET_T                  ;T = 1, so branch is taken.
  CMP/STR  R2,R3                    ;R2 = "ABCD", R3 = "XYCZ"
  BT       TRGET_T                  ;T = 1, so branch is taken.
*/

  void DIV0S(long m, long n)    /* DIV0S Rm,Rn */
  {
      if ((R[n] & 0x80000000)==0) Q=0;
      else Q=1;
      if ((R[m] & 0x80000000)==0) M=0;
      else M=1;
      T=!(M==Q);
      PC+=2;
  }
  void DIV0U()        /* DIV0U */
  {
      M=Q=T=0;
      PC+=2;
  }

  void DIV1(long m, long n)    /* DIV1 Rm,Rn */
  {
     unsigned long tmp0, tmp2;
     unsigned char old_q, tmp1;
     old_q=Q;
     Q=(unsigned char)((0x80000000 & R[n])!=0);
     tmp2= R[m];
     R[n]<<=1;
     R[n]|=(unsigned long)T;
     switch(old_q){
     case 0:switch(M){
             case 0:tmp0=R[n];
                     R[n]-=tmp2;
                     tmp1=(R[n]>tmp0);
                     switch(Q){
                     case 0:Q=tmp1;
                             break;
                     case 1:Q=(unsigned char)(tmp1==0);
                             break;
                     }
                     break;
             case 1:tmp0=R[n];
                     R[n]+=tmp2;
                     tmp1=(R[n]<tmp0);
                     switch(Q){
                     case 0:Q=(unsigned char)(tmp1==0);
                             break;
                     case 1:Q=tmp1;
                             break;
                     }
                     break;
             }
             break;
     case 1:switch(M){
             case 0:tmp0=R[n];
                     R[n]+=tmp2;
                     tmp1=(R[n]<tmp0);
                     switch(Q){
                     case 0:Q=tmp1;
                             break;
                     case 1:Q=(unsigned char)(tmp1==0);
                             break;
                     }
                     break;
             case 1:tmp0=R[n];
                    R[n]-=tmp2;
                    tmp1=(R[n]>tmp0);
                    switch(Q){
                    case 0:Q=(unsigned char)(tmp1==0);
                            break;
                    case 1:Q=tmp1;
                             break;
                    }
                    break;
           }
           break;
    }
    T=(Q==M);
    PC+=2;
 }
/*
Example 1

                         ;R1 (32 bits)  R0 (16 bits) = R1 (16 bits); unsigned
 SHLL16    R0            ;Set divisor in upper 16 bits, clear lower 16 bits to 0
 TST       R0,R0         ;Check for division by zero
 BT        ZERO_DIV      ;
 CMP/HS    R0,R1         ;Check for overflow
 BT        OVER_DIV      ;
 DIV0U                   ;Flag initialization
 .arepeat  16            ;
 DIV1      R0,R1         ;Repeat 16 times
 .aendr                  ;
 ROTCL     R1            ;
 EXTU.W    R1,R1         ;R1 = quotient

 Example 2

                              ; R1:R2 (64 bits)  R0 (32 bits) = R2 (32 bits); unsigned
  TST       R0,R0             ;Check for division by zero
  BT        ZERO_DIV          ;
  CMP/HS    R0,R1             ;Check for overflow
  BT        OVER_DIV          ;
  DIV0U                       ;Flag initialization
  .arepeat  32                ;
  ROTCL     R2                ;Repeat 32 times
  DIV1      R0,R1             ;
  .aendr                      ;
  ROTCL     R2                ;R2 = quotient

Example 3

                              ;R1 (16 bits)  R0 (16 bits) = R1 (16 bits); signed
  SHLL16    R0                ;Set divisor in upper 16 bits, clear lower 16 bits to 0
  EXTS.W    R1,R1             ;Dividend sign-extended to 32 bits
  XOR       R2,R2             ;R2 = 0
  MOV       R1,R3             ;
  ROTCL     R3                ;
  SUBC      R2,R1             ;If dividend is negative, subtract 1
  DIV0S     R0,R1             ;Flag initialization
  .arepeat  16                ;
  DIV1      R0,R1             ;Repeat 16 times
  .aendr                      ;
  EXTS.W    R1,R1             ;
  ROTCL     R1                ;R1 = quotient (one's complement notation)
  ADDC      R2,R1             ;If MSB of quotient is 1, add 1 to convert to two's complement notation
  EXTS.W    R1,R1             ;R1 = quotient (two's complement notation)


Example 4

                    ;R2 (32 bits)  R0 (32 bits) = R2 (32 bits); signed
 MOV       R2,R3    ;
 ROTCL     R3       ;
 SUBC      R1,R1    ;Dividend sign-extended to 64 bits (R1:R2)
 XOR       R3,R3    ;R3 = 0
 SUBC      R3,R2    ;If dividend is negative, subtract 1 to convert to one's complement notation
 DIV0S     R0,R1    ;Flag initialization
 .arepeat  32       ;
 ROTCL     R2       ;Repeat 32 times
 DIV1      R0,R1    ;
 .aendr             ;
 ROTCL     R2       ;R2 = quotient (one's complement notation)
 ADDC      R3,R2    ;If MSB of quotient is 1, add 1 to convert to two's complement notation
                    ;R2 = quotient (two's complement notation)

*/

  void DMULS(long m, long n)  /* DMULS.L Rm,Rn */
  {
      unsigned long RnL,RnH,RmL,RmH,Res0,Res1,Res2;
      unsigned long temp0,temp1,temp2,temp3;
      long tempm,tempn,fnLmL;


      tempn=(long)R[n];
      tempm=(long)R[m];
      if (tempn<0) tempn=0-tempn;
      if (tempm<0) tempm=0-tempm;
      if ((long)(R[n]^R[m])<0) fnLmL=-1;
      else fnLmL=0;


      temp1=(unsigned long)tempn;
      temp2=(unsigned long)tempm;


      RnL=temp1&0x0000FFFF;
      RnH=(temp1>>16)&0x0000FFFF;
      RmL=temp2&0x0000FFFF;
      RmH=(temp2>>16)&0x0000FFFF;

     temp0=RmL*RnL;
     temp1=RmH*RnL;
     temp2=RmL*RnH;
     temp3=RmH*RnH;


     Res2=0;
     Res1=temp1+temp2;
     if (Res1<temp1) Res2+=0x00010000;
     temp1=(Res1<<16)&0xFFFF0000;
     Res0=temp0+temp1;
     if (Res0<temp0) Res2++;

            Res2=Res2+((Res1>>16)&0x0000FFFF)+temp3;


            if (fnLmL<0) {
                Res2=~Res2;
                if (Res0==0)
                   Res2++;
                else
                   Res0=(~Res0)+1;
            }


            MACH=Res2;
            MACL=Res0;
            PC+=2;
        }
/*
Example

 DMULS.L         R0,R1          ;Before execution R0 = H'FFFFFFFE, R1 = H'00005555
                                ;After execution     MACH = H'FFFFFFFF, MACL = H'FFFF5556
 STS             MACH,R0        ;Get operation result (upper)
 STS             MACL,R1        ;et operation result (lower)
*/


  void DMULU(long m, long n)  /* DMULU.L Rm,Rn */
  {
      unsigned long RnL,RnH,RmL,RmH,Res0,Res1,Res2;
      unsigned long temp0,temp1,temp2,temp3;

      RnL=R[n]&0x0000FFFF;
      RnH=(R[n]>>16)&0x0000FFFF;


      RmL=R[m]&0x0000FFFF;
      RmH=(R[m]>>16)&0x0000FFFF;


      temp0=RmL*RnL;
      temp1=RmH*RnL;
      temp2=RmL*RnH;
      temp3=RmH*RnH;


      Res2=0;
      Res1=temp1+temp2;
      if (Res1<temp1) Res2+=0x00010000;


     temp1=(Res1<<16)&0xFFFF0000;
     Res0=temp0+temp1;
     if (Res0<temp0) Res2++;

     Res2=Res2+((Res1>>16)&0x0000FFFF)+temp3;

     MACH=Res2;
     MACL=Res0;
     PC+=2;
 }

/*
Example

 DMULU.L    R0,R1         ;Before execution R0 = H'FFFFFFFE, R1 = H'00005555
                          ;After execution    MACH = H'00005554, MACL = H'FFFF5556
 STS        MACH,R0       ;Get operation result (upper)
 STS        MACL,R1       ;Get operation result (lower)
*/

  void DT(long n)/* DT Rn */
  {
      R[n]--;
      if (R[n]==0) T=1;
      else T=0;
      PC+=2;
  }
/*
Example

      MOV  #4,R5                ;Set loop count
  LOOP:
      ADD  R0,R1                ;
      DT         R5             ;Decrement R5 value and check for 0.
      BF         LOOP           ;If T = 0, branch to LOOP (in this example, 4 loops are executed).
*/

  void EXTSB(long m, long n)            /* EXTS.B Rm,Rn */
  {
      R[n]=R[m];
      if ((R[m]&0x00000080)==0) R[n]&=0x000000FF;
      else R[n]|=0xFFFFFF00;
      PC+=2;
  }


  void EXTSW(long m, long n)            /* EXTS.W Rm,Rn */
  {
      R[n]=R[m];
      if ((R[m]&0x00008000)==0) R[n]&=0x0000FFFF;
      else R[n]|=0xFFFF0000;
      PC+=2;
  }
/*
Example

  EXTS.B  R0,R1             ;Before execution R0 = H'00000080
                            ;After execution    R1 = H'FFFFFF80
  EXTS.W  R0,R1             ;Before execution R0 = H'00008000
                            ;After execution    R1 = H'FFFF8000
*/

  void EXTUB(long m, long n)             /* EXTU.B Rm,Rn */
  {
      R[n]=R[m] & 0x000000FF;;
      PC+=2;
  }


  void EXTUW(long m, long n)             /* EXTU.W Rm,Rn */
  {
      R[n]=R[m] & 0x0000FFFF;
      PC+=2;
  }
/*
Example

  EXTU.B  R0,R1                     ;Before execution R0 = H'FFFFFF80
                                    ;After execution    R1 = H'00000080
  EXTU.W  R0,R1                     ;Before execution R0 = H'FFFF8000
                                    ;After execution    R1 = H'00008000
*/

  void JMP(int n)/* JMP @Rn */
  {
      unsigned int temp;
      temp=PC;
      PC=R[n];
      Delay_Slot(temp+2);
  }
/*
Example

                      MOV.L          JMP_TABLE,R0          ;R0 = TRGET address
                      JMP            @R0                   ;Branch to TRGET.
                      MOV            R0,R1                 ;MOV executed before branch.
                      .align         4
  JMP_TABLE:          .data.l        TRGET                 ;Jump table
          ...........
  TRGET:              ADD            #1,R1                 ;  Branch destination
*/

  void JSR(int n)/* JSR @Rn */
  {
      unsigned int temp;
      temp=PC;
      PR=PC+4;
      PC=R[n];
      Delay_Slot(temp+2);
  }
/*
Example

               MOV.L      JSR_TABLE,R0    ;R0 = TRGET address
               JSR        @R0             ;Branch to TRGET.
               XOR        R1,R1           ;XOR executed before branch.
               ADD        R0,R1           ;  Procedure return destination (PR contents)
               .......
               .align     4
 JSR_TABLE:    .data.l    TRGET           ;Jump table
 TRGET:        NOP                        ;  Entry to procedure
               MOV        R2,R3           ;
               RTS                        ;Return to above ADD instruction.
               MOV        #70,R1          ;MOV executed before RTS.
*/

       void LDCSR(int m)      /* LDC Rm,SR : Privileged */
       {
         SR=R[m]&0x700083F3;
         PC+=2;
       }


       void LDCGBR(int m)     /* LDC Rm,GBR */
       {
         GBR=R[m];
         PC+=2;
       }


       void LDCVBR(int m)      /* LDC Rm,VBR : Privileged */
       {
         VBR=R[m];
         PC+=2;
       }


       void LDCSSR(int m)      /* LDC Rm,SSR : Privileged */
       {
         SSR=R[m],
         PC+=2;
       }


       void LDCSPC(int m)      /* LDC Rm,SPC : Privileged */
       {
         SPC=R[m];
         PC+=2;
       }


       void LDCDBR(int m)      /* LDC Rm,DBR : Privileged */
       {
         DBR=R[m];
         PC+=2;
       }


       void LDCRn_BANK(int m, int n)  /* LDC Rm,Rn_BANK : Privileged */
       {
         R_BANK[n]=R[m];
         PC+=2;
       }


       void LDCMSR(int m)     /* LDC.L @Rm+,SR : Privileged */
       {
         SR=Read_Long(R[m])&0x700083F3;
         R[m]+=4;
         PC+=2;
       }


       void LDCMGBR(int m)     /* LDC.L @Rm+,GBR */
       {
         GBR=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }


       void LDCMVBR(int m)     /* LDC.L @Rm+,VBR : Privileged */
       {
         VBR=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }

       void LDCMSSR(int m)     /* LDC.L @Rm+,SSR : Privileged */
       {
         SSR=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }


       void LDCMSPC(int m)     /* LDC.L @Rm+,SPC : Privileged */
       {
         SPC=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }


       void LDCMDBR(int m)     /* LDC.L @Rm+,DBR : Privileged */
       {
         DBR=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }


       void LDCMRn_BANK(int m, int n) /* LDC.L @Rm+,Rn_BANK : Privileged ;  n=07 */
       {
         R_BANK[n]=Read_Long(R[m]);
         R[m]+=4;
         PC+=2;
       }

  #define FPSCR_MASK 0x003FFFFF


  void LDSFPUL(int m)        /* LDS Rm,FPUL  */
  {
       FPUL=R[m];
       PC+=2;
  }
  void LDSMFPUL(int m)        /* LDS.L @Rm+,FPUL  */
  {
       FPUL=Read_Long(R[m]);
       R[m]+=4;
       PC+=2;
  }
  void LDSFPSCR(int  m)        /* LDS Rm,FPSCR  */
  {
       FPSCR=R[m] & FPSCR_MASK;
       PC+=2;
  }
  void LDSMFPSCR(int  m)        /* LDS.L @Rm+,FPSCR  */
  {
       FPSCR=Read_Long(R[m]) & FPSCR_MASK;
       R[m]+=4;
       PC+=2;
  }

  void LDSMACH(int m)     /* LDS Rm,MACH */
  {
      MACH=R[m];
      PC+=2;
  }


  void LDSMACL(int m)     /* LDS Rm,MACL */
  {
      MACL=R[m];
      PC+=2;
  }


  void LDSPR(int m)      /* LDS Rm,PR */
  {
      PR=R[m];
      PC+=2;
  }


  void LDSMMACH(int m)     /* LDS.L @Rm+,MACH */
  {
     MACH=Read_Long(R[m]);
     R[m]+=4;
     PC+=2;
  }


 void LDSMMACL(int m)     /* LDS.L @Rm+,MACL */
 {
     MACL=Read_Long(R[m]);
     R[m]+=4;
     PC+=2;
 }


 void LDSMPR(int m)     /* LDS.L @Rm+,PR */
 {
     PR=Read_Long(R[m]);
     R[m]+=4;
     PC+=2;
 }
/*
Example

 LDS     R0,PR              ; Before execution    R0 = H'12345678, PR = H'00000000
                            ; After execution     PR = H'12345678
 LDS.L   @R15+,MACL         ; Before execution    R15 = H'10000000
                            ; After execution     R15 = H'10000004, MACL = (H'10000000)
*/

 void LDTLB()
 {
     TLB[MMUCR_URC].ASID=(*PTEH & 0x000000FF);
     TLB[MMUCR_URC].VPN=(*PTEH & 0xFFFFFC00)>>10;
     TLB[MMUCR_URC].PPN=(*PTEH & 0x1FFFFC00)>>10;
     TLB[MMUCR_URC].SZ=(*PTEL & 0x00000080)>>6 | (*PTEL & 0x00000010)>>4;
     TLB[MMUCR_URC].SH=(*PTEH & 0x00000002)>>1;
     TLB[MMUCR_URC].PR=(*PTEH & 0x00000060)>>5;
     TLB[MMUCR_URC].WT=(*PTEH & 0x00000001);
     TLB[MMUCR_URC].C=(*PTEH & 0x00000008)>>3;
     TLB[MMUCR_URC].D=(*PTEH & 0x00000004)>>2;
     TLB[MMUCR_URC].V=(*PTEH & 0x00000100)>>8;
     TLB[MMUCR_URC].SA=(*PTEA & 0x00000007);
     TLB[MMUCR_URC].TC=(*PTEA & 0x00000008)>>3;
     PC+=2;
 }

/*
Example

 MOV   @R0,R1        ;Load page table entry (upper) into R1
 MOV   R1,@R2        ;Load R1 into PTEH; R2 is PTEH address (H'FF000000)
 LDTLB               ;Load PTEH, PTEL, PTEA registers into TLB
*/

  void MAC_L(long m, long n)   /* MAC.L @Rm+,@Rn+ */
  {
      unsigned long RnL,RnH,RmL,RmH,Res0,Res1,Res2;
      unsigned long temp0,temp1,temp2,temp3;
      long tempm,tempn,fnLmL;


      tempn=(long)Read_Long(R[n]);
      R[n]+=4;
      tempm=(long)Read_Long(R[m]);
      R[m]+=4;


      if ((long)(tempn^tempm)<0) fnLmL=-1;
      else fnLmL=0;
    if (tempn<0) tempn=0-tempn;
    if (tempm<0) tempm=0-tempm;


    temp1=(unsigned long)tempn;
    temp2=(unsigned long)tempm;


    RnL=temp1&0x0000FFFF;
    RnH=(temp1>>16)&0x0000FFFF;
    RmL=temp2&0x0000FFFF;
    RmH=(temp2>>16)&0x0000FFFF;
    temp0=RmL*RnL;
    temp1=RmH*RnL;
    temp2=RmL*RnH;
    temp3=RmH*RnH;


    Res2=0;


Res1=temp1+temp2;
if (Res1<temp1) Res2+=0x00010000;


temp1=(Res1<<16)&0xFFFF0000;
Res0=temp0+temp1;
if (Res0<temp0) Res2++;


Res2=Res2+((Res1>>16)&0x0000FFFF)+temp3;


if(fnLmL<0){
    Res2=~Res2;
    if (Res0==0) Res2++;
    else Res0=(~Res0)+1;
}
if(S==1){
    Res0=MACL+Res0;
    if (MACL>Res0) Res2++;
    if (MACH&0x00008000);
    else Res2+=MACH|0xFFFF0000;
          Res2+=MACH&0x00007FFF;


      if(((long)Res2<0)&&(Res2<0xFFFF8000)){
          Res2=0xFFFF8000;
          Res0=0x00000000;
      }
      if(((long)Res2>0)&&(Res2>0x00007FFF)){
          Res2=0x00007FFF;
          Res0=0xFFFFFFFF;
      };


      MACH=(Res2&0x0000FFFF)|(MACH&0xFFFF0000);
      MACL=Res0;
  }
      else {
          Res0=MACL+Res0;
          if (MACL>Res0) Res2++;
          Res2+=MACH;


          MACH=Res2;
          MACL=Res0;
      }
      PC+=2;
  }
/*
Example

           MOVA         TBLM,R0       ;Get table address
           MOV          R0,R1         ;
           MOVA         TBLN,R0       ;Get table address
           CLRMAC                     ;MAC register initialization
           MAC.L        @R0+,@R1+     ;
           MAC.L        @R0+,@R1+     ;
           STS          MACL,R0       ;Get result in R0
           .........
           .align       2             ;
 TBLM      .data.l      H'1234ABCD    ;
           .data.l      H'5678EF01    ;
 TBLN      .data.l      H'0123ABCD    ;
           .data.l      H'4567DEF0    ;
*/


 void MACW(long m, long n)   /* MAC.W @Rm+,@Rn+ */
 {
     long tempm,tempn,dest,src,ans;
     unsigned long templ;
     tempn=(long)Read_Word(R[n]);
     R[n]+=2;
     tempm=(long)Read_Word(R[m]);
     R[m]+=2;
     templ=MACL;
     tempm=((long)(short)tempn*(long)(short)tempm);
     if ((long)MACL>=0) dest=0;
     else dest=1;
     if ((long)tempm>=0) {
         src=0;
         tempn=0;
     }
     else {
         src=1;
         tempn=0xFFFFFFFF;
     }
     src+=dest;
     MACL+=tempm;
     if ((long)MACL>=0) ans=0;
     else ans=1;
     ans+=dest;
     if (S==1) {
         if (ans==1) {
             if (src==0) MACL=0x7FFFFFFF;
             if (src==2) MACL=0x80000000;
         }
     }
     else {
         MACH+=tempn;
         if (templ>MACL) MACH+=1;


     }
      PC+=2;
  }
/*
Example

               MOVA                 TBLM,R0      ;Get table address
               MOV                  R0,R1        ;
               MOVA                 TBLN,R0      ;Get table address
               CLRMAC                            ;MAC register initialization
               MAC.W                @R0+,@R1+    ;
               MAC.W                @R0+,@R1+    ;
               STS                  MACL,R0      ;Get result in R0
               ...........
               .align 2                          ;
  TBLM         .data.w              H'1234       ;
               .data.w              H'5678       ;
  TBLN         .data.w              H'0123       ;
               .data.w              H'4567       ;
*/


  void MOV(long m, long n)   /* MOV Rm,Rn */
  {
      R[n]=R[m];
      PC+=2;
  }


  void MOVBS(long m, long n) /* MOV.B Rm,@Rn */
  {
       Write_Byte(R[n],R[m]);
       PC+=2;
  }


  void MOVWS(long m, long n) /* MOV.W Rm,@Rn */
  {
       Write_Word(R[n],R[m]);
       PC+=2;
  }


  void MOVLS(long m, long n) /* MOV.L Rm,@Rn */
  {
       Write_Long(R[n],R[m]);
       PC+=2;
  }


  void MOVBL(long m, long n) /* MOV.B @Rm,Rn */
  {
       R[n]=(long)Read_Byte(R[m]);
       /*
       if ((R[n]&0x80)==0) R[n]&=0x000000FF;
       else R[n]|=0xFFFFFF00;
       */
       PC+=2;
  }


  void MOVWL(long m, long n) /* MOV.W @Rm,Rn */
  {
     R[n]=(long)Read_Word(R[m]);
     /*
     if ((R[n]&0x8000)==0) R[n]&=0x0000FFFF;
     else R[n]|=0xFFFF0000;
     */
     PC+=2;
  }


void MOVLL(long m, long n) /* MOV.L @Rm,Rn */
{
     R[n]=Read_Long(R[m]);
     PC+=2;
}


void MOVBM(long m, long n) /* MOV.B Rm,@-Rn */
{
     Write_Byte(R[n]-1,R[m]);
     R[n]-=1;
     PC+=2;
}


void MOVWM(long m, long n) /* MOV.W Rm,@-Rn */
{
     Write_Word(R[n]-2,R[m]);
     R[n]-=2;
     PC+=2;
}


void MOVLM(long m, long n)   /* MOV.L Rm,@-Rn */
{
     Write_Long(R[n]-4,R[m]);
     R[n]-=4;
     PC+=2;
}


void MOVBP(long m, long n) /* MOV.B @Rm+,Rn */
{
     R[n]=(long)Read_Byte(R[m]);
     /*
     if ((R[n]&0x80)==0) R[n]&=0x000000FF;
     else R[n]|=0xFFFFFF00;
     */
     if (n!=m) R[m]+=1;
     PC+=2;
}
  void MOVWP(long m, long n)    /* MOV.W @Rm+,Rn */
  {
       R[n]=(long)Read_Word(R[m]);
       /*
       if ((R[n]&0x8000)==0) R[n]&=0x0000FFFF;
       else R[n]|=0xFFFF0000;
       */
       if (n!=m) R[m]+=2;
       PC+=2;
  }


  void MOVLP(long m, long n)   /* MOV.L @Rm+,Rn */
  {
       R[n]=Read_Long(R[m]);
       if (n!=m) R[m]+=4;
       PC+=2;
  }


  void MOVBS0(long m, long n) /* MOV.B Rm,@(R0,Rn) */
  {
       Write_Byte(R[n]+R[0],R[m]);
       PC+=2;
  }


  void MOVWS0(long m, long n) /* MOV.W Rm,@(R0,Rn) */
  {
       Write_Word(R[n]+R[0],R[m]);
       PC+=2;
  }


  void MOVLS0(long m, long n) /* MOV.L Rm,@(R0,Rn) */
  {
       Write_Long(R[n]+R[0],R[m]);
       PC+=2;
  }


 void MOVBL0(long m, long n) /* MOV.B @(R0,Rm),Rn */
 {
     R[n]=(long)Read_Byte(R[m]+R[0]);
     /*
     if ((R[n]&0x80)==0) R[n]&=0x000000FF;
     else R[n]|=0xFFFFFF00;
     */
     PC+=2;
 }


 void MOVWL0(long m, long n)   /* MOV.W @(R0,Rm),Rn */
 {
     R[n]=(long)Read_Word(R[m]+R[0]);
     /*
     if ((R[n]&0x8000)==0) R[n]&=0x0000FFFF;
     else R[n]|=0xFFFF0000;
     */
     PC+=2;
 }


 void MOVLL0(long m, long n)   /* MOV.L @(R0,Rm),Rn */
 {
     R[n]=Read_Long(R[m]+R[0]);
     PC+=2;
 }
/*
Example

 MOV       R0,R1          ;Before execution R0 = H'FFFFFFFF, R1 = H'00000000
                          ;After execution    R1 = H'FFFFFFFF
 MOV.W     R0,@R1         ;Before execution R0 = H'FFFF7F80
                          ;After execution    (R1) = H'7F80
 MOV.B     @R0,R1         ;Before execution (R0) = H'80, R1 = H'00000000
                          ;After execution    R1 = H'FFFFFF80
 MOV.W     R0,@-R1        ;Before execution R0 = H'AAAAAAAA, (R1) = H'FFFF7F80
                          ;After execution    R1 = H'FFFF7F7E, (R1) = H'AAAA
 MOV.L     @R0+,R1        ;Before execution R0 = H'12345670
                          ;After execution    R0 = H'12345674, R1 = (H'12345670)
 MOV.B     R1,@(R0,R2)    ;Before execution R2 = H'00000004, R0 = H'10000000
                          ;After execution    R1 = (H'10000004)
 MOV.W     @(R0,R2),R1    ;Before execution R2 = H'00000004, R0 = H'10000000
                          ;After execution    R1 = (H'10000004)
*/

 void MOVI(int i, int n)  /* MOV #imm,Rn */
 {
       //if ((i&0x80)==0) R[n]=(0x000000FF & i);
       //else R[n]=(0xFFFFFF00 | i);
       R[n]=i;
       PC+=2;
 }


 void MOVWI(int d, int n) /* MOV.W @(disp,PC),Rn */
 {
       //R[n]=(int)Read_Word(PC+4+(d<<1));
       R[n]=(long)Read_Word(PC+d);
       /*
       if ((R[n]&0x8000)==0) R[n]&=0x0000FFFF;
       else R[n]|=0xFFFF0000;
       */
       PC+=2;
 }


 void MOVLI(int d, int n)/* MOV.L @(disp,PC),Rn */
 {
       //R[n]=Read_Long((PC&0xFFFFFFFC)+4+(d<<2));
       R[n]=Read_Long((PC&0xFFFFFFFC)+d);
       PC+=2;
 }

/*
Example

  Address
  1000          MOV           #H'80,R1      ;R1 = H'FFFFFF80
  1002          MOV.W         IMM,R2        ;R2 = H'FFFF9ABC      IMM means (PC + 4 + H'08)
  1004          ADD           #-1,R0        ;
  1006          TST           R0,R0         ;
  1008          MOV.L         @(3,PC),R3    ;R3 = H'12345678
  100A          BRA           NEXT          ;Delayed branch instruction
  100C NOP
  100E IMM  .data.w           H'9ABC        ;
  1010          .data.w       H'1234        ;
  1012 NEXT JMP               @R3           ;BRA branch instruction
  1014          CMP/EQ        #0,R0         ;
                .align        4             ;
  1018          .data.l       H'12345678    ;
  101C          .data.l       H'9ABCDEF0    ;
*/


  void MOVBLG(int d) /* MOV.B @(disp,GBR),R0 */
  {
          R[0]=(long)Read_Byte(GBR+d);
          /*
          if ((R[0]&0x80)==0) R[0]&=0x000000FF;
          else R[0]|=0xFFFFFF00;
          */
          PC+=2;
  }
  void MOVWLG(int d) /* MOV.W @(disp,GBR),R0 */
  {
          //R[0]=(int)Read_Word(GBR+(d<<1));
          R[0]=(long)Read_Word(GBR+d);
          /*
          if ((R[0]&0x8000)==0) R[0]&=0x0000FFFF;
          else R[0]|=0xFFFF0000;
          */
          PC+=2;
  }
  void MOVLLG(int d) /* MOV.L @(disp,GBR),R0 */
  {
          //R[0]=Read_Long(GBR+(d<<2));
          R[0]=Read_Long(GBR+d);
          PC+=2;
  }
  void MOVBSG(int d) /* MOV.B R0,@(disp,GBR) */
  {
         Write_Byte(GBR+d,R[0]);
         PC+=2;
  }
 void MOVWSG(int d) /* MOV.W R0,@(disp,GBR) */
 {
         //Write_Word(GBR+(d<<1),R[0]);
         Write_Word(GBR+d,R[0]);
         PC+=2;
 }
 void MOVLSG(int d) /* MOV.L R0,@(disp,GBR) */
 {
         //Write_Long(GBR+(d<<2),R[0]);
         Write_Long(GBR+d,R[0]);
         PC+=2;
 }
/*
Example

 MOV.L @(2,GBR),R0    ;Before execution (GBR+8) = H'12345670
                      ;After execution    R0 = (H'12345670)
 MOV.B R0,@(1,GBR)    ;Before execution R0 = H'FFFF7F80
                      ;After execution    (GBR+1) = H'80
*/


 void MOVBS4(long d, long n)   /* MOV.B R0,@(disp,Rn) */
 {
      Write_Byte(R[n]+d,R[0]);
      PC+=2;
 }


 void MOVWS4(long d, long n)  /* MOV.W R0,@(disp,Rn) */
 {
      //Write_Word(R[n]+(d<<1),R[0]);
      Write_Word(R[n]+d,R[0]);
      PC+=2;
 }


 void MOVLS4(long m, long d, long n) /* MOV.L Rm,@(disp,Rn) */
 {
      //Write_Long(R[n]+(d<<2),R[m]);
      Write_Long(R[n]+d,R[m]);
      PC+=2;
 }


 void MOVBL4(long m, long d)  /* MOV.B @(disp,Rm),R0 */
 {
      R[0]=(long)Read_Byte(R[m]+d);
      /*
      if ((R[0]&0x80)==0) R[0]&=0x000000FF;
      else R[0]|=0xFFFFFF00;
      */
      PC+=2;
 }
  void MOVWL4(long m, long d) /* MOV.W @(disp,Rm),R0 */
  {
     //R[0]=Read_Word(R[m]+(d<<1));
     R[0]=(long)Read_Word(R[m]+d);
     /*
     if ((R[0]&0x8000)==0) R[0]&=0x0000FFFF;
     else R[0]|=0xFFFF0000;
     */
     PC+=2;
  }
  void MOVLL4(long m, long d, long n) /* MOV.L @(disp,Rm),Rn */
  {
     //R[n]=Read_Long(R[m]+(d<<2));
     R[n]=Read_Long(R[m]+d);
     PC+=2;
  }
/*
Example

  MOV.L        @(2,R0),R1           ;Before execution (R0+8) = H'12345670
                                    ;After execution R1 = (H'12345670)
  MOV.L        R0,@(H'F,R1)         ;Before execution R0 = H'FFFF7F80
                                    ;After execution (R1+60) = H'FFFF7F80
*/

  void MOVA(int d)               /* MOVA @(disp,PC),R0 */
  {
           //R[0]=(PC&0xFFFFFFFC)+4+(d<<2);
           R[0]=(PC&0xFFFFFFFC)+d;
           PC+=2;
  }
/*
Example

  Address .org    H'1006
  1006       MOVA    STR,R0           ;STR address   R0
  1008       MOV.B   @R0,R1           ;R1 = "X"   Position after adjustment of lower 2 bits of PC
  100A       ADD      R4,R5           ;  Original PC position in MOVA instruction address calculation
             .align  4
  100C       STR:.sdata  "XYZP12"
*/
#define MISS 1
void MOVCAL(int n)      //MOVCA.L  R0,@Rn
{
 if ((is_write_back_memory(R[n])) &&
 ( look_up_in_operand_cache(R[n])==MISS ) )
    allocate_operand_cache_block(R[n]);
    Write_Long(R[n], R[0]);
    PC+=2;
}

  void MOVT(long n)               /* MOVT Rn */
  {
           R[n]=(0x00000001 & SR);
           PC+=2;
  }
/*
Example

  XOR                R2,R2             ;R2 = 0
  CMP/PZ             R2                ;T = 1
  MOVT               R0                ;R0 = 1
  CLRT                                 ;T = 0
  MOVT               R1                ;R1 = 0
*/

  void MULL(long m, long n) /* MUL.L Rm,Rn */
  {
       MACL=R[n]*R[m];
       PC+=2;
  }
/*
Example

  MUL.L          R0,R1               ;Before execution R0 = H'FFFFFFFE, R1 = H'00005555
                                     ;After execution    MACL = H'FFFF5556
  STS            MACL,R0             ;Get operation result
*/

  void MULS(long m, long n) /* MULS Rm,Rn */
  {
       MACL=((long)(short)R[n]*(long)(short)R[m]);
       PC+=2;
  }
/*
Example

  MULS.W             R0,R 1             ;Before execution R0 = H'FFFFFFFE, R1 = H'00005555
                                        ;After execution MACL = H'FFFF5556
  STS                MACL,R0            ;Get operation result
*/

  void MULU(long m, long n) /* MULU Rm,Rn  */
  {
       MACL=(unsigned long)(R[n]*R[m]);
        PC+=2;
  }
/*
Example

  MULU.W        R0,R1               ;Before execution R0 = H'00000002, R1 = H'FFFFAAAA
                                    ;After execution    MACL = H'00015554
  STS           MACL,R0             ;Get operation result
*/

  void NEG(long m, long n) /* NEG Rm,Rn */
  {
          //R[n]=0-R[m];
          R[n]=-R[m];
          PC+=2;
  }
/*
Example

  NEG   R0,R1                       ;Before execution R0 = H'00000001
                                    ;After execution    R1 = H'FFFFFFFF
*/

  void NEGC(long m, long n) /* NEGC Rm,Rn */
  {
          //unsigned long temp;
          //temp=0-R[m];
          long temp=-R[m];
          R[n]=temp-T;
          if (0<temp) T=1;
          else T=0;
          if (temp<R[n]) T=1;
          PC+=2;
  }
/*
Example

  CLRT                        ;Sign inversion of R0:R1 (64 bits)
  NEGC       R1,R1            ;Before execution R1 = H'00000001, T = 0
                              ;After execution    R1 = H'FFFFFFFF, T = 1
  NEGC       R0,R0 ;Before execution R0 = H'00000000, T = 1
                              ;After execution    R0 = H'FFFFFFFF, T = 1
*/

  void NOP() /* NOP */
  {
          PC+=2;
  }
/*
Example

  NOP                      ;Time equivalent to one execution state elapses.
*/

  void NOT(long m, long n) /* NOT Rm,Rn */
  {
          R[n]= R[m];
          PC+=2;
  }
/*
Example

  NOT R0,R1        ;Before execution R0 = H'AAAAAAAA
                     ;After execution R1 = H'55555555
*/

  void OCBI(int n)        /* OCBI @Rn */
  {
    invalidate_operand_cache_block(R[n]);
    PC+=2;
  }

  void OCBP(int n)        /* OCBP @Rn */
  {
    if(is_dirty_block(R[n]))  write_back(R[n]);
    invalidate_operand_cache_block(R[n]);
    PC+=2;
  }

  void OCBWB(int n)       /* OCBWB @Rn */
  {
         if(is_dirty_block(R[n]))  write_back(R[n]);
         PC+=2;
  }
 void OR(long m, long n) /* OR Rm,Rn */
 {
         R[n]|=R[m];
         PC+=2;
 }


 void ORI(long i)  /* OR #imm,R0 */
 {
         //R[0]|=(0x000000FF & (long)i);
         R[0]|= i;
         PC+=2;
 }


 void ORM(long i) /* OR.B #imm,@(R0,GBR) */
 {
        long temp;
        temp=(long)Read_Byte(GBR+R[0]);
        //temp|=(0x000000FF & (long)i);
        temp|=i;
        Write_Byte(GBR+R[0],temp);
        PC+=2;
 }
/*
Example

 OR          R0,R1 ;Before execution R0 = H'AAAA5555, R1 = H'55550000
                                ;After execution    R1 = H'FFFF5555
 OR          #H'F0,R0 ;Before execution R0 = H'00000008
                                ;After execution    R0 = H'000000F8
 OR.B        #H'50,@(R0,GBR) ;Before execution (R0,GBR) = H'A5
                                ;After execution    (R0,GBR) = H'F5
*/

  void PREF(int n) /* PREF */
  {
           PC+=2;
  }
/*
Example

                MOV.L #SOFT_PF,R1                ;R1 address is SOFT_PF
                PREF @R1                         ;Load SOFT_PF data into on-chip cache

                .align 32
  SOFT_PF: .data.l              H'12345678
                .data.l         H'9ABCDEF0
                .data.l         H'AAAA5555
                .data.l         H'5555AAAA
                .data.l         H'11111111
                .data.l         H'22222222
                .data.l         H'33333333
                .data.l         H'44444444
*/

  void ROTCL(long n) /* ROTCL Rn */
  {
          //long temp;
          char temp;
          if ((R[n]&0x80000000)==0) temp=0;
          else temp=1;
          R[n]<<=1;
          if (T==1) R[n]|=0x00000001;
          else R[n]&=0xFFFFFFFE;
          if (temp==1) T=1;
          else T=0;
          PC+=2;
  }
/*
Example

  ROTCL R0                     ;Before execution R0 = H'80000000, T = 0
                               ;After execution    R0 = H'00000000, T = 1
*/

  void ROTCR(long n) /* ROTCR Rn */
  {
          //long temp;
          char temp;
          if ((R[n]&0x00000001)==0) temp=0;
          else temp=1;
          R[n]>>=1;
          if (T==1) R[n]|=0x80000000;
          else R[n]&=0x7FFFFFFF;
          if (temp==1) T=1;
          else T=0;
          PC+=2;
  }
/*
Example

  ROTCR R0                     ;Before execution R0 = H'00000001, T = 1
                               ;After execution    R0 = H'80000000, T = 1
*/

  void ROTL(long n)  /* ROTL Rn */
  {
          if ((R[n]&0x80000000)==0) T=0;
          else T=1;
          R[n]<<=1;
          if (T==1) R[n]|=0x00000001;
          else R[n]&=0xFFFFFFFE;
          PC+=2;
  }
/*
Example

  ROTL R0                       ;Before execution R0 = H'80000000, T = 0
                                ;After execution    R0 = H'00000001, T = 1
*/

  void ROTR(long n) /* ROTR Rn */
  {
          if ((R[n]&0x00000001)==0) T=0;
          else T=1;
          R[n]>>=1;
          if (T==1) R[n]|=0x80000000;
          else R[n]&=0x7FFFFFFF;
          PC+=2;
  }
/*
Example

  ROTR R0                       ;Before execution R0 = H'00000001, T = 0
                                ;After execution    R0 = H'80000000, T = 1
*/

  void RTE() /* RTE */
  {
          unsigned int temp;
          temp=PC;
          SR=SSR;
          PC=SPC;
          Delay_Slot(temp+2);
  }
/*
Example

  RTE                          ;Return to original routine.
  ADD #8,R14                   ;Executed before branch.
*/

  void RTS() /* RTS */
  {
          unsigned int temp;
          temp=PC;
          PC=PR;
          //printf("PR:0x%x\n",PR);
          Delay_Slot(temp+2);
  }
/*
Example

               MOV.L        TABLE,R3    ;R3 = TRGET address
               JSR          @R3         ; Branch to TRGET.
               NOP                      ;NOP executed before branch.
               ADD          R0,R1       ;  Subroutine procedure return destination (PR contents)
               ........
  TABLE:       .data.l      TRGET       ;Jump table
               ........
  TRGET:       MOV          R1,R0       ;  Entry to procedure
               RTS                      ;PR contents   PC
               MOV          #12,R0      ;MOV executed before branch.
*/

  void SETS() /* SETS */
  {
          S=1;
          PC+=2;
  }
/*
Example

  SETS                         ;Before execution S = 0
                               ;After execution    S = 1
*/

  void SETT()  /* SETT */
  {
           T=1;
           PC+=2;
  }
/*
Example

  SETT                         ;Before execution T = 0
                               ;After execution    T = 1
*/

  void SHAD(int m,int n) /*SHAD Rm,Rn */
  {
          int sgn=R[m] & 0x80000000;
          if (sgn==0)
                 R[n] <<= (R[m] & 0x1F);
          else if ((R[m] & 0x1F) == 0) {
                 if ((R[n] & 0x80000000) == 0)
                          R[n] = 0;
                 else
                          R[n] = 0xFFFFFFFF;
         }
         else
                 R[n]=(long)R[n] >> ((~R[m] & 0x1F)+1);
         PC+=2;
  }
/*
Example

  SHAD       R1,R2          ;Before execution R1 = H'FFFFFFEC, R2 = H'80180000
                            ;After execution    R1 = H'FFFFFFEC, R2 = H'FFFFF801
  SHAD       R3,R4          ;Before execution R3 = H'00000014, R4 = H'FFFFF801
                            ;After execution    R3 = H'00000014, R4 = H'80100000
*/

  void SHAL(long n) /* SHAL Rn (Same as SHLL) */
  {
          if ((R[n]&0x80000000)==0) T=0;
          else T=1;
          R[n]<<=1;
          PC+=2;
  }
/*
Example

  SHAL R0                       ;Before execution R0 = H'80000001, T = 0
                                ;After execution    R0 = H'00000002, T = 1
*/

  void SHAR(long n) /* SHAR Rn */
  {
          //long temp;
          char temp;
          if ((R[n]&0x00000001)==0) T=0;
          else T=1;
          if ((R[n]&0x80000000)==0) temp=0;
          else temp=1;
          R[n]>>=1;
          if (temp==1) R[n]|=0x80000000;
          else R[n]&=0x7FFFFFFF;
          PC+=2;
  }
/*
Example

  SHAR R0                       ;Before execution R0 = H'80000001, T = 0
                                ;After execution    R0 = H'C0000000, T = 1
*/


  void SHLD(int m,int n)/*SHLD Rm,Rn */
  {
       int sgn = R[m] & 0x80000000;
       if (sgn == 0)
                 R[n] <<= (R[m] & 0x1F);
       else if ((R[m] & 0x1F) == 0)
                 R[n] = 0;
       else
                 R[n]=(unsigned)R[n] >> ((~R[m] & 0x1F)+1);
       PC+=2;
  }
/*
Example

  SHLD R1,
                R2          ;Before execution R1 = H'FFFFFFEC,  R2 = H'80180000
                            ;After execution    R1 = H'FFFFFFEC,  R2 = H'00000801
  SHLD R3,
                R4          ;Before execution R3 = H'00000014,  R4 = H'FFFFF801
                            ;After execution    R3 = H'00000014,  R4 = H'80100000
*/

  void SHLL(long n) /* SHLL Rn  (Same as SHAL) */
  {
      if ((R[n]&0x80000000)==0) T=0;
      else T=1;
      R[n]<<=1;
      PC+=2;
  }
/*
Example

  SHLL R0                      ;Before execution R0 = H'80000001, T = 0
                               ;After execution    R0 = H'00000002, T = 1
*/

 void SHLL2(long n) /* SHLL2 Rn */
 {
     R[n]<<=2;
     PC+=2;
 }


 void SHLL8(long n) /* SHLL8 Rn */
 {
     R[n]<<=8;
     PC+=2;
 }


 void SHLL16(long n) /* SHLL16 Rn */
 {
     R[n]<<=16;
     PC+=2;
 }
/*
Example

 SHLL2  R0          ;Before execution R0 = H'12345678
                    ;After execution    R0 = H'48D159E0
 SHLL8  R0          ;Before execution R0 = H'12345678
                    ;After execution    R0 = H'34567800
 SHLL16  R0         ;Before execution R0 = H'12345678
                    ;After execution    R0 = H'56780000
*/


  void SHLR(long n)   /* SHLR Rn */
  {
      if ((R[n]&0x00000001)==0) T=0;
      else T=1;
      R[n]>>=1;
      //R[n]&=0x7FFFFFFF;
      PC+=2;
  }
/*
Example

  SHLR       R0                ;Before execution R0 = H'80000001, T = 0
                               ;After execution    R0 = H'40000000, T = 1
*/

  void SHLR2(long n)          /* SHLR2 Rn */
  {
       R[n]>>=2;
       //R[n]&=0x3FFFFFFF;
       PC+=2;
  }


  void SHLR8(long n)          /* SHLR8 Rn */
  {
       R[n]>>=8;
       //R[n]&=0x00FFFFFF;
       PC+=2;
  }


  void SHLR16(long n)         /* SHLR16 Rn */
  {
       R[n]>>=16;
       //R[n]&=0x0000FFFF;
       PC+=2;
  }
/*
Example

  SHLR2  R0                 ;Before execution R0 = H'12345678
                            ;After execution    R0 = H'048D159E
  SHLR8  R0                 ;Before execution R0 = H'12345678
                            ;After execution    R0 = H'00123456
  SHLR16  R0                ;Before execution R0 = H'12345678
                            ;After execution    R0 = H'00001234
*/

  void SLEEP()    /* SLEEP */
  {
      Sleep_standby();
  }
/*
Example

  SLEEP                      ;Transition to power-down mode
*/

  void STCSR(int n)      /* STC SR,Rn : Privileged */
       {
           R[n]=SR;
           PC+=2;
       }
  void STCGBR(int n)     /* STC GBR,Rn */
       {
           R[n]=SGR;
           PC+=2;
       }
  void STCVBR(int n)     /* STC VBR,Rn : Privileged */
       {
           R[n]=VBR;
           PC+=2;
       }
  void STCSSR(int n)     /* STC SSR,Rn : Privileged */
       {
           R[n]=SSR;
           PC+=2;
       }
  void STCSPC(int n)     /* STC SPC,Rn : Privileged */
       {
           R[n]=SPC;
           PC+=2;
       }
  void STCSGR(int n)     /* STC SGR,Rn : Privileged */
       {
           R[n]=SGR;
           PC+=2;
       }
  void STCDBR(int n)     /* STC DBR,Rn : Privileged */
       {
           R[n]=DBR;
           PC+=2;
       }
  void STCRm_BANK(int n, int m)     /* STC Rm_BANK,Rn : Privileged ; m=07 */
       {
           R[n]=R_BANK[m];
           PC+=2;
       }
  void STCMSR(int n)     /* STC.L SR,@-Rn : Privileged */
       {
           R[n]-=4;
           Write_Long(R[n],SR);
           PC+=2;
       }
  void STCMGBR(int n)     /* STC.L GBR,@Rn */
       {
           R[n]-=4;
           Write_Long(R[n],GBR);
           PC+=2;
       }
  void STCMVBR(int n)     /* STC.L VBR,@-Rn : Privileged */
       {
         R[n]-=4;
         Write_Long(R[n],VBR);
         PC+=2;
       }
  void STCMSSR(int n)     /* STC.L SSR,@-Rn : Privileged */
       {
         R[n]-=4;
         Write_Long(R[n],SSR);
         PC+=2;
       }
  void STCMSPC(int n)     /* STC.L SPC,@-Rn : Privileged */
       {
         R[n]-=4;
         Write_Long(R[n],SPC);
         PC+=2;
       }
  void STCMSGR(int n)     /* STC.L SGR,@-Rn : Privileged */
     {
         R[n]-=4;
         Write_Long(R[n],SGR);
         PC+=2;
     }
  void STCMDBR(int n)     /* STC.L DBR,@-Rn : Privileged */
     {
         R[n]-=4;
         Write_Long(R[n],DBR);
         PC+=2;
     }
  void STCMRm_BANK(int n, int m)     /* STC.L Rm_BANK,@-Rn : Privileged ; m=07 */
  {
           R[n]-=4;
           Write_Long(R[n],R_BANK[m]);
           PC+=2;
  }
  void STSMACH(int n)     /* STS MACH,Rn */
  {
     R[n]=MACH;
     PC+=2;
  }
  void STSMACL(int n)     /* STS MACL,Rn */
  {
     R[n]=MACL;
     PC+=2;
  }
  void STSPR(int n)     /* STS PR,Rn */
  {
     R[n]=PR;
     PC+=2;
  }
  void STSMMACH(int n)     /* STS.L MACH,@-Rn */
  {
     R[n]-=4;
     Write_Long(R[n],MACH);
     PC+=2;
  }
  void STSMMACL(int n)     /* STS.L MACL,@-Rn */
  {
     R[n]-=4;
     Write_Long(R[n],MACL);
     PC+=2;
  }
  void STSMPR(int n)     /* STS.L PR,@-Rn */
  {
     R[n]-=4;
     Write_Long(R[n],PR);
     PC+=2;
  }
/*
Example

  STS MACH,R0                 ; Before execution    R0 = H'FFFFFFFF, MACH = H'00000000
                              ; After execution     R0 = H'00000000
  STS.L PR,@-R15              ; Before execution    R15 = H'10000004
                              ; After execution     R15 = H'10000000, (R15) = PR
*/

  void STS(int n)           /* STS FPUL,Rn  */
  {
       R[n]= (LONG)FPUL;
       PC+=2;
  }
  void STS_SAVE(int n)     /* STS.L FPUL,@-Rn  */
  {
       R[n]-=4;
       Write_Long(R[n], (LONG)FPUL) ;
       PC+=2;
  }
  void STS_FPSCR(int n)          /* STS FPSCR,Rn  */
  {
       R[n]=FPSCR&0x003FFFFF;
       PC+=2;
  }
  void STS_RESTORE(int n)  /* STS.L FPSCR,@-Rn  */
  {
       R[n]-=4;
       Write_Long(R[n],FPSCR&0x003FFFFF);
       PC+=2;
  }


  void SUB(long m, long n) /* SUB Rm,Rn */
  {
     R[n]-=R[m];
     PC+=2;
  }
/*
Example

  SUB        R0,R1               ;Before execution R0 = H'00000001, R1 = H'80000000
                                 ;After execution    R1 = H'7FFFFFFF
*/

  void SUBC(long m, long n) /* SUBC Rm,Rn */
  {
       unsigned long tmp0,tmp1;
       tmp1=R[n]-R[m];
       tmp0=R[n];
       R[n]=tmp1-T;
       if (tmp0<tmp1) T=1;
       else T=0;
       if (tmp1<R[n]) T=1;
       PC+=2;
  }
/*
Example

  CLRT                        ;R0:R1(64 bits)  R2:R3(64 bits) = R0:R1(64 bits)
  SUBC       R3,R1            ;Before execution T = 0, R1 = H'00000000, R3 = H'00000001
                              ;After execution    T = 1, R1 = H'FFFFFFFF
  SUBC       R2,R0            ;Before execution T = 1, R0 = H'00000000, R2 = H'00000000
                              ;After execution    T = 1, R0 = H'FFFFFFFF
*/

  void SUBV(long m, long n) /* SUBV Rm,Rn */
  {
       long dest,src,ans;
       if ((long)R[n]>=0) dest=0;
       else dest=1;
       if ((long)R[m]>=0) src=0;
       else src=1;
       src+=dest;
       R[n]-=R[m];
       if ((long)R[n]>=0) ans=0;
       else ans=1;
       ans+=dest;
       if (src==1) {
            if (ans==1) T=1;
            else T=0;
       }
       else T=0;
       PC+=2;
  }
/*
Example

  SUBV     R0,R1            ;Before execution R0 = H'00000002, R1 = H'80000001
                            ;After execution    R1 = H'7FFFFFFF, T = 1
  SUBV     R2,R3            ;Before execution R2 = H'FFFFFFFE, R3 = H'7FFFFFFE
                            ;After execution    R3 = H'80000000, T = 1
*/

  void SWAPB(long m, long n)      /* SWAP.B Rm,Rn */
  {
     unsigned long temp0,temp1;
     temp0=R[m]&0xFFFF0000;
     temp1=(R[m]&0x000000FF)<<8;
     R[n]=(R[m]&0x0000FF00)>>8;
     R[n]=R[n]|temp1|temp0;
     PC+=2;
  }


  void SWAPW(long m, long n)      /* SWAP.W Rm,Rn */
  {
     unsigned long temp;
     temp=(R[m]>>16)&0x0000FFFF;
     R[n]=R[m]<<16;
     R[n]|=temp;
     PC+=2;
  }
/*
Example

  SWAP.B     R0,R1          ;Before execution R0 = H'12345678
                            ;After execution    R1 = H'12347856
  SWAP.W     R0,R1          ;Before execution R0 = H'12345678
                            ;After execution    R1 = H'56781234
*/

  void TAS(int n) /* TAS.B @Rn */
  {
       int temp;
       temp=(int)Read_Byte(R[n]); /* Bus Lock */
       if (temp==0) T=1;
       else T=0;
       temp|=0x00000080;
       Write_Byte(R[n],temp);     /* Bus unlock */
       PC+=2;
  }

  void TRAPA(int i) /* TRAPA #imm */
  {
       int imm;
       //imm=(0x000000FF & i);
       //*TRA=imm<<2;
       *TRA=i<<2;
       SSR=SR;
       SPC=PC+2;
        /* pas optimise
       SR.MD=1;  30
       SR.BL=1;  28
       SR.RB=1;  29
        */
       SR|=0x70000000;
       *EXPEVT=0x00000160;
       PC=VBR+0x00000100;
  }
  void TST(long m, long n) /* TST Rm,Rn */
  {
       if ((R[n]&R[m])==0) T=1;
       else T=0;
       PC+=2;
  }


  void TSTI(long i) /* TST #imm,R0 */
  {
       long temp;
       //temp=R[0]&(0x000000FF & (long)i);
       temp=R[0]&i;
       if (temp==0) T=1;
       else T=0;
       PC+=2;
  }
 void TSTM(long i) /* TST.B #imm,@(R0,GBR) */
 {
      long temp;
      temp=(long)Read_Byte(GBR+R[0]);
      //temp&=(0x000000FF & (long)i);
      temp&=i;
      if (temp==0) T=1;
      else T=0;
      PC+=2;
 }
/*
Example

 TST       R0,R0           ;Before execution R0 = H'00000000
                           ;After execution    T = 1
 TST       #H'80,R0        ;Before execution R0 = H'FFFFFF7F
                           ;After execution    T = 1
 TST.B #H'A5,@(R0,GBR) ;Before execution (R0,GBR) = H'A5
                           ;After execution    T = 0
*/

  void XOR(long m, long n) /* XOR Rm,Rn */
  {
       R[n]^=R[m];
       PC+=2;
  }


  void XORI(long i)  /* XOR #imm,R0 */
  {
       //R[0]^=(0x000000FF & (long)i);
       R[0]^= i;
       PC+=2;
  }


  void XORM(long i)  /* XOR.B #imm,@(R0,GBR) */
  {
       int temp;
       temp=(long)Read_Byte(GBR+R[0]);
       //temp^=(0x000000FF &(long)i);
       temp^=i;
      Write_Byte(GBR+R[0],temp);
      PC+=2;
 }
/*
Example

 XOR R0,R1                ;Before execution R0 = H'AAAAAAAA, R1 = H'55555555
                          ;After execution    R1 = H'FFFFFFFF
 XOR #H'F0,R0             ;Before execution R0 = H'FFFFFFFF
                          ;After execution    R0 = H'FFFFFF0F
 XOR.B #H'A5,@(R0,GBR) ;Before execution (R0,GBR) = H'A5
                          ;After execution    (R0,GBR) = H'00
*/


  void XTRCT(long m, long n)     /* XTRCT Rm,Rn */
  {
       unsigned long temp;
       temp=(R[m]<<16)&0xFFFF0000;
       R[n]=(R[n]>>16)&0x0000FFFF;
       R[n]|=temp;
       PC+=2;
  }
/*
Example

  XTRCT R0,R1                   ;Before execution R0 = H'01234567, R1 = H'89ABCDEF
                                ;After execution    R1 = H'456789AB
*/




