/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"
#include <stdio.h>

#define PowerOn 1
#define Manual 0
//Longword access to TEA can be performed from H'FF00 000C in the P4 area
//and H'1F00 000C in area 7.
#define EXCEPTION_ADDRESS 0xff00000c
#define PAGE_NUMBER 0x1
//PTEH_VPN  (p 43)

unsigned char read_access;
long imm;
long pre_execution_break;
void Initialize_CPU()
{

}
void Initialize_Module(unsigned char initmode)
{

}

  void Power_on_reset()
  {
   if (RamAlloc==0)
   {
          ROMNAME=NULL;
          mem_map_reg();
          create_on_chip_ram();
          create_ram();
   }
          *EXPEVT = 0;
          VBR ^= VBR;
/*
          MD = 1;
          RB = 1;
          BL = 1;
	  IM = 15;
          FD = 0;
*/
          Initialize_CPU();
          Initialize_Module(PowerOn);
          PC = 0xA0000000;
          SR = 0x700000F0;
          FPSCR=0x00040001;
  }
  void Manual_reset()
  {
          *EXPEVT = 0x00000020;
          VBR = 0x00000000;
          MD = 1;
          RB = 1;
          BL = 1;
          IM = 15;
          FD = 0;
          Initialize_CPU();
          Initialize_Module(Manual);
          PC = 0xA0000000;
  }
  void Hitachi_UDI_reset()
  {
          *EXPEVT ^= *EXPEVT;
          VBR ^= VBR;
          MD = 1;
          RB = 1;
          BL = 1;
          IM = 15;
          FD = 0;
          Initialize_CPU();
          Initialize_Module(PowerOn);
          PC = 0xA0000000;
  }
  void TLB_multi_hit()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          *EXPEVT = 0x00000140;
          VBR = 0x00000000;
          MD = 1;
          RB = 1;
          BL = 1;
          IM = 15;
          FD = 0;
          Initialize_CPU();
          Initialize_Module(Manual);
          PC = 0xA0000000;
  }
  void Data_TLB_miss_exception()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          SPC = PC;
          SSR = SR;
          *EXPEVT = read_access ? 0x00000040 : 0x00000060;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000400;
  }
  void ITLB_miss_exception()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x00000040;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000400;
  }
  void Initial_write_exception()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x00000080;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void Data_TLB_protection_violation_exception()
  {
             *TEA = EXCEPTION_ADDRESS;
             PTEH_VPN = PAGE_NUMBER;
             SPC = PC;
             SSR = SR;
             *EXPEVT = read_access ? 0x000000A0 : 0x000000C0;
             MD = 1;
             RB = 1;
             BL = 1;
             PC = VBR + 0x00000100;
  }
  void ITLB_protection_violation_exception()
  {
            *TEA = EXCEPTION_ADDRESS;
            PTEH_VPN = PAGE_NUMBER;
            SPC = PC;
            SSR = SR;
            *EXPEVT = 0x000000A0;
            MD = 1;
            RB = 1;
            BL = 1;
            PC = VBR + 0x00000100;
  }
  void Data_address_error()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          SPC = PC;
          SSR = SR;
          *EXPEVT = read_access? 0x000000E0: 0x00000100;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void Instruction_address_error()
  {
          *TEA = EXCEPTION_ADDRESS;
          PTEH_VPN = PAGE_NUMBER;
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x000000E0;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void TRAPA_exception()
  {
          SPC = PC + 2;
          SSR = SR;
          *TRA = imm << 2;
          *EXPEVT = 0x00000160;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void General_illegal_instruction_exception()
  {
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x00000180;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void Slot_illegal_instruction_exception()
  {
          SPC = PC - 2;
          SSR = SR;
          *EXPEVT = 0x000001A0;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void General_fpu_disable_exception()
  {
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x00000800;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void Slot_fpu_disable_exception()
  {
          SPC = PC - 2;
          SSR = SR;
          *EXPEVT = 0x00000820;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
/*
  void User_break_exception()
  {
          SPC = (pre_execution_break? PC : PC + 2);
          SSR = SR;
          *EXPEVT = 0x000001E0;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = (BRCR.UBDE==1 ? DBR : VBR + 0x00000100);
  }
*/
  void FPU_exception()
  {
          SPC = PC;
          SSR = SR;
          *EXPEVT = 0x00000120;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000100;
  }
  void NMI()
  {
          SPC = PC;
          SSR = SR;
          *INTEVT = 0x000001C0;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000600;
  }
/*
  void IRL()
  {
          SPC = PC;
          SSR = SR;
          INTEVT = 0x00000200 ~ 0x000003C0;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000600;
  }

  void Module_interruption()
  {
          SPC = PC;
          SSR = SR;
          INTEVT = 0x00000400 ~ 0x00000760;
          MD = 1;
          RB = 1;
          BL = 1;
          PC = VBR + 0x00000600;
  }
*/


int allocate_operand_cache_block(int n)
{
 printf("%x ",PC);
 printf("NYI allocate_operand_cache_block\n");
 return 0;
}
void Delay_Slot(unsigned long Addr)
{
 volatile unsigned long PC_SAVE;
 WORD DB_instr;
 PC_SAVE=PC;
 //assume no branch 
 DB_instr=Read_Word(Addr);
 OPCALL(DB_instr);
 PC=PC_SAVE;
}
void fpu_exception_trap(void)
{
 printf("%x ",PC);
 printf("NYI fpu_exception_trap\n");
}
int invalidate_operand_cache_block(int n)
{
 printf("%x ",PC);
 printf("NYI invalidate_operand_cache_block\n");
 return 0;
}
void inexact()
{
 printf("%x ",PC);
 printf("NYI inexact\n");
}
int is_write_back_memory(int n)
{
 printf("%x ",PC);
 printf("NYI is_write_back_memory\n");
 return 0;
}
int is_dirty_block(int n)
{
 printf("%x ",PC);
 printf("NYI is_dirty_block\n");
 return 0;
}
int look_up_in_operand_cache(int n)
{
 printf("%x ",PC);
 printf("NYI look_up_in_operand_cache\n");
 return 0;
}
void Sleep_standby()
{
 printf("%x ",PC);
 printf("NYI Sleep_standby\n");
}
void undefined_operation()
{
 printf("%x ",PC);
 printf("NYI undefined_operation\n");
}
int write_back(int n)
{
 printf("%x ",PC);
 printf("NYI write_back\n");
 return 0;
}
