/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include <math.h>
#include "extern.h"

int fcmp_chk (int m,int n);
  int sign_of(int n)
  {
        return(FR_HEX[n]>>31);
  }
  int data_type_of(int n)
  {
  int abs;
       abs = FR_HEX[n] & 0x7fffffff;
       if(FPSCR_PR == 0) { /* Single-precision */
           if(abs < 0x00800000){
               if((FPSCR_DN == 1) || (abs == 0x00000000)){
                   if(sign_of(n) == 0)  {zero(n, 0); return(PZERO);}
                   else                 {zero(n, 1); return(NZERO);}
               }
               else                     return(DENORM);
           }
           else if(abs < 0x7f800000)    return(NORM);
           else if(abs == 0x7f800000) {
               if(sign_of(n) == 0)      return(PINF);
               else                     return(NINF);
           }
           else if(abs < 0x7fc00000)    return(qNaN);
         else                         return(sNaN);
     }
     else {      /* Double-precision */
         if(abs < 0x00100000){
             if ((FPSCR_DN == 1) ||
                   (abs == 0x00000000) &&
                   (FR_HEX[n+1] == 0x00000000))
                   {
                 if(sign_of(n) == 0)  {zero(n, 0); return(PZERO);}
                 else                 {zero(n, 1); return(NZERO);}
            }
            else                 return(DENORM);
         }
         else if(abs < 0x7ff00000) return(NORM);
         else if((abs == 0x7ff00000) &&
                 (FR_HEX[n+1] == 0x00000000)) {
             if(sign_of(n) == 0) return(PINF);
             else                return(NINF);
             }
             else if(abs < 0x7ff80000) return(qNaN);
         else                      return(sNaN);
     }
}
void register_copy(int m,int n)
{
                         FR[n]   = FR[m];
     if(FPSCR_PR == 1)   FR[n+1] = FR[m+1];
}
void normal_faddsub(int m,int n,int type)
{
union {
     float f;
     int l;
}   dstf,srcf;
union {
     double d;
     int l[2];
}   dstd,srcd;
union {             /* "long double" format:   */
       long double x;   /*   1-bit sign      */
       int l[4];       /*  15-bit exponent  */
  }   dstx;           /*  112-bit mantissa   */
       if(FPSCR_PR == 0) {
           if(type == FADD)     srcf.f =  FR[m];
           else                    srcf.f = -FR[m];
           dstd.d = FR[n]; /* Conversion from single-precision to double-precision */
           dstd.d += srcf.f;
           if(((dstd.d == FR[n]) && (srcf.f != 0.0)) ||
               ((dstd.d == srcf.f) && (FR[n] != 0.0))) {
               set_I();
               if(sign_of(m)^ sign_of(n)) {
                   dstd.l[1] -= 1;
                   if(dstd.l[1] == 0xffffffff) dstd.l[0] -= 1;
               }
           }
           if(dstd.l[1] & 0x1fffffff) set_I();
           dstf.f += srcf.f; /* Round to nearest */
           if(FPSCR_RM == 1) {
               dstd.l[1] &= 0xe0000000; /* Round to zero */
               dstf.f = dstd.d;
           }
           check_single_exception(&FR[n],dstf.f);
       }else {
           if(type == FADD)  srcd.d =  DR[m>>1];
           else              srcd.d = -DR[m>>1];
           dstx.x = DR[n>>1];
                        /* Conversion from double-precision to extended double-precision */
           dstx.x += srcd.d;
           if(((dstx.x == DR[n>>1]) && (srcd.d != 0.0)) ||
               ((dstx.x == srcd.d) && (DR[n>>1] != 0.0)) ) {
               set_I();
               if(sign_of(m)^ sign_of(n)) {
                   dstx.l[3] -= 1;
                   if(dstx.l[3] == 0xffffffff) {dstx.l[2] -= 1;
                   if(dstx.l[2] == 0xffffffff) {dstx.l[1] -= 1;
                   if(dstx.l[1] == 0xffffffff) {dstx.l[0] -= 1;}}}
             }
         }
         if((dstx.l[2] & 0x0fffffff) || dstx.l[3]) set_I();
         dstd.d += srcd.d; /* Round to nearest */
         if(FPSCR_RM == 1) {
             dstx.l[2] &= 0xf0000000; /* Round to zero */
             dstx.l[3]  = 0x00000000;
             dstd.d = dstx.x;
         }
         check_double_exception(&DR[n>>1] ,dstd.d);
     }
}
  void normal_fsqrt(int n)
  {
  union {
        float f;
        int l;
  }    dstf,tmpf;
  union {
        double d;
        int l[2];
  }    dstd,tmpd;
  union {
        long double x;
        int l[4];
  }    tmpx;
        if(FPSCR_PR == 0) {
           tmpf.f = FR[n]; /* save destination value */
           dstf.f = sqrt(FR[n]); /* round toward nearest or even */
           tmpd.d = dstf.f; /* convert single to double */
           tmpd.d *= dstf.f;
           if(tmpf.f != tmpd.d) set_I();
           if((tmpf.f < tmpd.d) && (FPSCR_RM == 1))
               dstf.l -= 1; /* round toward zero */
           if(FPSCR & ENABLE_I) fpu_exception_trap();
           else                    FR[n] = dstf.f;
        }else {
           tmpd.d = DR[n>>1]; /* save destination value */
           dstd.d = sqrt(DR[n>>1]); /* round toward nearest or even */
           tmpx.x = dstd.d; /* convert double to int double */
           tmpx.x *= dstd.d;
           if(tmpd.d != tmpx.x) set_I();
           if((tmpd.d < tmpx.x) && (FPSCR_RM == 1)) {
               dstd.l[1] -= 1; /* round toward zero */
               if(dstd.l[1] == 0xffffffff) dstd.l[0] -= 1;
           }
           if(FPSCR & ENABLE_I) fpu_exception_trap();
           else                    DR[n>>1] = dstd.d;
        }
  }
void normal_fdiv(int m,int n)
{
union {
      float f;
      int l;
}    dstf,tmpf;
union {
      double d;
      int l[2];
}    dstd,tmpd;
union {
      long double x;
      int l[4];

  }    tmpx;
       if(FPSCR_PR == 0) {
           tmpf.f = FR[n]; /* save destination value */
           dstf.f /= FR[m]; /* round toward nearest or even */
           tmpd.d = dstf.f; /* convert single to double */
           tmpd.d *= FR[m];
           if(tmpf.f != tmpd.d) set_I();
           if((tmpf.f < tmpd.d) && (FPSCR_RM == 1))
               dstf.l -= 1; /* round toward zero */
            check_single_exception(&FR[n], dstf.f);
       }else {
           tmpd.d = DR[n>>1]; /* save destination value */
           dstd.d /= DR[m>>1]; /* round toward nearest or even */
           tmpx.x = dstd.d; /* convert double to int double */
           tmpx.x *= DR[m>>1];
           if(tmpd.d != tmpx.x) set_I();
           if((tmpd.d < tmpx.x) && (FPSCR_RM == 1)) {
               dstd.l[1] -= 1; /* round toward zero */
               if(dstd.l[1] == 0xffffffff) dstd.l[0] -= 1;
           }
           check_double_exception(&DR[n>>1], dstd.d);
       }
  }

void normal_fmul(int m,int n)
{
union {
     float f;
     int l;
}   tmpf;
union {
     double d;
     int l[2];
}   tmpd;
union {
     long double x;
     int l[4];
}   tmpx;
     if(FPSCR_PR == 0) {
         tmpd.d = FR[n]; /* Single-precision to double-precision */
         tmpd.d *= FR[m]; /* Precise creation */
         tmpf.f *= FR[m]; /* Round to nearest */
         if(tmpf.f != tmpd.d) set_I();
         if((tmpf.f > tmpd.d) && (FPSCR_RM == 1)) {
             tmpf.l -= 1; /* Round to zero */
         }
         check_single_exception(&FR[n],tmpf.f);
     }else {
         tmpx.x = DR[n>>1]; /* Single-precision to double-precision */
           tmpx.x *= DR[m>>1]; /* Precise creation */
           tmpd.d *= DR[m>>1]; /* Round to nearest */
           if(tmpd.d != tmpx.x) set_I();
           if((tmpd.d > tmpx.x) && (FPSCR_RM == 1)) {
               tmpd.l[1] -= 1; /* Round to zero */
               if(tmpd.l[1] == 0xffffffff) tmpd.l[0] -= 1;
           }
           check_double_exception(&DR[n>>1], tmpd.d);
       }
  }
  void fipr(int m,int n)
  {
  char i;
  union {
       double d;
       int l[2];
  }   mlt[4];
  float dstf;
       if((data_type_of(m) == sNaN) || (data_type_of(n) == sNaN) ||
           (data_type_of(m+1) == sNaN) || (data_type_of(n+1) == sNaN) ||
           (data_type_of(m+2) == sNaN) || (data_type_of(n+2) == sNaN) ||
           (data_type_of(m+3) == sNaN) || (data_type_of(n+3) == sNaN) ||
           (check_product_invalid(m,n)) ||
           (check_product_invalid(m+1,n+1)) ||
           (check_product_invalid(m+2,n+2)) ||
           (check_product_invalid(m+3,n+3)) )   invalid(n+3);
       else if((data_type_of(m) == qNaN)|| (data_type_of(n) == qNaN)||
           (data_type_of(m+1) == qNaN) || (data_type_of(n+1) == qNaN) ||
           (data_type_of(m+2) == qNaN) || (data_type_of(n+2) == qNaN) ||
           (data_type_of(m+3) == qNaN) || (data_type_of(n+3) == qNaN))
  qnan(n+3);
/*
       else if (check_positive_infinity() &&
               check_negative_infinity())       invalid(n+3);
       else if (check_positive_infinity())        inf(n+3,0);
       else if (check_negative_infinity())        inf(n+3,1);
*/
       else {
           for(i=0;i<4;i++) {
               /* If FPSCR_DN == 1, zeroize */
               if     (data_type_of(m+i) == PZERO)  FR[m+i] = +0.0;
             else if(data_type_of(m+i) == NZERO)  FR[m+i] = -0.0;
             if     (data_type_of(n+i) == PZERO)  FR[n+i] = +0.0;
             else if(data_type_of(n+i) == NZERO)  FR[n+i] = -0.0;
             mlt[i].d = FR[m+i];
              mlt[i].d *= FR[n+i];

     /* To be precise, with FIPR, the lower 18 bits are discarded; therefore, this description
        is simplified, and differs from the hardware. */
         mlt[i].l[1] &= 0xff000000;
         mlt[i].l[1] |= 0x00800000;
         }
         mlt[0].d += mlt[1].d + mlt[2].d + mlt[3].d;
         mlt[0].l[1] &= 0xff800000;
         dstf = mlt[0].d;
         set_I();
         check_single_exception(&FR[n+3],dstf);
     }
}
void check_single_exception(float *dst,float result)
{
union {
     float f;
     int l;
}   tmp;
float abs;
     if(result < 0)  tmp.l = 0xff800000; /*  infinity */
     else              tmp.l = 0x7f800000; /* + infinity */
     if(result == tmp.f) {
         set_O(); set_I();
         if(FPSCR_RM == 1)                    {
             tmp.l -= 1; /* Maximum value of normalized number */
             result = tmp.f;
         }
     }
     if(result < 0)  abs = -result;
     else              abs =  result;
     tmp.l = 0x00800000; /* Minimum value of normalized number */


       if(abs < tmp.f) {
           if((FPSCR_DN == 1) && (abs != 0.0)) {
               set_I();
               if(result < 0) result = -0.0; /* Zeroize denormalized number */
               else             result =  0.0;
           }
           if(FPSCR_I == 1) set_U();
       }
       if(FPSCR & ENABLE_OUI) fpu_exception_trap();
       else                    *dst = result;
  }
  void check_double_exception(double *dst,double result)
  {
  union {
       double d;
       int l[2];
  }   tmp;
  double abs;
       if(result < 0)  tmp.l[0] = 0xfff00000; /*  infinity */
       else              tmp.l[0] = 0x7ff00000; /* + infinity */
                         tmp.l[1] = 0x00000000;
       if(result == tmp.d)
       {
           set_O(); set_I();
           if(FPSCR_RM == 1) {
               tmp.l[0] -= 1;
               tmp.l[1] = 0xffffffff;
               result = tmp.d; /* Maximum value of normalized number */
           }
       }
       if(result < 0)  abs = -result;
       else              abs =  result;
       tmp.l[0] = 0x00100000; /* Minimum value of normalized number */
       tmp.l[1] = 0x00000000;
       if(abs < tmp.d) {
           if((FPSCR_DN == 1) && (abs != 0.0)) {
               set_I();
               if(result < 0) result = -0.0;
                           /* Zeroize denormalized number */
             else             result =  0.0;
         }
         if(FPSCR_I == 1) set_U();
     }
     if(FPSCR & ENABLE_OUI) fpu_exception_trap();
     else                    *dst = result;
}
int check_product_invalid(int m,int n)
{
     return(check_product_infinity(m,n)  &&
           ((data_type_of(m) == PZERO) || (data_type_of(n) == PZERO) ||
            (data_type_of(m) == NZERO) || (data_type_of(n) == NZERO)));
}
int check_product_infinity(int m,int n)
{
     return((data_type_of(m) == PINF) || (data_type_of(n) == PINF) ||
            (data_type_of(m) == NINF) || (data_type_of(n) == NINF));
}
int check_positive_infinity(int m,int n)
{
     return(((check_product_infinity(m,n) &&
             (~sign_of(m)^sign_of(n))) ||
            ((check_product_infinity(m+1,n+1) &&
             (~sign_of(m+1)^sign_of(n+1))) ||
            ((check_product_infinity(m+2,n+2) &&
             (~sign_of(m+2)^sign_of(n+2))) ||
            ((check_product_infinity(m+3,n+3) &&
             (~sign_of(m+3)^sign_of(n+3))))))));
}
int check_negative_infinity(int m,int n)
{
  return(((check_product_infinity(m,n) && (sign_of(m)^ sign_of(n))) ||
     ((check_product_infinity(m+1,n+1) && (sign_of(m+1)^
sign_of(n+1))) ||
     ((check_product_infinity(m+2,n+2) && (sign_of(m+2)^
sign_of(n+2))) ||
     ((check_product_infinity(m+3,n+3) && (sign_of(m+3)^
sign_of(n+3))))))));


}
  void clear_cause () {FPSCR &= ~CAUSE;}
  void set_E() {FPSCR |= SET_E; fpu_exception_trap();}
  void set_V() {FPSCR |= SET_V;}
  void set_Z() {FPSCR |= SET_Z;}
  void set_O() {FPSCR |= SET_O;}
  void set_U() {FPSCR |= SET_U;}
  void set_I() {FPSCR |= SET_I;}
  void invalid(int n)
  {
       set_V();
       if((FPSCR & ENABLE_V) == 0 ) qnan(n);
       else    fpu_exception_trap();
  }
  void dz(int n,int sign)
  {
       set_Z();
       if((FPSCR & ENABLE_Z) == 0 ) inf(n,sign);
       else    fpu_exception_trap();
  }
  void zero(int n,int sign)
  {
       if(sign == 0)    FR_HEX [n]   = 0x00000000;
       else             FR_HEX [n]   = 0x80000000;
       if (FPSCR_PR==1) FR_HEX [n+1] = 0x00000000;
  }
  void inf(int n,int sign) {
       if (FPSCR_PR==0) {
           if(sign == 0)  FR_HEX [n]   = 0x7f800000;
           else           FR_HEX [n]   = 0xff800000;
       }else {
           if(sign == 0)  FR_HEX [n]   = 0x7ff00000;
           else           FR_HEX [n]   = 0xfff00000;
                          FR_HEX [n+1] = 0x00000000;
       }
  }
  void qnan(int n)
  {
       if (FPSCR_PR==0)  FR[n]   = 0x7fbfffff;
       else {           FR[n]   = 0x7ff7ffff;
                         FR[n+1] = 0xffffffff;
       }
  }

void FABS(int n)
{
  if(FPSCR_PR == 0)
  {
        //(int)FR[n]&=0x7fffffff;
	if (FR[n]<0) FR[n]=-FR[n];
  }
  else
  {
        //(long long)DR[n>>1]&=0x7fffffffffffffff;
	  if (DR[n>>1]<0) DR[n>>1]=-DR[n>>1];
  }
        PC += 2;
}

void FLADD(int m,int n)
{
          PC += 2;
          clear_cause();
          if((data_type_of(m) == sNaN) || (data_type_of(n) == sNaN)) invalid(n);
          else if((data_type_of(m) == qNaN) || (data_type_of(n) == qNaN)) qnan(n);
          else if((data_type_of(m) == DENORM) || (data_type_of(n) == DENORM)) set_E();
          else switch (data_type_of(m))
          {
           case NORM:
           {
              switch (data_type_of(n))
              {
                  case NORM:    normal_faddsub(m,n,FADD); break;
                  case PZERO:
                  case NZERO:register_copy(m,n); break;
                  default:      break;
              }
              break;
           }
           case PZERO:
           {
                switch (data_type_of(n))
                {
                  case NZERO:   zero(n,0); break;
                  default:      break;
                }

           break;
           }
           case NZERO:    break;
           case PINF:
           {
                switch (data_type_of(n))
                {
                  case NINF:     invalid(n);     break;
                  default:       inf(n,0);       break;
           }
           break;
           }
           case NINF:
           {
           switch (data_type_of(n))
           {
               case PINF:     invalid(n);     break;
               default:       inf(n,1);       break;
           }
           break;
           }
  }
}


  void FCMP_EQ(int m,int n) /* FCMP/EQ  FRm,FRn */
  {
          PC += 2;
          clear_cause();
          if(fcmp_chk (m,n) == INVALID) fcmp_invalid();
          else if(fcmp_chk (m,n) == EQ)  T = 1;
          else                           T = 0;
  }
  void FCMP_GT(int m,int n) /* FCMP/GT  FRm,FRn */
  {
          PC += 2;
          clear_cause();
          if ((fcmp_chk (m,n) == INVALID) ||
               (fcmp_chk (m,n) == UO)) fcmp_invalid();
          else if(fcmp_chk (m,n) == GT)  T = 1;
          else                           T = 0;
  }
  int fcmp_chk (int m,int n)
  {
       if((data_type_of(m) == sNaN) ||
          (data_type_of(n) == sNaN))        return(INVALID);
       else if((data_type_of(m) == qNaN) ||
                 (data_type_of(n) == qNaN))      return(UO);
       else switch(data_type_of(m))
	   {
             case NORM:
				 switch(data_type_of(n))
				 {
                   case PINF   :return(GT);  break;
                   case NINF   :return(LT);  break;
                   default:                  break;
				 }
				 break;
             case PZERO:
             case NZERO:
				 switch(data_type_of(n))
				 {
                   case PZERO  :
                   case NZERO  :return(EQ);  break;
                   default:                  break;
				 }
				 break;
             case PINF :
				 switch(data_type_of(n))
				 {
                   case PINF   :return(EQ);  break;
                   default:return(LT);       break;
				 }
				 break;
             case NINF :
				 switch(data_type_of(n))
				 {
                   case NINF   :return(EQ);  break;
                   default:return(GT);       break;
				 }
				 break;
       }

       if(FPSCR_PR == 0)
	   {
           if(FR[n] == FR[m])           return(EQ);
           else if(FR[n] > FR[m])       return(GT);
           else                         return(LT);
       }
	   else
	   {
           if(DR[n>>1] == DR[m>>1])     return(EQ);
           else if(DR[n>>1] > DR[m>>1]) return(GT);
           else                         return(LT);
       }

  }
  void fcmp_invalid()
  {
   set_V();
   if((FPSCR & ENABLE_V) == 0)  T = 0;
   else fpu_exception_trap();
  }

     void FCNVDS(int m)
     {
          switch (FPSCR_PR)
          {
             case  0:  undefined_operation();break;   /* reserved */
             case  1:  fcnvds(m);  break;  /* FCNVDS */
          }
     }
     void fcnvds(int m)
     {
          PC += 2;
          clear_cause();
          switch (data_type_of(m))
          {
              case NORM  :
              case PZERO :
              case NZERO :    normal_fcnvds(m);  break;
              case DENORM : set_E();
              case PINF  :    FPUL = 0x7f800000; break;
              case NINF  :    FPUL = 0xff800000; break;
              case qNaN  :    FPUL = (float)0x7fbfffff; break;
              case sNaN  :     set_V();
                          if((FPSCR & ENABLE_V) == 0) FPUL = (float)0x7fbfffff;
                          else fpu_exception_trap();   break;
          }
  }
  void normal_fcnvds(int m)
  {
  //int sign;
  //float abs;
  union {
        float f;
        int l;
  }    dstf;
  union {
        double d;
        int l[2];
  }    dstd;
        dstd.d = DR[m>>1];
        if(dstd.l[1] & 0x1fffffff) set_I();
        if(FPSCR_RM == 1) dstd.l[1] &= 0xe0000000; /* round toward zero*/
        dstf.f = (float)dstd.d;
        check_single_exception(&FPUL, dstf.f);
  }
  void FCNVSD(int n)
  {
          PC += 2;
          clear_cause();
          switch (FPSCR_PR){
               case 0:  undefined_operation();    /* reserved */
               case 1:  fcnvsd (n);  break;  /* FCNVSD */
          }
  }
     void fcnvsd(int n)
     {
          switch (fpul_type())
          {
              case PZERO :
              case NZERO :
              case PINF  :
              case NINF  :                     DR[n>>1] = FPUL;        break;
              case DENORM : set_E();                          break;
              case qNaN  :                     qnan(n);       break;
              case sNaN  :                     invalid(n);              break;
          }
     }
  int fpul_type()
  {
  int abs;
       abs = (long)FPUL & 0x7fffffff;
       if(abs < 0x00800000){
           if((FPSCR_DN == 1) || (abs == 0x00000000)){
               if(((LONG)FPUL>>31) == 0) return(PZERO);
               else                  return(NZERO);
           }
           else                      return(DENORM);
       }
       else if(abs < 0x7f800000) return(NORM);
       else if(abs == 0x7f800000) {
               if(((LONG)FPUL>>31) == 0) return(PINF);
               else               return(NINF);
       }
       else if(abs < 0x7fc00000)  return(qNaN);
       else                       return(sNaN);
  }

     void FDIV(int m,int n)     /* FDIV FRm,FRn */
     {
          PC += 2;
          clear_cause();
          if((data_type_of(m) == sNaN) ||
             (data_type_of(n) == sNaN)) invalid(n);
          else if((data_type_of(m) == qNaN) ||
                  (data_type_of(n) == qNaN)) qnan(n);
          else switch (data_type_of(m)){
              case NORM: switch (data_type_of(n)){
                  case PINF:
                  case NINF:    inf(n,sign_of(m)^sign_of(n));break;
                  case PZERO:
                  case NZERO:   zero(n,sign_of(m)^sign_of(n));break;
                  case DENORM:set_E();           break;
                  default:    normal_fdiv(m,n);  break;
                  }   break;
         case PZERO: switch (data_type_of(n)){
             case PZERO:
             case NZERO: invalid(n);break;
             case PINF:
             case NINF:  break;
             default:      dz(n,sign_of(m)^sign_of(n));break;
                }    break;
         case NZERO: switch (data_type_of(n)){
             case PZERO:
             case NZERO:  invalid(n);  break;
             case PINF:   inf(n,1);    break;
             case NINF:   inf(n,0);    break;
             default:     dz(n,sign_of(m)^sign_of(n)); break;
             }    break;
         case DENORM:     set_E();     break;
         case PINF :
         case NINF : switch (data_type_of(n)){
             case DENORM: set_E(); break;
             case PINF:
             case NINF: invalid(n);     break;
             default:   zero(n,sign_of(m)^sign_of(n));break;
             }   break;
         }
}
  void FIPR(int m,int n)   /* FIPR FVm,FVn */
  {
       if(FPSCR_PR == 0) {
           PC += 2;
           clear_cause();
           fipr(m,n);
       }
       else    undefined_operation();
  }
     void FLDI0(int n)
     {
          FR[n] = 0x00000000;
          PC += 2;
     }
  void FLDI1(int n)
  {
       FR[n] = 0x3F800000;
       PC += 2;
  }
  void FLDS(int m)
  {
       FPUL = FR[m];
       PC += 2;
  }

  void FPUFLOAT(int n)
  {
  union {
       double d;
       int l[2];
  }   tmp;
       PC += 2;
       clear_cause();
       if(FPSCR_PR==0){
           FR[n] = FPUL; /* convert from integer to float */
           tmp.d = FPUL;
           if(tmp.l[1] & 0x1fffffff) inexact();
       }else {
           DR[n>>1] = FPUL; /* convert from integer to double */
       }
  }
     void FMAC(int m,int n)
     {
          PC += 2;
          clear_cause();
          if(FPSCR_PR == 1) undefined_operation();
          else if((data_type_of(0) == sNaN) ||
                  (data_type_of(m) == sNaN) ||
                  (data_type_of(n) == sNaN)) invalid(n);
          else if((data_type_of(0) == qNaN) ||
                  (data_type_of(m) == qNaN)) qnan(n);
          else if((data_type_of(0) == DENORM) ||
                  (data_type_of(m) == DENORM)) set_E();
          else switch (data_type_of(0))
			{
				case NORM: switch (data_type_of(m))
						   {
								case PZERO:
								case NZERO: switch (data_type_of(n))
											{
												case DENORM: set_E();  break;
												case qNaN:   qnan(n);  break;
												case PZERO:
												case NZERO: zero(n,sign_of(0)^ sign_of(m)^sign_of(n));
															break;
												default: break;
											}
								case PINF:
								case NINF: switch (data_type_of(n))
										   {
												case DENORM:  set_E(); break;
												case qNaN:    qnan(n); break;
												case PINF:
												case NINF: if(sign_of(0)^ sign_of(m)^sign_of(n))  invalid(n);
															else   inf(n,sign_of(0)^ sign_of(m)); break;
												default: inf(n,sign_of(0)^ sign_of(m)); break;
										   }    break;
								case NORM: switch (data_type_of(n))
										   {
												case DENORM: set_E();  break;
												case qNaN:   qnan(n);  break;
												case PINF:
												case NINF:   inf(n,sign_of(n)); break;
												case PZERO:
												case NZERO:
												case NORM:   normal_fmac(m,n);  break;
											}
						   }
				case PZERO:
				case NZERO: switch (data_type_of(m))
							{
								case PINF:
								case NINF:  invalid(n); break;
								case PZERO:
								case NZERO:
								case NORM: switch (data_type_of(n))
										   {
												case DENORM: set_E();    break;
												case qNaN:   qnan(n);    break;
												case PZERO:
												case NZERO: zero(n,sign_of(0)^ sign_of(m)^sign_of(n));  break;
												default:    break;
										   }        break;
							}     break;
				case PINF :
				case NINF : switch (data_type_of(m))
							{
								case PZERO:
								case NZERO:invalid(n);  break;
								default: switch (data_type_of(n))
										 {
											case DENORM: set_E();  break;
											case qNaN:    qnan(n);  break;
											default:   inf(n,sign_of(0)^sign_of(m)^sign_of(n));break;
										 }     break;
							}break;
				}
}
void normal_fmac(int m,int n)
{
union {
      long double x;
      int l[4];
}    dstx,tmpx;
float dstf,srcf;
      if((data_type_of(n) == PZERO)|| (data_type_of(n) == NZERO))
             srcf = 0.0; /* flush denormalized value */
      else    srcf = FR[n];
      tmpx.x = FR[0]; /* convert single to int double */
      tmpx.x *= FR[m]; /* exact product */
      dstx.x = tmpx.x + srcf;
      if(((dstx.x == srcf) && (tmpx.x != 0.0)) ||
         ((dstx.x == tmpx.x) && (srcf != 0.0))) {
         set_I();
         if(sign_of(0)^ sign_of(m)^ sign_of(n))  {
             dstx.l[3] -= 1; /* correct result */
             if(dstx.l[3] == 0xffffffff) dstx.l[2] -= 1;
             if(dstx.l[2] == 0xffffffff) dstx.l[1] -= 1;
             if(dstx.l[1] == 0xffffffff) dstx.l[0] -= 1;
         }
         else   dstx.l[3] |= 1;
      }
      if((dstx.l[1] & 0x01ffffff) || dstx.l[2] || dstx.l[3]) set_I();
        if(FPSCR_RM == 1) {
               dstx.l[1] &= 0xfe000000; /* round toward zero */
               dstx.l[2]  = 0x00000000;
               dstx.l[3]  = 0x00000000;
        }
        dstf = dstx.x;
        check_single_exception(&FR[n],dstf);
  }
void FMOV(int m,int n)
{
  if (FPSCR_PR==1)
  {
   if (m&1)
   {
    if (n&1)
    {
    /* FMOV XDm,XDn */
       XD[n>>1] = XD[m>>1];
     }
     else
     {
      /* FMOV XDm,DRn */
       DR[n>>1] = XD[m>>1];
     }
   }
   else
   {
   /* FMOV DRm,XDn */
       XD[n>>1] = DR[m>>1];
   }
  }
  else
  {
   if (FPSCR_SZ==0)
   { /* FMOV FRm,FRn */
       FR[n] = FR[m];
   }
   else
   {/* FMOV DRm,DRn */
       DR[n>>1] = DR[m>>1];
   }
  }
PC += 2;
}
void FMOV_STORE(int m,int n)
{
  if (FPSCR_PR==1)
  {
  /* FMOV XDm,@Rn */
  //store_quad(XD[m>>1],R[n]);
  Write_Long(R[n],(LONG)XF[m]);
  Write_Long(R[n],(LONG)XF[m+1]);
  }
  else
  {
   if (FPSCR_SZ==0)
   {/* FMOV.S FRm,@Rn */
   //store_int(FR[m],R[n]);
   Write_Long(R[n],(LONG)FR[m]);
   }
   else
   {/* FMOV DRm,@Rn */
   //store_quad(DR[m>>1],R[n]);
   Write_Long(R[n],(LONG)FR[m]);
   Write_Long(R[n],(LONG)FR[m+1]);
   }
  }
PC += 2;
}
void FMOV_LOAD(int m,int n)
{
  if (FPSCR_PR==1)
  {
       /* FMOV @Rm,XDn */
       //load_quad(R[m],XD[n>>1]);
       //XD0 = XF0 XF1
       XF[n]=Read_Long(R[m]);
       XF[n+1]=Read_Long(R[m]+4);
  }
  else
  {
   if (FPSCR_SZ==0)
   {/* FMOV.S @Rm,FRn */
       //load_int(R[m],FR[n]);
       FR[n]=Read_Long(R[m]);
   }
   else
   {/* FMOV @Rm,DRn */
       //load_quad(R[m],DR[n>>1]);
       //DR0 = FR0 FR1
       FR[n]=Read_Long(R[m]);
       FR[n+1]=Read_Long(R[m]+4);

   }
  }
PC += 2;
}
void FMOV_RESTORE(int m,int n)
{
  if (FPSCR_PR==1)
  {
     /* FMOV @Rm+,DBn */
       //load_quad(R[m],XD[n>>1]);
       XF[n]=Read_Long(R[m]);
       XF[n+1]=Read_Long(R[m]+4);
       R[m] += 8;
  }
  else
  {
   if (FPSCR_SZ==0)
   {/* FMOV.S @Rm+,FRn */
     //load_int(R[m],FR[n]);
     FR[n]=Read_Long(R[m]);
     R[m] += 4;
   }
   else
   {/* FMOV @Rm+,DRn */
     //load_quad(R[m],DR[n>>1]);
     FR[n]=Read_Long(R[m]);
     FR[n+1]=Read_Long(R[m]+4);
     R[m] += 8;
   }
  }
 PC += 2;
}
void FMOV_SAVE(int m,int n)
{
  if (FPSCR_PR==1)
  {
  /* FMOV XDm,@Rn */
       //store_quad(XD[m>>1],R[n]-8);
       Write_Long(R[n]-8,(LONG)XF[m]);
       Write_Long(R[n]-4,(LONG)XF[m+1]);
       R[n] -= 8;
  }
  else
  {
   if (FPSCR_SZ==0)
   {/* FMOV.S FRm,@Rn */
     //store_int(FR[m],R[n]-4);
     Write_Long(R[n]-4,(LONG)FR[m]);
     R[n] -= 4;
   }
   else
   {/* FMOV DRm,@Rn */
     //store_quad(DR[m>>1],R[n]-8);
     Write_Long(R[n]-8,(LONG)FR[m]);
     Write_Long(R[n]-4,(LONG)FR[m+1]);
     R[n] -= 8;
   }
  }
 PC += 2;
}
void FMOV_INDEX_LOAD(int m,int n)
{
  if (FPSCR_PR==1)
  {
  /* FMOV @(R0,Rm),XDn */
  //load_quad(R[0] + R[m],XD[n>>1]);
   XF[n]=Read_Long(R[0] + R[m]);
   XF[n+1]=Read_Long(R[0] + R[m] + 4);
  }
  else
  {
   if (FPSCR_SZ==0)
   {/* FMOV.S @(R0,Rm),FRn */
   //load_int(R[0] + R[m],FR[n]);
   FR[n]=Read_Long(R[0] + R[m]);
   }
   else
   {/*FMOV @(R0,Rm),DRn */
   //load_quad(R[0] + R[m],DR[n>>1]);
   FR[n]=Read_Long(R[0] + R[m]);
   FR[n+1]=Read_Long(R[0] + R[m] + 4);
   }
  }
 PC += 2;
}
void FMOV_INDEX_STORE(int m,int n)
{
  if (FPSCR_PR==1)
  {
  /* FMOV XDm,@(R0,Rn) */
  //store_quad(XD[m>>1], R[0] + R[n]);
   Write_Long(R[0] + R[n],(LONG)XF[m]);
   Write_Long(R[0] + R[n] + 4,(LONG)XF[m+1]);
  }
  else
  {
   if (FPSCR_SZ==0)
   {/*FMOV.S FRm,@(R0,Rn)*/
    //store_int(FR[m], R[0] + R[n]);
    Write_Long(R[0] + R[n],(LONG)XF[m]);
   }
   else
   {
    /*FMOV DRm,@(R0,Rn)*/
    //store_quad(DR[m>>1], R[0] + R[n]);
    Write_Long(R[0] + R[n],(LONG)FR[m]);
    Write_Long(R[0] + R[n] + 4,(LONG)FR[m+1]);
   }
  }
 PC += 2;
}

     void FMUL(int m,int n)
     {
          PC += 2;
              clear_cause();
              if((data_type_of(m) == sNaN) ||
                  (data_type_of(n) == sNaN)) invalid(n);
              else if((data_type_of(m) == qNaN) ||
                      (data_type_of(n) == qNaN)) qnan(n);
              else if((data_type_of(m) == DENORM) ||
                      (data_type_of(n) == DENORM)) set_E();
              else switch (data_type_of(m)){
                  case NORM: switch (data_type_of(n)){
                      case PZERO:
                      case NZERO: zero(n,sign_of(m)^sign_of(n));  break;
                      case PINF:
                      case NINF:      inf(n,sign_of(m)^sign_of(n));  break;
                      default:        normal_fmul(m,n);  break;
        }     break;
           case PZERO:
           case NZERO: switch (data_type_of(n)){
               case PINF:
               case NINF:  invalid(n); break;
               default:    zero(n,sign_of(m)^sign_of(n));break;
        }     break;
            case PINF :
            case NINF : switch (data_type_of(n)){
                case PZERO:
                case NZERO: invalid(n);   break;
                default:       inf(n,sign_of(m)^sign_of(n));break;
        }      break;
        }
  }

     void FNEG (int n)
     {
        if(FPSCR_PR == 0)
        {
          FR[n] = -FR[n];
        }
        else DR[n>>1] = -DR[n>>1];
        PC += 2;
     }
     void FSCHG()   /* FSCHG */
     {
          if(FPSCR_PR == 0){
              FPSCR ^= 0x00100000; /* bit 20 : SZ */
              PC += 2;
          }
          else undefined_operation();
     }
     void FRCHG()   /* FRCHG */
     {
          if(FPSCR_PR == 0){
              FPSCR ^= 0x00200000; /* bit 21 : FR */
              PC += 2;
          }
          else undefined_operation();
     }


    void FSQRT(int n)
    {
          PC += 2;
          clear_cause();
          switch(data_type_of(n)){
              case NORM  :   if(sign_of(n) == 0) normal_fsqrt(n);
                        else      invalid(n); break;
              case DENORM:   if(sign_of(n) == 0) set_E();
                        else      invalid(n); break;
              case PZERO :
              case NZERO :
              case PINF  :     break;
              case NINF  :     invalid(n); break;
              case qNaN  :     qnan(n);    break;
              case sNaN  :     invalid(n); break;
          }
     }

void FSTS(int n)
{
       FR[n] = FPUL;
       PC += 2;
}

void FLSUB (int m,int n)
{
          PC += 2;
          clear_cause();
          if((data_type_of(m) == sNaN) ||
              (data_type_of(n) == sNaN)) invalid(n);
          else if((data_type_of(m) == qNaN) ||
                  (data_type_of(n) == qNaN)) qnan(n);
          else if((data_type_of(m) == DENORM) ||
                  (data_type_of(n) == DENORM)) set_E();
          else switch (data_type_of(m)){
              case NORM: switch (data_type_of(n)){
                  case NORM:  normal_faddsub(m,n,FSUB); break;
                  case PZERO:
                  case NZERO: register_copy(m,n); FR[n] = -FR[n];break;
                  default:       break;
           }          break;
           case PZERO: break;
           case NZERO: switch (data_type_of(n)){
               case NZERO: zero(n,0); break;
               default:       break;
           }         break;
           case PINF: switch (data_type_of(n)){
               case PINF:    invalid(n);     break;
               default:      inf(n,1);       break;
           }   break;
           case NINF: switch (data_type_of(n)){
               case NINF:    invalid(n);     break;
               default:      inf(n,0);       break;
           }         break;
       }
  }
     #define N_INT_SINGLE_RANGE 0xcf000000 & 0x7fffffff  /* -1.000000 * 2^31 */
     #define P_INT_SINGLE_RANGE 0x4effffff  /* 1.fffffe * 2^30 */
     #define N_INT_DOUBLE_RANGE 0xc1e0000000200000 & 0x7fffffffffffffff
     #define P_INT_DOUBLE_RANGE 0x41e0000000000000


     void FTRC(int m)
     {
          PC += 2;
          clear_cause();
          if(FPSCR_PR==0){
               switch (ftrc_single_type_of(m)){
               case NORM:     FPUL = FR[m];    break;
               case PINF:     ftrc_invalid(0);          break;
               case NINF:     ftrc_invalid(1);          break;
               }
          }
          else{                 /* case FPSCR_PR=1 */
               switch (ftrc_double_type_of(m)){
            case NORM:     FPUL = DR[m>>1]; break;
            case PINF:     ftrc_invalid(0);      break;
            case NINF:     ftrc_invalid(1);      break;
            }
       }
  }
  int ftrc_single_type_of(int m)
  {
   //nothing yet
  }
  int ftrc_double_type_of(int m)
  {
  //nothing yet
  }
  void ftrc_invalid(int sign)
  {
       set_V();
        if((FPSCR & ENABLE_V) == 0){
              if(sign == 0)     FPUL = 0x7fffffff;
              else              FPUL = 0x80000000;
       }
       else fpu_exception_trap();
  }


  void FTRV (int n)     /* FTRV FVn */
  {
  float saved_vec[4],result_vec[4];
  int saved_fpscr;
  int dst,i,j;
       if(FPSCR_PR == 0) {
           PC += 2;
           clear_cause();
           saved_fpscr  = FPSCR;
           FPSCR &= ~ENABLE_VOUI; /* mask VOUI enable */
           dst = 12 - n;          /* select other vector than FVn */
           for(i=0;i<4;i++) saved_vec[i] = FR[dst+i];
           for(i=0;i<4;i++)
		   {
               for(j=0;j<4;j++) FR[dst+j] = XF[i+(j<<2)]; //j*4
               fipr(n,dst);
               saved_fpscr |= FPSCR & (CAUSE|FLAG) ;
               result_vec [i] = FR[dst+3];
           }
           for(i=0;i<4;i++) FR[dst+i] = saved_vec [i];
           FPSCR = saved_fpscr;
           if(FPSCR & ENABLE_VOUI) fpu_exception_trap();
           else    for(i=0;i<4;i++)   FR[n+i] = result_vec [i];
       }
       else undefined_operation();
  }




