/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include <gtk/gtk.h>
#include <GL/glut.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>

#if defined (__linux__)
  #define _linux
#endif

#ifndef BYTE
 #define BYTE unsigned char
#endif
#ifndef WORD
 #define WORD unsigned short
#endif
#ifndef LONG
 #define LONG unsigned long
#endif
#ifndef LONG64
#ifdef _linux
 #define LONG64 long long
#elif WINDOWS
 #define LONG64 _int64
#endif
#endif
/*
ip.bin -> 8C008000
1st_read.bin -> 8C010000
*/
#ifndef EMU_GLOBALS
 #define EMU_GLOBALS

//CACHE
BYTE RamAlloc; //use to know if allow or not mem
//2*16*4K
BYTE *RamArea1,*RamArea2;
//4*16*16=1024
BYTE *IndexRamArea[0x10];

//PAGE 50
BYTE *DREAMCAST_PRAM; //16 M
BYTE *DREAMCAST_VRAM; //8 M
BYTE *DREAMCAST_RAM_A05; //1 M
BYTE *DREAMCAST_RAM_A07; //1 M
BYTE *DREAMCAST_RAM_A08; //1 M

GLubyte *FrameStart;
GLubyte *FrameBufAddr;

unsigned long CODESIZE;
char *ROMNAME;
GtkWidget *pvrtext;
static char rendernow;
int frames;


#endif

#ifndef OP_GLOBALS
 #define OP_GLOBALS

union {
        int  l[2][16];
        float f[2][16];
        double d[2][8];
}frf;



/* assume in C language :  (becareful of long=32 bits in GNU C LINUX !) int=64 bits on alpha
  char         8-bit integer
  short        16-bit integer
  int          32-bit integer
  long         64-bit integer
  float        single-precision floating point number(32 bits)
  double       double-precision floating point number(64 bits)
  These are data types.
*/

//registers
  unsigned long R[16];
  unsigned long R_BANK[8];
  unsigned long SR,FPSCR,GBR,VBR,SSR,SPC,DBR,SGR;
  unsigned long MACH,MACL,PR;
  unsigned long PC;
  float FPUL;
//MM registers
  BYTE CCN[0x40];BYTE UBC[0x22];BYTE BSC1[0x50];BYTE BSC2[0x10000];BYTE BSC3[0x10000];
  BYTE DMAC[0x44];BYTE CPG[0x11];BYTE RTC[0x3D];BYTE INTC[0xE];BYTE TMU[0x30];
  BYTE SCI[0x1D];BYTE SCIF[0x26];BYTE HUDI[0xC];
  BYTE *mmregtab[0xf1];

  unsigned long *PTEH;
  unsigned long *PTEL;
  unsigned long *TTB;
  unsigned long *TEA;
  unsigned long *MMUCR;
  unsigned long *TRA;
  unsigned long *EXPEVT;
  unsigned long *INTEVT;
  unsigned long *PTEA;
  unsigned long *CCR;

struct sTLB
{
 unsigned char ASID;
 int VPN;
 int PPN;
 unsigned char SZ,SH,PR,WT,C,D,V,SA,TC;
};

struct sTLB TLB[64];

struct tagfpar
{
        void (*fonc)();
        int par1;
        int par2;
        int par3;
} ;
struct tagfpar tab_op[0x10000];

#endif


