/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"

#define TRACEWINDOWSX 400
#define TRACEWINDOWSY 400
#define PVRWINDOWSX 200
#define PVRWINDOWSY 350

char go_trace=0;
char running=0;
char StepDsm=0;
char dsmdone=0;
#define LOADED 1
#define UNLOADED 0
char rom=UNLOADED;
char DSM=0;
char *romfilename;
GtkWidget *text,*vscrollbar,*reglabel,*table,*filew,*bpwindow,*memwindow;
GtkWidget *pvrvscrollbar,*pvrtable;
GdkFont *fixed_font;
#define MAXBP 10
#define MAXMW 10
unsigned int breakpoints[MAXBP];
int CurBP=0;
unsigned int memwatchs[MAXMW];
int CurMemW=0;

#define MAXPCTRACEBACK 10
LONG prevPC[MAXPCTRACEBACK];
int trpc=0;

void dsmprog();
void showmem();

void activebp( GtkWidget *widget,
                     GtkWidget *entry )
{
  gchar *entry_text;
  if (CurBP>=MAXBP) {printf("no more bp\n"); return;}
  entry_text = gtk_entry_get_text(GTK_ENTRY(entry));
  if (sscanf(entry_text,"%x",&breakpoints[CurBP])==1)
  {
   printf("New BP: 0x%x\n", breakpoints[CurBP]);
   CurBP++;
  }
  gtk_widget_destroy(widget);
  gtk_widget_destroy(bpwindow);
}

void gotoaddr()
{
    GtkWidget *entry;

    bpwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_usize( GTK_WIDGET (bpwindow), 200, 100);
    gtk_window_set_title(GTK_WINDOW (bpwindow), "Break Point");
    gtk_signal_connect(GTK_OBJECT (bpwindow), "delete_event",
                       (GtkSignalFunc)gtk_widget_destroy, bpwindow);

    entry = gtk_entry_new_with_max_length (12);
    gtk_signal_connect(GTK_OBJECT(entry), "activate",
                       GTK_SIGNAL_FUNC(activebp),
                       entry);
    gtk_entry_set_text (GTK_ENTRY (entry), "0x");
    gtk_entry_append_text (GTK_ENTRY (entry), "8c00");
    gtk_entry_set_editable(GTK_ENTRY(entry),TRUE);
    gtk_entry_set_visibility(GTK_ENTRY(entry),TRUE);

    gtk_entry_select_region (GTK_ENTRY (entry),
                             0, GTK_ENTRY(entry)->text_length);

    gtk_container_add (GTK_CONTAINER(bpwindow),entry);

    gtk_widget_show (entry);
    gtk_widget_show (bpwindow);
}

void watchmem( GtkWidget *widget,
                     GtkWidget *entry )
{
  gchar *entry_text;
  if (CurBP>=MAXMW) {printf("no more mem watch\n"); return;}
  entry_text = gtk_entry_get_text(GTK_ENTRY(entry));
  if (sscanf(entry_text,"%x",&memwatchs[CurMemW])==1)
  {
   printf("New Watch: 0x%x\n", memwatchs[CurMemW]);
   CurMemW++;
  }
  gtk_widget_destroy(widget);
  gtk_widget_destroy(memwindow);
}

void showmemaddr()
{
    GtkWidget *entry;

    memwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_usize( GTK_WIDGET (memwindow), 200, 100);
    gtk_window_set_title(GTK_WINDOW (memwindow), "MemWatch");
    gtk_signal_connect(GTK_OBJECT (memwindow), "delete_event",
                       (GtkSignalFunc)gtk_widget_destroy, memwindow);

    entry = gtk_entry_new_with_max_length (12);
    gtk_signal_connect(GTK_OBJECT(entry), "activate",
                       GTK_SIGNAL_FUNC(watchmem),
                       entry);
    gtk_entry_set_text (GTK_ENTRY (entry), "0x");
    gtk_entry_set_editable(GTK_ENTRY(entry),TRUE);
    gtk_entry_set_visibility(GTK_ENTRY(entry),TRUE);

    gtk_entry_select_region (GTK_ENTRY (entry),
                             0, GTK_ENTRY(entry)->text_length);

    gtk_container_add (GTK_CONTAINER(memwindow),entry);

    gtk_widget_show (entry);
    gtk_widget_show (memwindow);
}



void setmem( GtkWidget *widget,
                     GtkWidget *entry )
{
  gchar *entry_text;
  LONG setaddr;
  int value;
  entry_text = gtk_entry_get_text(GTK_ENTRY(entry));
  if (sscanf(entry_text,"%x %d",&setaddr,&value)==2)
  {
   printf("Set:0x%x %d\n",setaddr,value);
   Write_Long(setaddr,value);
  }
  //gtk_widget_destroy(widget);
}

void setmemaddr()
{
    GtkWidget *entry;

    memwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_usize( GTK_WIDGET (memwindow), 200, 100);
    gtk_window_set_title(GTK_WINDOW (memwindow), "Change Mem Value");
    gtk_signal_connect(GTK_OBJECT (memwindow), "delete_event",
                       (GtkSignalFunc)gtk_widget_destroy, memwindow);

    entry = gtk_entry_new_with_max_length (12);
    gtk_signal_connect(GTK_OBJECT(entry), "activate",
                       GTK_SIGNAL_FUNC(setmem),
                       entry);
    gtk_entry_set_text (GTK_ENTRY (entry), "0x");
    gtk_entry_set_editable(GTK_ENTRY(entry),TRUE);
    gtk_entry_set_visibility(GTK_ENTRY(entry),TRUE);

    gtk_entry_select_region (GTK_ENTRY (entry),
                             0, GTK_ENTRY(entry)->text_length);

    gtk_container_add (GTK_CONTAINER(memwindow),entry);

    gtk_widget_show (entry);
    gtk_widget_show (memwindow);
}


void close_app(GtkWidget *widget, gpointer data)
{
 gtk_main_quit();

 free(RamArea1);
 free(RamArea2);
 free(DREAMCAST_PRAM);
 free(DREAMCAST_VRAM);
 free(DREAMCAST_RAM_A05);
 free(DREAMCAST_RAM_A07);
 free(DREAMCAST_RAM_A08);
 exit(1);
}

void updateinfo()
{
  char *getreginfo;
  gtk_text_set_point(GTK_TEXT(text),(PC-0x8c008300)<<5);
  gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL," ",-1);
  gtk_text_backward_delete(GTK_TEXT(text),1);
  gtk_text_thaw(GTK_TEXT(text));
  getreginfo=makereginfo();
  gtk_label_set_text(GTK_LABEL(reglabel),getreginfo);
  free(getreginfo);
}
/*
getmeminfo()
{
  printf("%x %x\n",0x7e000fd4,Read_Long(0x7e000fd4));
  printf("%x %x\n",0x8c008534,Read_Long(0x8c008534));
  printf("%x %x\n",0x7e000fe0,Read_Long(0x7e000fe0));
  printf("%x %x\n",0x7e000fdc,Read_Long(0x7e000fdc));
  printf("%x %x\n",0x8c0084e4,Read_Long(0x8c0084e4));
  printf("%x %x\n",0x8c009f24,Read_Long(0x8c009f24));
  printf("%x %x\n",0xffd8000c,Read_Long(0xffd8000c));
  printf("%x %x\n",0x7e000fe8,Read_Long(0x7e000fe8));
  printf("%x %x\n",0x7e000fec,Read_Long(0x7e000fec));
  printf("%x %x\n",0x8c0084e8,Read_Long(0x8c0084e8));
  printf("%x %x\n",0x7e000fe4,Read_Long(0x7e000fe4));
  printf("%x %x\n",0x8c0084ec,Read_Long(0x8c0084ec));
  printf("%x %x\n",0x8c009f28,Read_Long(0x8c009f28));
  printf("%x %x\n",0x7e000fc4,Read_Long(0x7e000fc4));
  printf("%x %x\n",0x7e000fc8,Read_Long(0x7e000fc8));
  printf("%x %x\n",0x8c009f2c,Read_Long(0x8c009f2c));
  printf("%x %x\n",0x7e000fc8,Read_Long(0x7e000fc8));
  printf("%x %x\n",0x8c009f2c,Read_Long(0x8c009f2c));
  printf("%x %x\n",0x7e000fcc,Read_Long(0x7e000fcc));
}

setmeminfo()
{
  Write_Long(0x7e000fd4,0);
  //Write_Long(0x7e000fe0,0x00e147ae);
  Write_Long(0xffd8000c,0xffffffff);
  Write_Long(0x7e000fe8,0x83600000);
  Write_Long(0x7e000fec,0x8c00d828);
  Write_Long(0x7e000fe4,0xb000);
  Write_Long(0x7e000fc4,0xb000);
  Write_Long(0xac0000e0,0x8c010000);
}
*/
int go_step()
{
 WORD i;
 char j;

 i=Read_Word(PC);
 prevPC[trpc]=PC;
 trpc++;
 if (trpc==MAXPCTRACEBACK) trpc=0;
 OPCALL(i);
 if (StepDsm)
 {
  printf("PC:%x\n",PC);
  updateinfo();
  //getmeminfo();
  //setmeminfo();
  showmem();
  for (j=0;j<10;j++)
  {
   if (breakpoints[j]==PC)
   {
    updateinfo();
    getchar();
    return 1;
   }
  }
 }
 return 0;
}


void click_step()
{
 if (!(rom)) return;
 go_step();
}

void click_dsm()
{
 if (!dsmdone) return;
 StepDsm=!StepDsm;
}

void *thr_run()
{
 if (!(rom)) return NULL;
 running=1;
 while(1)
 {
  gdk_threads_enter();
  if ((go_step()) || (!(go_trace))) break;
  gdk_threads_leave();
 }
 gdk_threads_leave();
 running=0;
 return NULL;
}

void go_run(GtkWidget *widget, gpointer data)
{
#if defined _linux
 pthread_t pth_run;
#elif defined WINDOWS
 unsigned long pth_run;
#endif

 if (!(rom)) return;
 go_trace=!go_trace;
 if ((go_trace) && (!(running)))
 {
  #if defined _linux
   pthread_create(&pth_run,NULL,(void *(*)(void *))thr_run,NULL);
  #elif defined WINDOWS
   CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)thr_run,NULL,0,&pth_run);
  #endif
 }
}

void create_text_area()
{
 text=gtk_text_new(NULL,NULL);

 gtk_widget_set_usize(GTK_WIDGET(text),TRACEWINDOWSX,TRACEWINDOWSY);
 gtk_table_attach(GTK_TABLE (table), text, 0, 3, 0, 3,
	 (GtkAttachOptions) (GTK_EXPAND | GTK_SHRINK | GTK_FILL) ,
     (GtkAttachOptions) (GTK_EXPAND | GTK_SHRINK | GTK_FILL), 0, 0);
 gtk_text_set_editable(GTK_TEXT(text),FALSE);
 gtk_widget_show(text);

 vscrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
 gtk_table_attach (GTK_TABLE (table), vscrollbar, 3, 4, 0, 3,
      (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL) ,
	  (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL), 0, 0);
 gtk_widget_show (vscrollbar);
}

void create_pvr_text_area()
{
 pvrtext=gtk_text_new(NULL,NULL);

 gtk_widget_set_usize(GTK_WIDGET(pvrtext),PVRWINDOWSX,PVRWINDOWSY);
 gtk_table_attach(GTK_TABLE (pvrtable), pvrtext, 0, 1, 0, 1,
           (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
           (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL), 0, 0);
 gtk_text_set_editable(GTK_TEXT(pvrtext),FALSE);
 gtk_widget_show(pvrtext);

 pvrvscrollbar = gtk_vscrollbar_new (GTK_TEXT (pvrtext)->vadj);
 gtk_table_attach (GTK_TABLE (pvrtable), pvrvscrollbar, 1, 2, 0, 1,
           (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL),
           (GtkAttachOptions)(GTK_EXPAND | GTK_SHRINK | GTK_FILL), 0, 0);
 gtk_widget_show(pvrvscrollbar);
}


void getromname(GtkWidget *w,GtkFileSelection *fs)
{
 char *getreginfo;
 romfilename=gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
 loadip_1stread(romfilename);
 rom=LOADED;
 gtk_widget_destroy(text);
 gtk_widget_destroy(vscrollbar);
 create_text_area();
 //gtk_text_insert(GTK_TEXT(text),NULL,&text->style->black,NULL,romfilename,-1);
 //gtk_text_insert(GTK_TEXT(text),NULL,&text->style->black,NULL," :\n",-1);
 //gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,ROMNAME,-1);
 printf("ROM : %s\n",ROMNAME);
 gtk_widget_destroy(filew);

 gtk_text_set_point(GTK_TEXT(text),0);
 gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL," ",-1);
 gtk_text_backward_delete(GTK_TEXT(text),1);

 getreginfo=makereginfo();
 gtk_label_set_text(GTK_LABEL(reglabel),getreginfo);
 free(getreginfo);
}

void openfile(GtkWidget *widget, gpointer data)
{
 filew=gtk_file_selection_new("Open Rom : IP.BIN");
 gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filew)->ok_button),"clicked",
                (GtkSignalFunc)getromname,filew);
 gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(filew)->cancel_button),
                "clicked",(GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(filew));
 gtk_widget_show(filew);
}

void dsmprog()
{
 unsigned int a;
 unsigned int lastoffset;
 WORD i;
 int len;
 char *reste;

 if (rom!=LOADED)
 {
  printf("load something plz\n");
  return;
 }
 if (dsmdone) return;
 mapdsmall();
 lastoffset=0x8C010000+CODESIZE;

  printf("start : 0x8C008300\tend : 0x%x CS:%d\n",lastoffset,CODESIZE);
  gtk_text_freeze(GTK_TEXT(text));
  gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,dsmmsg,-1);
  for(a=0x8C008300;a<=lastoffset;a+=2)
  {
   len=0;
   i=Read_Word(a);
   sprintf(dsmmsg,"PC:0x%x 0x%04x ",a,i);
   gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,dsmmsg,-1);
   len+=strlen(dsmmsg);
   OPCALL(i);
   gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,dsmmsg,-1);
   len+=strlen(dsmmsg);
   if (len<64)
   {
    reste=(char *)malloc(64-len);
    memset(reste,32,64-len-2);
    reste[64-len-2]='\n';
    reste[64-len-1]=0;
    gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,reste,-1);
    free(reste);
   }
   else gtk_text_insert(GTK_TEXT(text),fixed_font,&text->style->black,NULL,"\n",-1);

  }
  printf("dsm done\n");
 gtk_text_thaw(GTK_TEXT(text));
 dsmdone=1;
 mapall();
}



void dumpdsmprog()
{
 unsigned int a;
 unsigned int lastoffset;
 WORD i;
 FILE *dsmdmp;
 char *dmpfile;
 if (rom!=LOADED)
 {
  printf("load something plz\n");
  return;
 }
 dmpfile=(char *)malloc(strlen(ROMNAME)+4);
 strcpy(dmpfile,ROMNAME);
 strcat(dmpfile,".dsm");

 dsmdmp=fopen(dmpfile,"r");
 if (dsmdmp==NULL)
 {
  mapdsmall();
  lastoffset=0x8C010000+CODESIZE;
  printf("writing dsm log into %s\n",dmpfile);
  dsmdmp=fopen(dmpfile,"w");
  sprintf(dsmmsg,"start : 0x8C008300\tend : 0x%x CS:%d\n",lastoffset,CODESIZE);
  fwrite(dsmmsg,1,strlen(dsmmsg),dsmdmp);
  for(a=0x8C008300;a<=lastoffset;a+=2)
  {
   i=Read_Word(a);
   sprintf(dsmmsg,"PC:0x%x 0x%04x ",a,i);
   fwrite(dsmmsg,1,strlen(dsmmsg),dsmdmp);
   OPCALL(i);
   fwrite(dsmmsg,1,strlen(dsmmsg),dsmdmp);
  }
  fclose(dsmdmp);
  printf("dsm done\n");
  mapall();
 }
 else
 {
  printf("delete .dsm to redump\n");
 }
 free(dmpfile);
 DSM=1;
}

void showmem()
{
 char meminf[64];
 int i;
 for (i=0;i<CurMemW;i++)
 {
  sprintf(meminf,"@%x->%x\n",memwatchs[i],Read_Long(memwatchs[i]));
  gtk_text_insert(GTK_TEXT(pvrtext),NULL,&pvrtext->style->black,NULL,meminf,-1);
 }
}


#if defined _linux
main(int argc, char**argv)
#elif defined WINDOWS
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                   LPSTR     lpCmdLine,
                     int       nCmdShow)
#endif
{
 GtkWidget *window,*vbox,*stepb,*runb,*openb,*gotob,*getmemb,*setmemb,*dsmb,*dumpdsmb,*followb,*setdsmb;
 GtkWidget *window2,*regframe;
 GtkWidget *window3;
 GtkStyle *regwstyle;
 int j;
#if defined _linux
 pthread_t renderw_run;
#elif defined WINDOWS
 unsigned long renderw_run;
#endif


  mapall();
  RamAlloc=0;
  Power_on_reset();
  RamAlloc=1;
  printf("Emulation start\n");
  g_thread_init(NULL);
  //gtk_init(&argc,&argv);
  gtk_init(NULL,NULL);

 for (j=0;j<10;j++)
 {
  breakpoints[j]=0;
 }

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  window2=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  window3=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size(GTK_WINDOW(window),0,0);
  gtk_window_set_default_size(GTK_WINDOW(window2),0,0);
  //gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
  //gtk_window_set_position(GTK_WINDOW(window2), GTK_WIN_POS_MOUSE);
  gtk_widget_set_uposition(window,0,20);
  gtk_widget_set_uposition(window2,TRACEWINDOWSX+70,20);
  gtk_widget_set_uposition(window3,TRACEWINDOWSX+70,100);
  gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC(close_app),NULL);
  gtk_signal_connect(GTK_OBJECT(window2),"destroy",GTK_SIGNAL_FUNC(close_app),NULL);
  gtk_window_set_title(GTK_WINDOW(window),"SH4 emulation");
  gtk_window_set_title(GTK_WINDOW(window2),"reg info");
  gtk_window_set_title(GTK_WINDOW(window3),"power VR info");

  gtk_widget_show(window);
  gtk_widget_show(window2);
  gtk_widget_show(window3);

  regframe=gtk_frame_new("reg");
  gtk_container_add(GTK_CONTAINER(window2),regframe);
  gtk_widget_show(regframe);

  reglabel=gtk_label_new(NULL);
  gtk_label_set_justify (GTK_LABEL(reglabel), GTK_JUSTIFY_LEFT);
  regwstyle=gtk_widget_get_style(reglabel);
  fixed_font = gdk_font_load ("-misc-fixed-medium-r-*-*-*-100-*-*-*-*-*-*");
  regwstyle->font=fixed_font;
  gtk_widget_set_style(reglabel,regwstyle);
  gtk_container_add(GTK_CONTAINER(regframe),reglabel);
  gtk_container_set_border_width (GTK_CONTAINER(window2), 0);
  gtk_widget_show(reglabel);

  table = gtk_table_new (5, 5, FALSE);
  gtk_container_add(GTK_CONTAINER(window),table);
  gtk_widget_show(table);

  create_text_area();

  pvrtable = gtk_table_new (1, 2, FALSE);
  gtk_container_add(GTK_CONTAINER(window3),pvrtable);
  gtk_widget_show(pvrtable);

  create_pvr_text_area();

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_table_attach_defaults (GTK_TABLE (table), vbox, 4, 5, 0, 3);
  gtk_widget_show(vbox);

  openb=gtk_button_new_with_label("Open");
  gtk_signal_connect(GTK_OBJECT(openb),"clicked",GTK_SIGNAL_FUNC(openfile),NULL);
  gtk_widget_show(openb);
  gtk_box_pack_start (GTK_BOX (vbox), openb, TRUE, TRUE, 0);

  stepb=gtk_button_new_with_label("Step");
  gtk_signal_connect(GTK_OBJECT(stepb),"clicked",GTK_SIGNAL_FUNC(click_step),NULL);
  gtk_widget_show(stepb);
  gtk_box_pack_start (GTK_BOX (vbox), stepb, TRUE, TRUE, 0);

  runb=gtk_button_new_with_label("On/Off");
  gtk_signal_connect(GTK_OBJECT(runb),"clicked",GTK_SIGNAL_FUNC(go_run),NULL);
  gtk_widget_show(runb);
  gtk_box_pack_start (GTK_BOX (vbox), runb, TRUE, TRUE, 0);

  gotob=gtk_button_new_with_label("Bp");
  gtk_signal_connect(GTK_OBJECT(gotob),"clicked",GTK_SIGNAL_FUNC(gotoaddr),NULL);
  gtk_widget_show(gotob);
  gtk_box_pack_start (GTK_BOX (vbox), gotob, TRUE, TRUE, 0);

  getmemb=gtk_button_new_with_label("Get Mem");
  gtk_signal_connect(GTK_OBJECT(getmemb),"clicked",GTK_SIGNAL_FUNC(showmemaddr),NULL);
  gtk_widget_show(getmemb);
  gtk_box_pack_start (GTK_BOX (vbox), getmemb, TRUE, TRUE, 0);

  setmemb=gtk_button_new_with_label("Set Mem");
  gtk_signal_connect(GTK_OBJECT(setmemb),"clicked",GTK_SIGNAL_FUNC(setmemaddr),NULL);
  gtk_widget_show(setmemb);
  gtk_box_pack_start (GTK_BOX (vbox), setmemb, TRUE, TRUE, 0);


  followb=gtk_button_new_with_label("Follow");
  gtk_signal_connect(GTK_OBJECT(followb),"clicked",GTK_SIGNAL_FUNC(click_dsm),NULL);
  gtk_widget_show(followb);
  gtk_box_pack_start (GTK_BOX (vbox), followb, TRUE, TRUE, 0);

  dsmb=gtk_button_new_with_label("Dsm");
  gtk_signal_connect(GTK_OBJECT(dsmb),"clicked",GTK_SIGNAL_FUNC(dsmprog),NULL);
  gtk_widget_show(dsmb);
  gtk_box_pack_start (GTK_BOX (vbox), dsmb, TRUE, TRUE, 0);

  dumpdsmb=gtk_button_new_with_label("Dump");
  gtk_signal_connect(GTK_OBJECT(dumpdsmb),"clicked",GTK_SIGNAL_FUNC(dumpdsmprog),NULL);
  gtk_widget_show(dumpdsmb);
  gtk_box_pack_start (GTK_BOX (vbox), dumpdsmb, TRUE, TRUE, 0);
/*
  setdsmb=gtk_button_new_with_label("set");
  gtk_signal_connect(GTK_OBJECT(setdsmb),"clicked",GTK_SIGNAL_FUNC(setmeminfo),NULL);
  gtk_widget_show(setdsmb);
  gtk_box_pack_start (GTK_BOX (vbox), setdsmb, TRUE, TRUE, 0);
*/

  //gdk_threads_enter();
  /*
  #if defined _linux
   pthread_create(&renderw_run,NULL,glstart,NULL);
  #elif defined WINDOWS
   CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)glstart,NULL,0,&renderw_run);
  #endif
  gdk_threads_leave();
  */
  //CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)gtk_main,NULL,0,&renderw_run);
  glstart(NULL);
  //gtk_main();
  //while(1) ;
  printf("codes by eBrain\n");
  return 0;
}
