/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"
#define MEMMAPREGADR1 0xFF000000
#define MEMMAPREGADR2 0x1F000000
#define MEMVRAM64BITS 0xa4000000
#define MEMVRAM32BITS 0xa5000000
#define MEMSRAM8C     0x8c000000
#define MEMSRAMAC     0xAc000000
#define MEMHARDWARE   0xA0000000
/*
AC and 8C points to the same mem area
as a0 and 80 ...
A => priviliege mode no cache ?
A => user mode no cache ?
as all DC runs in privilieged mode, and only in winCE it will use MMU
*/

BYTE *ExtMemSpace[0xad0]; //ac is max
extern int trpc;
#define MAXPCTRACEBACK 10
extern LONG prevPC[MAXPCTRACEBACK];

void mem_map_reg()
{
  PTEH=(unsigned long *)CCN;
  PTEL=(unsigned long *)(CCN+4);
  TTB=(unsigned long *)(CCN+8);
  TEA=(unsigned long *)(CCN+0xC);
  MMUCR=(unsigned long *)(CCN+0x10);
  CCR=(unsigned long *)(CCN+0x1c);
  TRA=(unsigned long *)(CCN+0x20);
  EXPEVT=(unsigned long *)(CCN+0x24);
  INTEVT=(unsigned long *)(CCN+0x28);
  PTEA=(unsigned long *)(CCN+0x34);

 mmregtab[0]=CCN;
 mmregtab[0x20]=UBC;
 mmregtab[0x80]=BSC1;
 mmregtab[0x90]=BSC2;
 mmregtab[0x94]=BSC3;
 mmregtab[0xa0]=DMAC;
 mmregtab[0xc0]=CPG;
 mmregtab[0xc8]=RTC;
 mmregtab[0xd0]=INTC;
 mmregtab[0xd8]=TMU;
 mmregtab[0xe0]=SCI;
 mmregtab[0xe8]=SCIF;
 mmregtab[0xf0]=HUDI;
}

//on chip RAM AREA 1 et 2
void create_on_chip_ram()
{
 int i;
 printf("creating on chip ram\n");
 RamArea1=(BYTE *)malloc(RAMONCHIPSIZE);
 RamArea2=(BYTE *)malloc(RAMONCHIPSIZE);

 for (i=0;i<0x10;i+=4)
 {
  IndexRamArea[i]=RamArea1;
  IndexRamArea[i+1]=RamArea1;
  IndexRamArea[i+2]=RamArea2;
  IndexRamArea[i+3]=RamArea2;
 }
}


void create_ram()
{
unsigned long EntryAddr8C;
unsigned long EntryAddrAC;
unsigned long EntryAddrA0;
unsigned long EntryAddrA4;
unsigned long EntryAddrA5;
 int m;
 //allocate 16 Mb system : ac and 8c
 DREAMCAST_PRAM=(BYTE *)malloc(256*65536);
 //8Mb graphic card : a4 and a5
 DREAMCAST_VRAM=(BYTE *)malloc(128*65536);
 //3Mb Hardware, pvr...a05 and a08 and a07
 DREAMCAST_RAM_A05=(BYTE *)malloc(0x100000);
 DREAMCAST_RAM_A07=(BYTE *)malloc(0x100000);
 DREAMCAST_RAM_A08=(BYTE *)malloc(0x100000);

 EntryAddr8C=(LONG)DREAMCAST_PRAM-EntryPoint8C;//0x8c000000
 EntryAddrAC=(LONG)DREAMCAST_PRAM-EntryPointAC;
 EntryAddrA4=(LONG)DREAMCAST_VRAM-EntryPointA4;
 EntryAddrA5=(LONG)DREAMCAST_VRAM-EntryPointA5;

 for (m=0;m<0x10;m++)
 {
  //system
  ExtMemSpace[0x8C0+m]=(BYTE *)EntryAddr8C;
  ExtMemSpace[0xAC0+m]=(BYTE *)EntryAddrAC;
  //video
  ExtMemSpace[0xa40+m]=(BYTE *)EntryAddrA4;
  ExtMemSpace[0xa50+m]=(BYTE *)EntryAddrA5;
 }
 //hardware reg, pvr reg, asic...
 ExtMemSpace[0xa05]=(BYTE *)((LONG)DREAMCAST_RAM_A05-EntryPointA05);
 ExtMemSpace[0xa07]=(BYTE *)((LONG)DREAMCAST_RAM_A07-EntryPointA07);
 ExtMemSpace[0xa08]=(BYTE *)((LONG)DREAMCAST_RAM_A08-EntryPointA08);

 FrameBufAddr=(BYTE *)((LONG)EntryAddrA5+0xa5200000);
 //printf("VRAM : %x   FrameBuf : %x\n",DREAMCAST_VRAM,FrameBufAddr);
 FrameStart=FrameBufAddr+1228800;
 //rendernow=0;
 //frames=0;
 /* mmap reg init */
 //Power on reset   //!=manual reset
 Write_Long(0xff000010,0);
 Write_Long(0xff000024,0);  //ex: manual is 0x20
 Write_Word(0xff200008,0);
 Write_Word(0xff200014,0);
 Write_Word(0xff200020,0);
 Write_Long(0xff800000,0);
 Write_Word(0xff800004,0x3ffc);
 Write_Long(0xff800008,0x77777777);
 Write_Long(0xff80000C,0xFFFEEFFF);
 Write_Long(0xff800010,0x07777777);
 Write_Long(0xff800014,0);
 Write_Word(0xff800018,0);
 Write_Word(0xff80001C,0);
 Write_Word(0xff800020,0);
 Write_Word(0xff800024,0);
 Write_Word(0xff800028,0);
 Write_Long(0xff80002C,0);
 Write_Long(0xff800040,0);
 Write_Long(0xff800048,0);
 Write_Long(0xffA0000C,0);
 Write_Long(0xffA0001C,0);
 Write_Long(0xffA0002C,0);
 Write_Long(0xffA0003C,0);
 Write_Long(0xffA00040,0);
 Write_Byte(0xffC00004,0);
 Write_Byte(0xffC00008,0);
 Write_Byte(0xffC0000C,0);
 Write_Byte(0xffC00010,0);
 Write_Word(0xffD00000,0);
 Write_Word(0xffD00004,0);
 Write_Word(0xffD00008,0);
 Write_Word(0xffD0000C,0);
 Write_Byte(0xffD80000,0);
 Write_Byte(0xffD80004,0);
 Write_Long(0xffD80008,0xFFFFFFFF);
 Write_Long(0xffD8000C,0xFFFFFFFF);
 Write_Long(0xffD80014,0xFFFFFFFF);
 Write_Long(0xffD80018,0xFFFFFFFF);
 Write_Word(0xffD8001C,0);
 Write_Long(0xffD80020,0xFFFFFFFF);
 Write_Long(0xffD80024,0xFFFFFFFF);
 Write_Word(0xffD80028,0);
 Write_Byte(0xffE00000,0);
 Write_Byte(0xffE00004,0);
 Write_Byte(0xffE00008,0);
 Write_Byte(0xffE0000C,0);
 Write_Byte(0xffE00010,0);
 Write_Byte(0xffE00014,0);
 Write_Byte(0xffE00018,0);
 Write_Byte(0xffE0001C,0);
 Write_Word(0xffE80000,0);
 Write_Byte(0xffE80004,0xff);
 Write_Word(0xffE80008,0);
 Write_Word(0xffE80010,0x60);
 Write_Word(0xffE80018,0);
 Write_Word(0xffE8001C,0);
 Write_Word(0xffE80020,0);
 Write_Word(0xffE80024,0);
 Write_Word(0xffF00000,0xffff);
}


//peut pas anticiper et enlever le & (and) si l'adresse n'est pas fixe

#define READ_TYPE(WhichCAST) \
adr=(Addr&0xFF000000);\
if((Addr>=0x7C000000)&&(Addr<=0x7F000000))\
{\
 if (CCR_OIX)\
 {\
  if (Addr<=0x7D000000) return *(WhichCAST*)(RamArea1+(Addr&0xFFF));\
  else return *(WhichCAST*)(RamArea2+(Addr&0xFFF));\
 }\
 else return *(WhichCAST*)(IndexRamArea[(Addr&0xF000)>>12]+(Addr&0xFFF));\
}\
else if ((adr==MEMMAPREGADR1) || (adr==MEMMAPREGADR2))\
{\
 return *(WhichCAST*)(mmregtab[(Addr&0x00FF0000)>>16]+(Addr&0xFFFF));\
}\
if ((adr==MEMSRAM8C) || (adr==MEMSRAMAC) || (adr==MEMHARDWARE) || (adr==MEMVRAM64BITS) || (adr==MEMVRAM32BITS))\
{\
 return *(WhichCAST*)(ExtMemSpace[(Addr&0xfff00000)>>20]+Addr);\
}\
adr=Addr&0xfff00000;\
if ((adr==EntryPointA05) || (adr==EntryPointA07) || (adr==EntryPointA08))\
{\
 return *(WhichCAST*)(ExtMemSpace[(Addr&0xfff00000)>>20]+Addr);\
}\
printf("not mapped mem ! PC: %x R at %x\n",PC,Addr);\
for (;trpc>-1;trpc--) printf("prevPC[%d]=%x",trpc,prevPC[trpc]);\
exit(0);\

BYTE Read_Byte(unsigned long Addr)
{
volatile unsigned long adr;
//printf("R B at 0x%x\n",Addr);
READ_TYPE(BYTE)
}

WORD Read_Word(unsigned long Addr)
{
volatile unsigned long adr;
//printf("R W at 0x%x\n",Addr);
READ_TYPE(WORD)
}

LONG Read_Long(unsigned long Addr)
{
volatile unsigned long adr;
int i;
GLubyte *FrameBufTmp;
GLubyte *ReverseBuf;
GLubyte *ReverseBufTmp;
if (Addr==0xa05f6900)
{
 //use glutDisplayFunc(gtk_main);
 //flip
  ReverseBufTmp=ReverseBuf=(GLubyte *)malloc(1228800);
  FrameBufTmp=FrameStart;
  for (i=0;i<480;i++)
  {
       FrameBufTmp-=2560;//640*4
       memcpy(ReverseBufTmp,FrameBufTmp,2560);
       ReverseBufTmp+=2560;
  }
 glDrawPixels(WSIZEX, WSIZEY, GL_BGRA, GL_UNSIGNED_BYTE, ReverseBuf);
 free(ReverseBuf);
 glutPostRedisplay();
 glutSwapBuffers();

  //use glutDisplayFunc(draw);
  /* direct
  FrameBufTmp=FrameStart;
  glRasterPos2f(-1,-1);

  for (i=0;i<480;i++)
  {
   FrameBufTmp-=2560;//640*4
   #if defined _linux
    glDrawPixels(WSIZEX, 1, GL_BGRA, GL_UNSIGNED_BYTE, FrameBufTmp);
   #elif defined WINDOWS
    glDrawPixels(WSIZEX, 1, GL_RGBA, GL_UNSIGNED_BYTE, FrameBufTmp);
   #endif
   glBitmap(0,0,-1,0,0,1, NULL);
  }
  */
  return 0xBf;
}
READ_TYPE(LONG);
}



#define WRITE_TYPE(WhatCAST) \
adr=(Addr&0xFF000000);\
if((Addr>=0x7C000000)&&(Addr<=0x7F000000))\
{\
 if (CCR_OIX)\
 {\
  if (Addr<=0x7D000000) {*(WhatCAST*)(RamArea1+(Addr&0xFFF))=Data;return;}\
  else {*(WhatCAST*)(RamArea2+(Addr&0xFFF))=Data;return;}\
 }\
 else {*(WhatCAST*)(IndexRamArea[(Addr&0xF000)>>12]+(Addr&0xFFF))=Data;return;}\
}\
else if ((adr==MEMMAPREGADR1) || (adr==MEMMAPREGADR2))\
{\
 *(WhatCAST*)(mmregtab[(Addr&0x00FF0000)>>16]+(Addr&0xFFFF))=Data;return;\
}\
if ((adr==MEMSRAM8C) || (adr==MEMSRAMAC) || (adr==MEMHARDWARE) || (adr==MEMVRAM64BITS) || (adr==MEMVRAM32BITS))\
{\
 *(WhatCAST*)(ExtMemSpace[(Addr&0xfff00000)>>20]+Addr)=Data;return;\
  exit(0);\
}\
adr=Addr&0xfff00000;\
if ((adr==EntryPointA05) || (adr==EntryPointA07) || (adr==EntryPointA08))\
{\
 *(WhatCAST*)(ExtMemSpace[(Addr&0xfff00000)>>20]+Addr)=Data;return;\
}\
printf("not mapped mem ! PC: %x W at %x\n",PC,Addr);\


void Write_Byte(unsigned long Addr, BYTE Data)
{
volatile unsigned long adr;
//printf("W B at 0x%x with 0x%x\n",Addr,Data);
WRITE_TYPE(BYTE);
}

void Write_Word(unsigned long Addr, WORD Data)
{
volatile unsigned long adr;
//printf("W W at 0x%x with 0x%x\n",Addr,Data);
WRITE_TYPE(WORD);
}

void Write_Long(unsigned long Addr, LONG Data)
{
volatile unsigned long adr;
//printf("W L at 0x%x with 0x%x\n",Addr,Data);
WRITE_TYPE(LONG);
}


/*
main()
{
 Write_Long(0xFF000004, 0x1FF);
 //printf(" CCN[0]-> %x\n",*(LONG *)(CCN+4));
}
*/
