/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "extern.h"

#ifdef SH4DSM
char *makereginfo(void)
{
  char *reg2cat=(char *)malloc(256);
  char *reginfo=(char *)malloc(2048);
  *reginfo=0;
  sprintf(reg2cat,"R%d :0x%08x      R%d :0x%08x       R%d :0x%08x       R%d :0x%08x\n",0,R[0],1,R[1],2,R[2],3,R[3]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"R%d :0x%08x      R%d :0x%08x       R%d :0x%08x       R%d :0x%08x\n",4,R[4],5,R[5],6,R[6],7,R[7]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"R%d :0x%08x      R%d :0x%08x       R%d:0x%08x       R%d:0x%08x\n",8,R[8],9,R[9],10,R[10],11,R[11]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"R%d:0x%08x      R%d:0x%08x       R%d:0x%08x       R%d:0x%08x\n",12,R[12],13,R[13],14,R[14],15,R[15]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"RB%d:0x%08x      RB%d:0x%08x       RB%d:0x%08x       RB%d:0x%08x\n",0,R_BANK[0],1,R_BANK[1],2,R_BANK[2],3,R_BANK[3]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"RB%d:0x%08x      RB%d:0x%08x       RB%d:0x%08x       RB%d:0x%08x\n",4,R_BANK[4],5,R_BANK[5],6,R_BANK[6],7,R_BANK[7]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"FR%d:%f      FR%d:%f       FR%d:%f       FR%d:%f\n",0,FR[0],1,FR[1],2,FR[2],3,FR[3]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"FR%d:%f      FR%d:%f       FR%d:%f       FR%d:%f\n",4,FR[4],5,FR[5],6,FR[6],7,FR[7]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"FR%d:%f     FR%d:%f       FR%d:%f       FR%d:%f\n",8,FR[8],9,FR[9],10,FR[10],11,FR[11]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"FR%d:%f     FR%d:%f       FR%d:%f       FR%d:%f\n",12,FR[12],13,FR[13],14,FR[14],15,FR[15]);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"SR :0x%08x   MD:%d RB:%d BL:%d FD:%d M:%d Q:%d IM:%d S:%d T:%d\n",SR,MD,RB,BL,FD,M,Q,IM,S,T);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"FPSCR:0x%08x FR:%d SZ:%d PR:%d DN:%d I:%d RM:%d\n",FPSCR,FPSCR_FR,FPSCR_SZ,FPSCR_PR,FPSCR_DN,FPSCR_I,FPSCR_RM);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"TEA:0x%08x    MMUCR:0x%08x       GBR:0x%08x       VBR:0x%08x\n",*TEA,*MMUCR,GBR,VBR);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"SSR:0x%08x      SPC:0x%08x       DBR:0x%08x       SGR:0x%08x\n",SSR,SPC,DBR,SGR);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"TRA:0x%08x     MACH:0x%08x      MACL:0x%08x        PR:0x%08x\n",*TRA,MACH,MACL,PR);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"PC :0x%08x     FPUL:%f      EXPEVT:0x%08x    INTEVT:0x%08x\n",PC,FPUL,*EXPEVT,*INTEVT);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"TTB:0x%08x     PTEH:0x%08x      PTEL:0x%08x      PTEA:0x%08x\n",*TTB,*PTEH,*PTEL,*PTEA);
  strcat(reginfo,reg2cat);
  sprintf(reg2cat,"CCR:0x%08x\n",*CCR);
  strcat(reginfo,reg2cat);
  free(reg2cat);
  return reginfo;
}
#endif

void no_opcode()
{
 PC+=2;
}

void DSMno_opcode()
{
#ifdef SH4DSM
  UNKNOWN_DSMINFO
#endif
}

void map_opcode(int opcform, int par1inc, int par2inc, int par3inc,
	int par1total, int par2total, int par3total, void (*opc_fonc)())
{
 int l,m,n;
/*
 int sh_op=0;
if (opcform==0xD000)
{
 sh_op=1;
 printf("map mov %d %d %d %d %d %d\n",par1inc,par2inc,par3inc,par1total,par2total,par3total);
}
*/
    for(l=0;l<par1total;l++)
	{
 	 for(m=0;m<par2total;m++)
	 {
	  for(n=0;n<par3total;n++)
	  {
	    //printf("%x\n",opcform);
/*
                if (sh_op)
                {
                 printf("0x%x ",opcform);
                }
*/
		  if ((tab_op[opcform].fonc==no_opcode) || (tab_op[opcform].fonc==DSMno_opcode))
		  {
			tab_op[opcform].fonc=opc_fonc;
 		    tab_op[opcform].par1=l;
  		    tab_op[opcform].par2=m;
  		    tab_op[opcform].par3=n;
		  }
		  else
                  {
                   printf("0x%x already mapped\n",opcform);
                   exit(1);
                  }

	    opcform+=par3inc;
	  }
	  opcform-=par3inc*par3total;
	  opcform+=par2inc;
	 }
	 opcform-=par2inc*par2total;
	 opcform+=par1inc;
	}
}



void map_opcode_sign(int opcform, int par1inc, int par2inc, int par3inc,
	int par1total, int par2total, int par3total, void (*opc_fonc)(), int limit,char isjump)
{
 int l,m,n;
 unsigned int possignmask;
 unsigned int negsignmask;
 if (limit==0x80) { possignmask=0xff; negsignmask=0xffffff00;}
 else if (limit==0x800) { possignmask=0xfff; negsignmask=0xfffff000;}
 else { printf("map_opcode_sign limit unknown\n"); exit(1); }
    for(l=0;l<par1total;l++)
	{
	 for(m=0;m<par2total;m++)
	 {
	  for(n=0;n<par3total;n++)
	  {
		  if ((tab_op[opcform].fonc==no_opcode) || (tab_op[opcform].fonc==DSMno_opcode))
		  {
		    tab_op[opcform].fonc=opc_fonc;
                //only the 1st a parameter
                if (!(l&limit))
                    tab_op[opcform].par1=(l & possignmask);
                else
                    tab_op[opcform].par1=(negsignmask | l);
                if (isjump)
                {
                    tab_op[opcform].par1<<=1;
                    tab_op[opcform].par1+=4;
                }
		    tab_op[opcform].par2=m;
		    tab_op[opcform].par3=n;
		  }
		  else
                  {
                   printf("0x%x already mapped\n",opcform);
                   exit(1);
                  }

	    opcform+=par3inc;
	  }
	  opcform-=par3inc*par3total;
	  opcform+=par2inc;
	 }
	 opcform-=par2inc*par2total;
	 opcform+=par1inc;
	}
}



void map_opcode_shl(int opcform, int par1inc, int par2inc, int par3inc,
	int par1total, int par2total, int par3total, void (*opc_fonc)(),int deg,char ispcinc)
{
 int l,m,n;
    for(l=0;l<par1total;l++)
	{
 	 for(m=0;m<par2total;m++)
	 {
	  for(n=0;n<par3total;n++)
	  {
		  if ((tab_op[opcform].fonc==no_opcode) || (tab_op[opcform].fonc==DSMno_opcode))
		  {
		    tab_op[opcform].fonc=opc_fonc;
 		    tab_op[opcform].par1=(l<<deg);
                    if (ispcinc) tab_op[opcform].par1+=4;
  		    tab_op[opcform].par2=m;
  		    tab_op[opcform].par3=n;
		  }
		  else
                  {
                   printf("0x%x already mapped\n",opcform);
                   exit(1);
                  }

	    opcform+=par3inc;
	  }
	  opcform-=par3inc*par3total;
	  opcform+=par2inc;
	 }
	 opcform-=par2inc*par2total;
	 opcform+=par1inc;
	}
}

void map_opcode_shl2(int opcform, int par1inc, int par2inc, int par3inc,
	int par1total, int par2total, int par3total, void (*opc_fonc)(),int deg,char ispcinc)
{
 int l,m,n;
    for(l=0;l<par1total;l++)
	{
 	 for(m=0;m<par2total;m++)
	 {
	  for(n=0;n<par3total;n++)
	  {
		  if ((tab_op[opcform].fonc==no_opcode) || (tab_op[opcform].fonc==DSMno_opcode))
		  {
		    tab_op[opcform].fonc=opc_fonc;
                    tab_op[opcform].par1=l;
 		    tab_op[opcform].par2=(m<<deg);
                    if (ispcinc) tab_op[opcform].par2+=4;
  		    tab_op[opcform].par3=n;
		  }
		  else
                  {
                   printf("0x%x already mapped\n",opcform);
                   exit(1);
                  }

	    opcform+=par3inc;
	  }
	  opcform-=par3inc*par3total;
	  opcform+=par2inc;
	 }
	 opcform-=par2inc*par2total;
	 opcform+=par1inc;
	}
}

void mapall(void)
{
int i;
 //initialiser a rien
 for (i=0;i<0x10000;i++) tab_op[i].fonc=no_opcode;
 //ex:map_opcode(0xE000,0x100,1,0,16,256,1,MOVI);
 //0XE000  forme initial   car c'est 0xEnnnniiiiiiii  n=par2, i=par1. Un autre ex:3nnnnmmmm7  par1=m par2=n
 //0X1     incremental par1
 //0x100   inc par2
 //0       pas de par3
 //16      total par1, 0 a 15   = n
 //256     total par2, 0 a 255  = m
 //1       total par3  passe au moins une fois, doit etre 1 = minimum
 //MOVI     fonction opcode    opcode(m,n)  attention aux parametres (inverse)

 //imm = 8 bits si encoder ds l'instruction
 map_opcode(0x300C,0x10,0x100,0,16,16,1,(void (*)())ADD);
 map_opcode_sign(0x7000,1,0x100,0,256,16,1,(void (*)())ADDI,0x80,0);
 map_opcode(0x300E,0x10,0x100,0,16,16,1,(void (*)())ADDC);
 map_opcode(0x300F,0x10,0x100,0,16,16,1,(void (*)())ADDV);
 map_opcode(0x2009,0x10,0x100,0,16,16,1,(void (*)())AND);
 map_opcode(0xC900,1,0,0,256,1,1,(void (*)())ANDI);
 map_opcode(0xCD00,1,0,0,256,1,1,(void (*)())ANDM);
 map_opcode_sign(0x8B00,1,0,0,256,1,1,(void (*)())BF,0x80,1);
 map_opcode_sign(0x8F00,1,0,0,256,1,1,(void (*)())BFS,0x80,1);
 map_opcode_sign(0x8900,1,0,0,256,1,1,(void (*)())BT,0x80,1);
 map_opcode_sign(0x8D00,1,0,0,256,1,1,(void (*)())BTS,0x80,1);
 map_opcode_sign(0xA000,1,0,0,4096,1,1,(void (*)())BRA,0x800,1);
 map_opcode(0x0023,0x100,0,0,16,1,1,(void (*)())BRAF);
 map_opcode_sign(0xB000,1,0,0,4096,1,1,(void (*)())BSR,0x800,1);
 map_opcode(0x0003,0x100,0,0,16,1,1,(void (*)())BSRF);
 map_opcode(0x8800,0x1,0,0,256,1,1,(void (*)())CMPIM);
 map_opcode(0x3000,0x10,0x100,0,16,16,1,(void (*)())CMPEQ);
 map_opcode(0x3003,0x10,0x100,0,16,16,1,(void (*)())CMPGE);
 map_opcode(0x3007,0x10,0x100,0,16,16,1,(void (*)())CMPGT);
 map_opcode(0x3006,0x10,0x100,0,16,16,1,(void (*)())CMPHI);
 map_opcode(0x3002,0x10,0x100,0,16,16,1,(void (*)())CMPHS);
 map_opcode(0x4015,0x100,0,0,16,1,1,(void (*)())CMPPL);
 map_opcode(0x4011,0x100,0,0,16,1,1,(void (*)())CMPPZ);
 map_opcode(0x200C,0x10,0x100,0,16,16,1,(void (*)())CMPSTR);
 map_opcode(0x3004,0x10,0x100,0,16,16,1,(void (*)())DIV1);
 map_opcode(0x2007,0x10,0x100,0,16,16,1,(void (*)())DIV0S);
 map_opcode(0x300D,0x10,0x100,0,16,16,1,(void (*)())DMULS);
 map_opcode(0x3005,0x10,0x100,0,16,16,1,(void (*)())DMULU);
 map_opcode(0x4010,0x100,0,0,16,1,1,(void (*)())DT);
 map_opcode(0x600E,0x10,0x100,0,16,16,1,(void (*)())EXTSB);
 map_opcode(0x600F,0x10,0x100,0,16,16,1,(void (*)())EXTSW);
 map_opcode(0x600C,0x10,0x100,0,16,16,1,(void (*)())EXTUB);
 map_opcode(0x600D,0x10,0x100,0,16,16,1,(void (*)())EXTUW);
 map_opcode(0x402B,0x100,0,0,16,1,1,(void (*)())JMP);
 map_opcode(0x400B,0x100,0,0,16,1,1,(void (*)())JSR);
 map_opcode(0x400E,0x100,0,0,16,1,1,(void (*)())LDCSR);
 map_opcode(0x401E,0x100,0,0,16,1,1,(void (*)())LDCGBR);
 map_opcode(0x402E,0x100,0,0,16,1,1,(void (*)())LDCVBR);
 map_opcode(0x403E,0x100,0,0,16,1,1,(void (*)())LDCSSR);
 map_opcode(0x404E,0x100,0,0,16,1,1,(void (*)())LDCSPC);
 map_opcode(0x40FA,0x100,0,0,16,1,1,(void (*)())LDCDBR);
 map_opcode(0x408E,0x100,0x10,0,16,8,1,(void (*)())LDCRn_BANK);
 map_opcode(0x4007,0x100,0,0,16,1,1,(void (*)())LDCMSR);
 map_opcode(0x4017,0x100,0,0,16,1,1,(void (*)())LDCMGBR);
 map_opcode(0x4027,0x100,0,0,16,1,1,(void (*)())LDCMVBR);
 map_opcode(0x4037,0x100,0,0,16,1,1,(void (*)())LDCMSSR);
 map_opcode(0x4047,0x100,0,0,16,1,1,(void (*)())LDCMSPC);
 map_opcode(0x40F6,0x100,0,0,16,1,1,(void (*)())LDCMDBR);
 map_opcode(0x4087,0x100,0x10,0,16,8,1,(void (*)())LDCMRn_BANK);
 map_opcode(0x405A,0x100,0,0,16,1,1,(void (*)())LDSFPUL);
 map_opcode(0x4056,0x100,0,0,16,1,1,(void (*)())LDSMFPUL);
 map_opcode(0x406A,0x100,0,0,16,1,1,(void (*)())LDSFPSCR);
 map_opcode(0x4066,0x100,0,0,16,1,1,(void (*)())LDSMFPSCR);
 map_opcode(0x400A,0x100,0,0,16,1,1,(void (*)())LDSMACH);
 map_opcode(0x401A,0x100,0,0,16,1,1,(void (*)())LDSMACL);
 map_opcode(0x402A,0x100,0,0,16,1,1,(void (*)())LDSPR);
 map_opcode(0x4006,0x100,0,0,16,1,1,(void (*)())LDSMMACH);
 map_opcode(0x4016,0x100,0,0,16,1,1,(void (*)())LDSMMACL);
 map_opcode(0x4026,0x100,0,0,16,1,1,(void (*)())LDSMPR);
 map_opcode(0x000F,0x10,0x100,0,16,16,1,(void (*)())MAC_L);
 map_opcode(0x400F,0x10,0x100,0,16,16,1,(void (*)())MACW);
 map_opcode_sign(0xE000,1,0x100,0,256,16,1,(void (*)())MOVI,0x80,0);
 map_opcode_shl(0x9000,1,0x100,0,256,16,1,(void (*)())MOVWI,1,1);
 map_opcode_shl(0xD000,1,0x100,0,256,16,1,(void (*)())MOVLI,2,1);
 map_opcode(0x6003,0x10,0x100,0,16,16,1,(void (*)())MOV);
 map_opcode(0x2000,0x10,0x100,0,16,16,1,(void (*)())MOVBS);
 map_opcode(0x2001,0x10,0x100,0,16,16,1,(void (*)())MOVWS);
 map_opcode(0x2002,0x10,0x100,0,16,16,1,(void (*)())MOVLS);
 map_opcode(0x6000,0x10,0x100,0,16,16,1,(void (*)())MOVBL);
 map_opcode(0x6001,0x10,0x100,0,16,16,1,(void (*)())MOVWL);
 map_opcode(0x6002,0x10,0x100,0,16,16,1,(void (*)())MOVLL);
 map_opcode(0x2004,0x10,0x100,0,16,16,1,(void (*)())MOVBM);
 map_opcode(0x2005,0x10,0x100,0,16,16,1,(void (*)())MOVWM);
 map_opcode(0x2006,0x10,0x100,0,16,16,1,(void (*)())MOVLM);
 map_opcode(0x6004,0x10,0x100,0,16,16,1,(void (*)())MOVBP);
 map_opcode(0x6005,0x10,0x100,0,16,16,1,(void (*)())MOVWP);
 map_opcode(0x6006,0x10,0x100,0,16,16,1,(void (*)())MOVLP);
 map_opcode(0x8000,1,0x10,0,16,16,1,(void (*)())MOVBS4);
 map_opcode_shl(0x8100,1,0x10,0,16,16,1,(void (*)())MOVWS4,1,0);
 map_opcode_shl2(0x1000,0x10,1,0x100,16,16,16,(void (*)())MOVLS4,2,0);
 map_opcode(0x8400,0x10,1,0,16,16,1,(void (*)())MOVBL4);
 map_opcode_shl2(0x8500,0x10,1,0,16,16,1,(void (*)())MOVWL4,1,0);
 map_opcode_shl2(0x5000,0x10,1,0x100,16,16,16,(void (*)())MOVLL4,2,0);
 map_opcode(0x0004,0x10,0x100,0,16,16,1,(void (*)())MOVBS0);
 map_opcode(0x0005,0x10,0x100,0,16,16,1,(void (*)())MOVWS0);
 map_opcode(0x0006,0x10,0x100,0,16,16,1,(void (*)())MOVLS0);
 map_opcode(0x000C,0x10,0x100,0,16,16,1,(void (*)())MOVBL0);
 map_opcode(0x000D,0x10,0x100,0,16,16,1,(void (*)())MOVWL0);
 map_opcode(0x000E,0x10,0x100,0,16,16,1,(void (*)())MOVLL0);
 map_opcode(0xC000,1,0,0,256,1,1,(void (*)())MOVBSG);
 map_opcode_shl(0xC100,1,0,0,256,1,1,(void (*)())MOVWSG,1,0);
 map_opcode_shl(0xC200,1,0,0,256,1,1,(void (*)())MOVLSG,2,0);
 map_opcode(0xC400,1,0,0,256,1,1,(void (*)())MOVBLG);
 map_opcode_shl(0xC500,1,0,0,256,1,1,(void (*)())MOVWLG,1,0);
 map_opcode_shl(0xC600,1,0,0,256,1,1,(void (*)())MOVLLG,2,0);
 map_opcode_shl(0xC700,1,0,0,256,1,1,(void (*)())MOVA,2,1);
 map_opcode(0x0029,0x100,0,0,16,1,1,(void (*)())MOVT);
 map_opcode(0x00C3,0x100,0,0,16,1,1,(void (*)())MOVCAL);
 map_opcode(0x0007,0x10,0x100,0,16,16,1,(void (*)())MULL);
 map_opcode(0x200F,0x10,0x100,0,16,16,1,(void (*)())MULS);
 map_opcode(0x200E,0x10,0x100,0,16,16,1,(void (*)())MULU);
 map_opcode(0x0093,0x100,0,0,16,1,1,(void (*)())OCBI);
 map_opcode(0x00A3,0x100,0,0,16,1,1,(void (*)())OCBP);
 map_opcode(0x00B3,0x100,0,0,16,1,1,(void (*)())OCBWB);
 map_opcode(0x0083,0x100,0,0,16,1,1,(void (*)())PREF);
 map_opcode(0x600B,0x10,0x100,0,16,16,1,(void (*)())NEG);
 map_opcode(0x600A,0x10,0x100,0,16,16,1,(void (*)())NEGC);
 map_opcode(0x200B,0x10,0x100,0,16,16,1,(void (*)())OR);
 map_opcode(0xCB00,0x1,0,0,256,1,1,(void (*)())ORI);
 map_opcode(0xCF00,0x1,0,0,256,1,1,(void (*)())ORM);
 map_opcode(0x4004,0x100,0,0,16,1,1,(void (*)())ROTL);
 map_opcode(0x4005,0x100,0,0,16,1,1,(void (*)())ROTR);
 map_opcode(0x4024,0x100,0,0,16,1,1,(void (*)())ROTCL);
 map_opcode(0x4025,0x100,0,0,16,1,1,(void (*)())ROTCR);
 map_opcode(0x400C,0x10,0x100,0,16,16,1,(void (*)())SHAD);
 map_opcode(0x400D,0x10,0x100,0,16,16,1,(void (*)())SHLD);
 map_opcode(0x4020,0x100,0,0,16,1,1,(void (*)())SHAL);
 map_opcode(0x4021,0x100,0,0,16,1,1,(void (*)())SHAR);
 map_opcode(0x4000,0x100,0,0,16,1,1,(void (*)())SHLL);
 map_opcode(0x4001,0x100,0,0,16,1,1,(void (*)())SHLR);
 map_opcode(0x4008,0x100,0,0,16,1,1,(void (*)())SHLL2);
 map_opcode(0x4009,0x100,0,0,16,1,1,(void (*)())SHLR2);
 map_opcode(0x4018,0x100,0,0,16,1,1,(void (*)())SHLL8);
 map_opcode(0x4019,0x100,0,0,16,1,1,(void (*)())SHLR8);
 map_opcode(0x4028,0x100,0,0,16,1,1,(void (*)())SHLL16);
 map_opcode(0x4029,0x100,0,0,16,1,1,(void (*)())SHLR16);
 map_opcode(0x0002,0x100,0,0,16,1,1,(void (*)())STCSR);
 map_opcode(0x0012,0x100,0,0,16,1,1,(void (*)())STCGBR);
 map_opcode(0x0022,0x100,0,0,16,1,1,(void (*)())STCVBR);
 map_opcode(0x0032,0x100,0,0,16,1,1,(void (*)())STCSSR);
 map_opcode(0x0042,0x100,0,0,16,1,1,(void (*)())STCSPC);
 map_opcode(0x003A,0x100,0,0,16,1,1,(void (*)())STCSGR);
 map_opcode(0x00FA,0x100,0,0,16,1,1,(void (*)())STCDBR);
 map_opcode(0x0082,0x100,0x10,0,16,8,1,(void (*)())STCRm_BANK);
 map_opcode(0x4003,0x100,0,0,16,1,1,(void (*)())STCMSR);
 map_opcode(0x4013,0x100,0,0,16,1,1,(void (*)())STCMGBR);
 map_opcode(0x4023,0x100,0,0,16,1,1,(void (*)())STCMVBR);
 map_opcode(0x4033,0x100,0,0,16,1,1,(void (*)())STCMSSR);
 map_opcode(0x4043,0x100,0,0,16,1,1,(void (*)())STCMSPC);
 map_opcode(0x4032,0x100,0,0,16,1,1,(void (*)())STCMSGR);
 map_opcode(0x40F2,0x100,0,0,16,1,1,(void (*)())STCMDBR);
 map_opcode(0x4083,0x100,0x10,0,16,8,1,(void (*)())STCMRm_BANK);
 map_opcode(0x006A,0x100,0,0,16,1,1,(void (*)())STS_FPSCR);
 map_opcode(0x4062,0x100,0,0,16,1,1,(void (*)())STS_RESTORE);
 map_opcode(0x005A,0x100,0,0,16,1,1,(void (*)())STS);
 map_opcode(0x4052,0x100,0,0,16,1,1,(void (*)())STS_SAVE);
 map_opcode(0x000A,0x100,0,0,16,1,1,(void (*)())STSMACH);
 map_opcode(0x001A,0x100,0,0,16,1,1,(void (*)())STSMACL);
 map_opcode(0x002A,0x100,0,0,16,1,1,(void (*)())STSPR);
 map_opcode(0x4002,0x100,0,0,16,1,1,(void (*)())STSMMACH);
 map_opcode(0x4012,0x100,0,0,16,1,1,(void (*)())STSMMACL);
 map_opcode(0x4022,0x100,0,0,16,1,1,(void (*)())STSMPR);
 map_opcode(0x3008,0x10,0x100,0,16,16,1,(void (*)())SUB);
 map_opcode(0x300A,0x10,0x100,0,16,16,1,(void (*)())SUBC);
 map_opcode(0x300B,0x10,0x100,0,16,16,1,(void (*)())SUBV);
 map_opcode(0x6008,0x10,0x100,0,16,16,1,(void (*)())SWAPB);
 map_opcode(0x6009,0x10,0x100,0,16,16,1,(void (*)())SWAPW);
 map_opcode(0xC300,0x1,0,0,256,1,1,(void (*)())TRAPA);
 map_opcode(0x40D1,0x100,0,0,16,1,1,(void (*)())TAS);
 map_opcode(0x2008,0x10,0x100,0,16,16,1,(void (*)())TST);
 map_opcode(0xC800,0x1,0,0,256,1,1,(void (*)())TSTI);
 map_opcode(0xCC00,0x1,0,0,256,1,1,(void (*)())TSTM);
 map_opcode(0x200A,0x10,0x100,0,16,16,1,(void (*)())XOR);
 map_opcode(0xCA00,0x1,0,0,256,1,1,(void (*)())XOR);
 map_opcode(0xCE00,0x1,0,0,256,1,1,(void (*)())XOR);
 map_opcode(0x200D,0x10,0x100,0,16,16,1,(void (*)())XTRCT);
//page 31 -> SR
//33 -> FPSCR
//certains opcodes de FPU dependent de FPSCR_ PR et SZ
//attention PR et SZ ne doivent etre a 1 en meme temps (page 33)
 map_opcode(0xF00C,0x10,0x100,0,16,16,1,(void (*)())FMOV);
 map_opcode(0xF008,0x10,0x100,0,16,16,1,(void (*)())FMOV_LOAD);
 map_opcode(0xF006,0x10,0x100,0,16,16,1,(void (*)())FMOV_INDEX_LOAD);
 map_opcode(0xF009,0x10,0x100,0,16,16,1,(void (*)())FMOV_RESTORE);
 map_opcode(0xF00A,0x10,0x100,0,16,16,1,(void (*)())FMOV_STORE);
 map_opcode(0xF00B,0x10,0x100,0,16,16,1,(void (*)())FMOV_SAVE);
 map_opcode(0xF007,0x10,0x100,0,16,16,1,(void (*)())FMOV_INDEX_STORE);
 map_opcode(0xF01D,0x100,0,0,16,1,1,(void (*)())FLDS);
 map_opcode(0xF00D,0x100,0,0,16,1,1,(void (*)())FSTS);
 map_opcode(0xF05D,0x100,0,0,16,1,1,(void (*)())FABS);
 map_opcode(0xF004,0x10,0x100,0,16,16,1,(void (*)())FCMP_EQ);
 map_opcode(0xF005,0x10,0x100,0,16,16,1,(void (*)())FCMP_GT);

 map_opcode(0xF000,0x10,0x100,0,16,16,1,(void (*)())FLADD);
 map_opcode(0xF08D,0x100,0,0,16,1,1,(void (*)())FLDI0);
 map_opcode(0xF09D,0x100,0,0,16,1,1,(void (*)())FLDI1);
 map_opcode(0xF001,0x10,0x100,0,16,16,1,(void (*)())FLSUB);
 map_opcode(0xF00E,0x10,0x100,0,16,16,1,(void (*)())FMAC);
 map_opcode(0xF002,0x10,0x100,0,16,16,1,(void (*)())FMUL);
 map_opcode(0xF0ED,0x100,0x400,0,4,4,1,(void (*)())FIPR);
 map_opcode(0xF04D,0x100,0,0,16,1,1,(void (*)())FNEG);
 map_opcode(0xF06D,0x100,0,0,16,1,1,(void (*)())FSQRT);
 map_opcode(0xF1FD,0x400,0,0,4,1,1,(void (*)())FTRV);

 map_opcode(0xF02D,0x100,0,0,16,1,1,(void (*)())FPUFLOAT);
 map_opcode(0xF03D,0x100,0,0,16,1,1,(void (*)())FTRC);
 /* bug ? */
 //map_opcode(0xF0BD,0x100,0,0,16,1,1,FCNVDS);
 //map_opcode(0xF0AD,0x100,0,0,16,1,1,FCNVSD);
 //map_opcode(0xF003,0x10,0x100,0,16,16,1,FDIV);

 tab_op[0x28].fonc=CLRMAC;
 tab_op[0x48].fonc=CLRS;
 tab_op[0x8].fonc=CLRT;
 tab_op[0x19].fonc=DIV0U;
 tab_op[0xB].fonc=RTS;
 tab_op[0x38].fonc=LDTLB;
 tab_op[0x9].fonc=NOP;
 tab_op[0x2B].fonc=RTE;
 tab_op[0x58].fonc=SETS;
 tab_op[0x18].fonc=SETT;
 tab_op[0x1B].fonc=SLEEP;
 tab_op[0x8B8D].fonc=FRCHG;
 tab_op[0x838D].fonc=FSCHG;
}


void mapdsmall(void)
{
int i;
 for (i=0;i<0x10000;i++) tab_op[i].fonc=DSMno_opcode;
 map_opcode(0x300C,0x10,0x100,0,16,16,1,(void (*)())DSMADD);
 map_opcode_sign(0x7000,1,0x100,0,256,16,1,(void (*)())DSMADDI,0x80,0);
 map_opcode(0x300E,0x10,0x100,0,16,16,1,(void (*)())DSMADDC);
 map_opcode(0x300F,0x10,0x100,0,16,16,1,(void (*)())DSMADDV);
 map_opcode(0x2009,0x10,0x100,0,16,16,1,(void (*)())DSMAND);
 map_opcode(0xC900,1,0,0,256,1,1,(void (*)())DSMANDI);
 map_opcode(0xCD00,1,0,0,256,1,1,(void (*)())DSMANDM);
 map_opcode_sign(0x8B00,1,0,0,256,1,1,(void (*)())DSMBF,0x80,1);
 map_opcode_sign(0x8F00,1,0,0,256,1,1,(void (*)())DSMBFS,0x80,1);
 map_opcode_sign(0x8900,1,0,0,256,1,1,(void (*)())DSMBT,0x80,1);
 map_opcode_sign(0x8D00,1,0,0,256,1,1,(void (*)())DSMBTS,0x80,1);
 map_opcode_sign(0xA000,1,0,0,4096,1,1,(void (*)())DSMBRA,0x800,1);
 map_opcode(0x0023,0x100,0,0,16,1,1,(void (*)())DSMBRAF);
 map_opcode_sign(0xB000,1,0,0,4096,1,1,(void (*)())DSMBSR,0x800,1);
 map_opcode(0x0003,0x100,0,0,16,1,1,(void (*)())DSMBSRF);
 map_opcode(0x8800,0x1,0,0,256,1,1,(void (*)())DSMCMPIM);
 map_opcode(0x3000,0x10,0x100,0,16,16,1,(void (*)())DSMCMPEQ);
 map_opcode(0x3003,0x10,0x100,0,16,16,1,(void (*)())DSMCMPGE);
 map_opcode(0x3007,0x10,0x100,0,16,16,1,(void (*)())DSMCMPGT);
 map_opcode(0x3006,0x10,0x100,0,16,16,1,(void (*)())DSMCMPHI);
 map_opcode(0x3002,0x10,0x100,0,16,16,1,(void (*)())DSMCMPHS);
 map_opcode(0x4015,0x100,0,0,16,1,1,(void (*)())DSMCMPPL);
 map_opcode(0x4011,0x100,0,0,16,1,1,(void (*)())DSMCMPPZ);
 map_opcode(0x200C,0x10,0x100,0,16,16,1,(void (*)())DSMCMPSTR);
 map_opcode(0x3004,0x10,0x100,0,16,16,1,(void (*)())DSMDIV1);
 map_opcode(0x2007,0x10,0x100,0,16,16,1,(void (*)())DSMDIV0S);
 map_opcode(0x300D,0x10,0x100,0,16,16,1,(void (*)())DSMDMULS);
 map_opcode(0x3005,0x10,0x100,0,16,16,1,(void (*)())DSMDMULU);
 map_opcode(0x4010,0x100,0,0,16,1,1,(void (*)())DSMDT);
 map_opcode(0x600E,0x10,0x100,0,16,16,1,(void (*)())DSMEXTSB);
 map_opcode(0x600F,0x10,0x100,0,16,16,1,(void (*)())DSMEXTSW);
 map_opcode(0x600C,0x10,0x100,0,16,16,1,(void (*)())DSMEXTUB);
 map_opcode(0x600D,0x10,0x100,0,16,16,1,(void (*)())DSMEXTUW);
 map_opcode(0x402B,0x100,0,0,16,1,1,(void (*)())DSMJMP);
 map_opcode(0x400B,0x100,0,0,16,1,1,(void (*)())DSMJSR);
 map_opcode(0x400E,0x100,0,0,16,1,1,(void (*)())DSMLDCSR);
 map_opcode(0x401E,0x100,0,0,16,1,1,(void (*)())DSMLDCGBR);
 map_opcode(0x402E,0x100,0,0,16,1,1,(void (*)())DSMLDCVBR);
 map_opcode(0x403E,0x100,0,0,16,1,1,(void (*)())DSMLDCSSR);
 map_opcode(0x404E,0x100,0,0,16,1,1,(void (*)())DSMLDCSPC);
 map_opcode(0x40FA,0x100,0,0,16,1,1,(void (*)())DSMLDCDBR);
 map_opcode(0x408E,0x100,0x10,0,16,8,1,(void (*)())DSMLDCRn_BANK);
 map_opcode(0x4007,0x100,0,0,16,1,1,(void (*)())DSMLDCMSR);
 map_opcode(0x4017,0x100,0,0,16,1,1,(void (*)())DSMLDCMGBR);
 map_opcode(0x4027,0x100,0,0,16,1,1,(void (*)())DSMLDCMVBR);
 map_opcode(0x4037,0x100,0,0,16,1,1,(void (*)())DSMLDCMSSR);
 map_opcode(0x4047,0x100,0,0,16,1,1,(void (*)())DSMLDCMSPC);
 map_opcode(0x40F6,0x100,0,0,16,1,1,(void (*)())DSMLDCMDBR);
 map_opcode(0x4087,0x100,0x10,0,16,8,1,(void (*)())DSMLDCMRn_BANK);
 map_opcode(0x405A,0x100,0,0,16,1,1,(void (*)())DSMLDSFPUL);
 map_opcode(0x4056,0x100,0,0,16,1,1,(void (*)())DSMLDSMFPUL);
 map_opcode(0x406A,0x100,0,0,16,1,1,(void (*)())DSMLDSFPSCR);
 map_opcode(0x4066,0x100,0,0,16,1,1,(void (*)())DSMLDSMFPSCR);
 map_opcode(0x400A,0x100,0,0,16,1,1,(void (*)())DSMLDSMACH);
 map_opcode(0x401A,0x100,0,0,16,1,1,(void (*)())DSMLDSMACL);
 map_opcode(0x402A,0x100,0,0,16,1,1,(void (*)())DSMLDSPR);
 map_opcode(0x4006,0x100,0,0,16,1,1,(void (*)())DSMLDSMMACH);
 map_opcode(0x4016,0x100,0,0,16,1,1,(void (*)())DSMLDSMMACL);
 map_opcode(0x4026,0x100,0,0,16,1,1,(void (*)())DSMLDSMPR);
 map_opcode(0x000F,0x10,0x100,0,16,16,1,(void (*)())DSMMAC_L);
 map_opcode(0x400F,0x10,0x100,0,16,16,1,(void (*)())DSMMACW);
 map_opcode(0xE000,1,0x100,0,256,16,1,(void (*)())DSMMOVI);
 map_opcode(0x9000,1,0x100,0,256,16,1,(void (*)())DSMMOVWI);
 map_opcode(0xD000,1,0x100,0,256,16,1,(void (*)())DSMMOVLI);
 map_opcode(0x6003,0x10,0x100,0,16,16,1,(void (*)())DSMMOV);
 map_opcode(0x2000,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBS);
 map_opcode(0x2001,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWS);
 map_opcode(0x2002,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLS);
 map_opcode(0x6000,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBL);
 map_opcode(0x6001,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWL);
 map_opcode(0x6002,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLL);
 map_opcode(0x2004,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBM);
 map_opcode(0x2005,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWM);
 map_opcode(0x2006,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLM);
 map_opcode(0x6004,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBP);
 map_opcode(0x6005,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWP);
 map_opcode(0x6006,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLP);
 map_opcode(0x8000,1,0x10,0,16,16,1,(void (*)())DSMMOVBS4);
 map_opcode(0x8100,1,0x10,0,16,16,1,(void (*)())DSMMOVWS4);
 map_opcode(0x1000,0x10,1,0x100,16,16,16,(void (*)())DSMMOVLS4);
 map_opcode(0x8400,0x10,1,0,16,16,1,(void (*)())DSMMOVBL4);
 map_opcode(0x8500,0x10,1,0,16,16,1,(void (*)())DSMMOVWL4);
 map_opcode(0x5000,0x10,1,0x100,16,16,16,(void (*)())DSMMOVLL4);
 map_opcode(0x0004,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBS0);
 map_opcode(0x0005,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWS0);
 map_opcode(0x0006,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLS0);
 map_opcode(0x000C,0x10,0x100,0,16,16,1,(void (*)())DSMMOVBL0);
 map_opcode(0x000D,0x10,0x100,0,16,16,1,(void (*)())DSMMOVWL0);
 map_opcode(0x000E,0x10,0x100,0,16,16,1,(void (*)())DSMMOVLL0);
 map_opcode(0xC000,1,0,0,256,1,1,(void (*)())DSMMOVBSG);
 map_opcode(0xC100,1,0,0,256,1,1,(void (*)())DSMMOVWSG);
 map_opcode(0xC200,1,0,0,256,1,1,(void (*)())DSMMOVLSG);
 map_opcode(0xC400,1,0,0,256,1,1,(void (*)())DSMMOVBLG);
 map_opcode(0xC500,1,0,0,256,1,1,(void (*)())DSMMOVWLG);
 map_opcode(0xC600,1,0,0,256,1,1,(void (*)())DSMMOVLLG);
 map_opcode(0xC700,1,0,0,256,1,1,(void (*)())DSMMOVA);
 map_opcode(0x0029,0x100,0,0,16,1,1,(void (*)())DSMMOVT);
 map_opcode(0x00C3,0x100,0,0,16,1,1,(void (*)())DSMMOVCAL);
 map_opcode(0x0007,0x10,0x100,0,16,16,1,(void (*)())DSMMULL);
 map_opcode(0x200F,0x10,0x100,0,16,16,1,(void (*)())DSMMULS);
 map_opcode(0x200E,0x10,0x100,0,16,16,1,(void (*)())DSMMULU);
 map_opcode(0x0093,0x100,0,0,16,1,1,(void (*)())DSMOCBI);
 map_opcode(0x00A3,0x100,0,0,16,1,1,(void (*)())DSMOCBP);
 map_opcode(0x00B3,0x100,0,0,16,1,1,(void (*)())DSMOCBWB);
 map_opcode(0x0083,0x100,0,0,16,1,1,(void (*)())DSMPREF);
 map_opcode(0x600B,0x10,0x100,0,16,16,1,(void (*)())DSMNEG);
 map_opcode(0x600A,0x10,0x100,0,16,16,1,(void (*)())DSMNEGC);
 map_opcode(0x200B,0x10,0x100,0,16,16,1,(void (*)())DSMOR);
 map_opcode(0xCB00,0x1,0,0,256,1,1,(void (*)())DSMORI);
 map_opcode(0xCF00,0x1,0,0,256,1,1,(void (*)())DSMORM);
 map_opcode(0x4004,0x100,0,0,16,1,1,(void (*)())DSMROTL);
 map_opcode(0x4005,0x100,0,0,16,1,1,(void (*)())DSMROTR);
 map_opcode(0x4024,0x100,0,0,16,1,1,(void (*)())DSMROTCL);
 map_opcode(0x4025,0x100,0,0,16,1,1,(void (*)())DSMROTCR);
 map_opcode(0x400C,0x10,0x100,0,16,16,1,(void (*)())DSMSHAD);
 map_opcode(0x400D,0x10,0x100,0,16,16,1,(void (*)())DSMSHLD);
 map_opcode(0x4020,0x100,0,0,16,1,1,(void (*)())DSMSHAL);
 map_opcode(0x4021,0x100,0,0,16,1,1,(void (*)())DSMSHAR);
 map_opcode(0x4000,0x100,0,0,16,1,1,(void (*)())DSMSHLL);
 map_opcode(0x4001,0x100,0,0,16,1,1,(void (*)())DSMSHLR);
 map_opcode(0x4008,0x100,0,0,16,1,1,(void (*)())DSMSHLL2);
 map_opcode(0x4009,0x100,0,0,16,1,1,(void (*)())DSMSHLR2);
 map_opcode(0x4018,0x100,0,0,16,1,1,(void (*)())DSMSHLL8);
 map_opcode(0x4019,0x100,0,0,16,1,1,(void (*)())DSMSHLR8);
 map_opcode(0x4028,0x100,0,0,16,1,1,(void (*)())DSMSHLL16);
 map_opcode(0x4029,0x100,0,0,16,1,1,(void (*)())DSMSHLR16);
 map_opcode(0x0002,0x100,0,0,16,1,1,(void (*)())DSMSTCSR);
 map_opcode(0x0012,0x100,0,0,16,1,1,(void (*)())DSMSTCGBR);
 map_opcode(0x0022,0x100,0,0,16,1,1,(void (*)())DSMSTCVBR);
 map_opcode(0x0032,0x100,0,0,16,1,1,(void (*)())DSMSTCSSR);
 map_opcode(0x0042,0x100,0,0,16,1,1,(void (*)())DSMSTCSPC);
 map_opcode(0x003A,0x100,0,0,16,1,1,(void (*)())DSMSTCSGR);
 map_opcode(0x00FA,0x100,0,0,16,1,1,(void (*)())DSMSTCDBR);
 map_opcode(0x0082,0x100,0x10,0,16,8,1,(void (*)())DSMSTCRm_BANK);
 map_opcode(0x4003,0x100,0,0,16,1,1,(void (*)())DSMSTCMSR);
 map_opcode(0x4013,0x100,0,0,16,1,1,(void (*)())DSMSTCMGBR);
 map_opcode(0x4023,0x100,0,0,16,1,1,(void (*)())DSMSTCMVBR);
 map_opcode(0x4033,0x100,0,0,16,1,1,(void (*)())DSMSTCMSSR);
 map_opcode(0x4043,0x100,0,0,16,1,1,(void (*)())DSMSTCMSPC);
 map_opcode(0x4032,0x100,0,0,16,1,1,(void (*)())DSMSTCMSGR);
 map_opcode(0x40F2,0x100,0,0,16,1,1,(void (*)())DSMSTCMDBR);
 map_opcode(0x4083,0x100,0x10,0,16,8,1,(void (*)())DSMSTCMRm_BANK);
 map_opcode(0x006A,0x100,0,0,16,1,1,(void (*)())DSMSTS_FPSCR);
 map_opcode(0x4062,0x100,0,0,16,1,1,(void (*)())DSMSTS_RESTORE);
 map_opcode(0x005A,0x100,0,0,16,1,1,(void (*)())DSMSTS);
 map_opcode(0x4052,0x100,0,0,16,1,1,(void (*)())DSMSTS_SAVE);
 map_opcode(0x000A,0x100,0,0,16,1,1,(void (*)())DSMSTSMACH);
 map_opcode(0x001A,0x100,0,0,16,1,1,(void (*)())DSMSTSMACL);
 map_opcode(0x002A,0x100,0,0,16,1,1,(void (*)())DSMSTSPR);
 map_opcode(0x4002,0x100,0,0,16,1,1,(void (*)())DSMSTSMMACH);
 map_opcode(0x4012,0x100,0,0,16,1,1,(void (*)())DSMSTSMMACL);
 map_opcode(0x4022,0x100,0,0,16,1,1,(void (*)())DSMSTSMPR);
 map_opcode(0x3008,0x10,0x100,0,16,16,1,(void (*)())DSMSUB);
 map_opcode(0x300A,0x10,0x100,0,16,16,1,(void (*)())DSMSUBC);
 map_opcode(0x300B,0x10,0x100,0,16,16,1,(void (*)())DSMSUBV);
 map_opcode(0x6008,0x10,0x100,0,16,16,1,(void (*)())DSMSWAPB);
 map_opcode(0x6009,0x10,0x100,0,16,16,1,(void (*)())DSMSWAPW);
 map_opcode(0xC300,0x1,0,0,256,1,1,(void (*)())DSMTRAPA);
 map_opcode(0x40D1,0x100,0,0,16,1,1,(void (*)())DSMTAS);
 map_opcode(0x2008,0x10,0x100,0,16,16,1,(void (*)())DSMTST);
 map_opcode(0xC800,0x1,0,0,256,1,1,(void (*)())DSMTSTI);
 map_opcode(0xCC00,0x1,0,0,256,1,1,(void (*)())DSMTSTM);
 map_opcode(0x200A,0x10,0x100,0,16,16,1,(void (*)())DSMXOR);
 map_opcode(0xCA00,0x1,0,0,256,1,1,(void (*)())DSMXOR);
 map_opcode(0xCE00,0x1,0,0,256,1,1,(void (*)())DSMXOR);
 map_opcode(0x200D,0x10,0x100,0,16,16,1,(void (*)())DSMXTRCT);
//page 31 -> SR
//33 -> FPSCR
//certains opcodes de FPU dependent de FPSCR_ PR et SZ
//attention PR et SZ ne doivent etre a 1 en meme temps (page 33)
 map_opcode(0xF00C,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV);
 map_opcode(0xF008,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_LOAD);
 map_opcode(0xF006,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_INDEX_LOAD);
 map_opcode(0xF009,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_RESTORE);
 map_opcode(0xF00A,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_STORE);
 map_opcode(0xF00B,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_SAVE);
 map_opcode(0xF007,0x10,0x100,0,16,16,1,(void (*)())DSMFMOV_INDEX_STORE);
 map_opcode(0xF01D,0x100,0,0,16,1,1,(void (*)())DSMFLDS);
 map_opcode(0xF00D,0x100,0,0,16,1,1,(void (*)())DSMFSTS);
 map_opcode(0xF05D,0x100,0,0,16,1,1,(void (*)())DSMFABS);
 map_opcode(0xF004,0x10,0x100,0,16,16,1,(void (*)())DSMFCMP_EQ);
 map_opcode(0xF005,0x10,0x100,0,16,16,1,(void (*)())DSMFCMP_GT);

 map_opcode(0xF000,0x10,0x100,0,16,16,1,(void (*)())DSMFLADD);
 map_opcode(0xF08D,0x100,0,0,16,1,1,(void (*)())DSMFLDI0);
 map_opcode(0xF09D,0x100,0,0,16,1,1,(void (*)())DSMFLDI1);
 map_opcode(0xF001,0x10,0x100,0,16,16,1,(void (*)())DSMFLSUB);
 map_opcode(0xF00E,0x10,0x100,0,16,16,1,(void (*)())DSMFMAC);
 map_opcode(0xF002,0x10,0x100,0,16,16,1,(void (*)())DSMFMUL);
 map_opcode(0xF0ED,0x100,0x400,0,4,4,1,(void (*)())DSMFIPR);
 map_opcode(0xF04D,0x100,0,0,16,1,1,(void (*)())DSMFNEG);
 map_opcode(0xF06D,0x100,0,0,16,1,1,(void (*)())DSMFSQRT);
 map_opcode(0xF1FD,0x400,0,0,4,1,1,(void (*)())DSMFTRV);

 map_opcode(0xF02D,0x100,0,0,16,1,1,(void (*)())DSMFLOAT);
 map_opcode(0xF03D,0x100,0,0,16,1,1,(void (*)())DSMFTRC);
 /* bug ? */
 //map_opcode(0xF0BD,0x100,0,0,16,1,1,(void (*)())DSMFCNVDS);
 //map_opcode(0xF0AD,0x100,0,0,16,1,1,(void (*)())DSMFCNVSD);
 //map_opcode(0xF003,0x10,0x100,0,16,16,1,(void (*)())DSMFDIV);

 tab_op[0x28].fonc=DSMCLRMAC;
 tab_op[0x48].fonc=DSMCLRS;
 tab_op[0x8].fonc=DSMCLRT;
 tab_op[0x19].fonc=DSMDIV0U;
 tab_op[0xB].fonc=DSMRTS;
 tab_op[0x38].fonc=DSMLDTLB;
 tab_op[0x9].fonc=DSMNOP;
 tab_op[0x2B].fonc=DSMRTE;
 tab_op[0x58].fonc=DSMSETS;
 tab_op[0x18].fonc=DSMSETT;
 tab_op[0x1B].fonc=DSMSLEEP;
 tab_op[0x8B8D].fonc=DSMFRCHG;
 tab_op[0x838D].fonc=DSMFSCHG;
}


