/************
Virtu@L Dream, DreamCast emulator for PC
Copyright (C) 2003 eBrain  H.H.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************/

#include "StdAfx.h"
#include "extern.h"
/*
long = 32 bits
0x01000000: TA access base
0xa4000000: graphics memory base (64bit interface)
0xa5000000: graphics memory base (32bit interface)
0xa0702c00: cable
0xff80002c
0xff800030: VGA, SCART...

System ASIC (interrupt control)
0xa05f6900: System ASIC - interrupt control stuff, for instance
0x0000: Pending interrupts 1
0x0008: Pending interrupts 2
0x0030: Enabled interrupts 1
0x0038: Enabled interrupts 2

VR2 Core
0xa05f8000: graphics registers base
*/

enum
{
//0x00: (PVR2 Core ID)
COREID,
//0x01:(PVR2 Core version)
CORETYPE,
//0x02:    (PVR2) (Enable/disable the submodules of the PVR2 Core)
COREDISABLE,
//0x03-0x04:
Unknown3,
//0x05:(3D) (Start render strobe)
RENDERSTART,
//0x06-0x07:
Unknown6,
//0x08:(3D) (Primitive allocation base)
PRIMALLOCBASE,
//0x10:(2D) (Border colour)
BORDERCOLOR,
//0x11: (ap display settings)
BITMAPTYPE,
//0x12: (3D) (Render output format)
RENDERFORMAT,
//0x13:(3D) (Render target pitch)
RENDERPITCH,
//0x14: (2D) (Framebuffer address)
FRAMEBUF,
//0x15: (?D) (Framebuffer address, short field)
FRA,
//0x16:
Unknown16,
//0x17:(2D) (Display window size)
DIWSIZE,
//0x18:(3D) (Render target base address)
RENDERBASE,
//0x19:
Unknown19,
//0x20:
Unknown20,
//0x21:(3D) (Something to do with rendering)
UNNAMED21,
//0x22:
Unknown22,
//0x23:(3D) (Background plane location)
BGPLANE,
//0x24-0x27:
Unknown24,
//0x28:
UNNAMED28,
//0x29:
Unknown29,
//0x30:(3D) (Minimum ARGB in render pipeline before fogging)
COLORCLAMPMIN,
//0x31-0x32:
Unknown31,
//0x33:(2D) (Scanline interrupt positions)
SCANINTPOS,
//0x34:(2D) (image control stuff)
IMAGECONTROL,
//0x35:(2D) (Border-colour rectangle X-start and X-stop)
BORDERWINDOWX,
//0x36:(2D) (Total number of frame cycles)
FRAMETOTAL,
//0x37:(2D) (Border-colour rectangle Y-start and Y-stop)
BORDERWINDOWY,
//0x38:(2D?)
UNNAMED38,
//0x39:(3D) (Width of rectangular texture)
TEXTURESTRIDE,
//0x3e-0x41:
Unknown3e,
//0x42:(3D) (Texture palette mode) ???
TEXTUREPALETTEMODE,
//0x43:(2D) (Current raster beam position)
BEAMPOS,
//0x44:(PVR) (Graphics memory control)
UNNAMED,
//0x45:
Unknown45,
//0x46: (3D) (Something render related)
UNNAMED46,
//0x47-0x48:
unknown47,
//0x49:(TA) (Root PP-block matrices base address)
PPMATRIXBASE,
//0x50:(TA) (PP-block sizes)
PPBLOCKSIZE,
//0x51:(TA) (Start vertex enqueueing strobe)
TASTART,
//0x52-0x58:
Unknown,
//0x59:(TA) (PP-block allocation area end)
PPALLOCEND,
//0x5a-0x7f:
Unknown5a,
//0x80 .. 0xff: (3D) Fog table
FogTab,
//0x400 .. 0x800: (3D) Texture palette data
TexPalDat,
};


#define DC_COREID 0x17fd11db
#define DC_CORETYPE 0x00000011

#ifdef SH4DSM
int wrpvrcnt=0;
void makepvrinfo(unsigned long Addr, LONG Data)
{
 char pvrinf[64];
 sprintf(pvrinf,"%d %x->%x\n",wrpvrcnt,Addr,Data);
 wrpvrcnt++;
 gtk_text_insert(GTK_TEXT(pvrtext),NULL,&pvrtext->style->black,NULL,pvrinf,-1);
 gtk_text_thaw(GTK_TEXT(pvrtext));
}
#endif

